c
code for calst
      subroutine calst
c--dummy routine to identify the module
      return
      end
c
code for slist
      subroutine slist
c--input list 1 2 3   6 18
c
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
c
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(temp,itemp)
c--
c--read down the lists
      call xfl01
      call xfl02
      call xlat(temp)
      m2=l2+(n2-1)*md2
      call xfl03
      call xfl06
      call sfl18
      return
      end
c
code for srdl
      subroutine srdl
c--read down the list 1 2 5
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,icc,ia,ih,numb(10),iplus, inus,ipoint,namh
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
     
      common/xdata/store(1000000)
      dimension istore(1000000)
      equivalence (store,istore)
      dimension hl(12)
c--
      call xfl01
      call xfl02
      l2p=nfl
      call xlat(hl)
      nfl=nfl+n2p*md2p
      l=n2p*md2p
      m2p=l2p
      do i=1,l
      store(m2p)=hl(i)
      m2p=m2p+1
      enddo
      call xfl05
      jp=ipoint
      jh=namh
      return
      end
c
code for xfl01
      subroutine xfl01
c--form absolute list 1 in store
c
c--the locations in store are controlled by the following variables
c
c  l1p1  location real cell parameters
c  l1p2  location of the reciprocal parameters
c  l1m1  location of the real metric tensor
c  l1m2  location of the reciprocal metric tensor
c  l1o1  location of the real orthogonalization matrix
c  l1o2  location of the reciprocal orthogonalization matrix
c  l1c   location of the coefficients needed to convert the
c        isotropic temperature factor to the aniso off diagonal
c        terms  (=cos(a*))
c  l1s   terms of the r(ij)=s
c  l1a   coefficients needed for the aniso temperature factor
c
c--
c23456789012345678901234567890123456789012345678901234567890123456789012
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/xcons/ pi,twopis,twopi,rtd,dtr,xnx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call srlin(1,ly,li,lj,lk,ll)
      call sldl(1,ly,li,lz)
      lii=li
      l1p1=li+5
      l1p2=l1p1+7
      l1m1=l1p2+7
      l1m2=l1m1+9
      l1o1=l1m2+9
      l1o2=l1o1+9
      l1p1d=l1o2+9
      l1p2d=l1p1d+7
      if(ll.eq.55) l1p1d=0
      l1a =lz+1
      l1c =l1a+6
      l1s =l1c+3
      nfl=l1s+6
      ljj=nfl-1
c--set up the necessary coefficients
      j=l1c
      k=l1p2+3
      l=l1s
      m=l1m2
      n=l1a
      i1=3
      do 1000 i=1,3
      store(j)=cos(store(k))
      store(l)=0.25*store(m)
      store(n)=-twopis*store(m)
      j=j+1
      k=k+1
      l=l+i1
      i1=i1-1
      m=m+4
      n=n+1
1000  continue
c--set up the off diagonal terms
      store(l1s+1)=0.5*store(l1m2+1)
      store(l1s+2)=0.5*store(l1m2+2)
      store(l1s+4)=0.5*store(l1m2+5)
      store(n  )=-2.*twopis*store(l1p2+1)*store(l1p2+2)
      store(n+1)=-2.*twopis*store(l1p2  )*store(l1p2+2)
      store(n+2)=-2.*twopis*store(l1p2  )*store(l1p2+1)
      call xsac(  1,ly,lii,ljj)
c      write(ncwu,*)store(l1s),store(l1s+1),store(l1s+2),
c     2 store(l1s+3),store(l1s+4),store(l1s+5)
      m=l1m1
      l=l1m2
      do i=1,9
      gg(i)=store(m)
      gr(i)=store(l)
      l=l+1
      m=m+1
      enddo
      return
      end
c
code for sntl2
      function sntl2(in)
c--calculate (sin(theta)/lambda)**2
c  (sin(theta)/lambda)**2 = (1/d**2) * (1/4)
c  d = distanza reale
c  resolution = 1.0 / [2.0 * sqrt(sntl2(in))]
c
c  m6   location of the reflection
c  l1s  location of the r(i,j) terms
c
c--
      include 'li6com.inc'
c--
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--     
      in1=in
      sntl2=store(m6  )*store(m6  )*store(l1s  )
     2     +store(m6  )*store(m6+1)*store(l1s+1)
     3     +store(m6  )*store(m6+2)*store(l1s+2)
     4     +store(m6+1)*store(m6+1)*store(l1s+3)
     5     +store(m6+1)*store(m6+2)*store(l1s+4)
     6     +store(m6+2)*store(m6+2)*store(l1s+5)
      return
      end
c
code for xfl02
      subroutine xfl02
c--form absolute list 2 in store
c
c  the variables are used as follows :
c
c  ic     centro (1) or non-centro (0)
c  il     lattice type (1-7)
c  g2     scale constants to convert the /fc/'s onto the absolute scale
c  isys   crystal family
c  ngen   number of generator
c  l2     location of the first word of the first symmetry matrix
c  md2    number of words per matrix  (=12)
c  n2     number of matrices
c  l2s    location of the first word of the space group symbol
c  l2i    location of the first word of the correlation matrix
c         (ngoxngo where ngo=n2x(ic+1) )
c  l2t    location of the temporary storage
c  md2t   number of words per temporary location  (=10)
c  n2t    number of temporary locations (=n2)
c  n2p    the number of speararte shift vectors needed to describe
c         this lattice
c  md2p   number of words per shift vectors
c
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,nori
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      call sldl(2,ly,li,lz)
      l2=     store(li+10) +li
      n2=     store(li+7)
      md2=12
      isys=    store(li+8)
      nori=    store(li+9)
      ngen=    store(li+11)
      m2s=     store(li+12)+li
      l2s=m2s
      call hocase(istore,l2s,16)
      l2a=l2s+16
      l2b=l2a+10
      l2c=l2b+8
      l2d=l2c+3
      l2j=l2d+3
      l2i=l2j+n2
      n2t=n2
      md2t=10
      l2t=lz+1
      nfl=l2t+n2t*md2t
      ljj=nfl-1
      ic=     store(li+6) -1
      il=     store(li+5)
      g2=store(li+5)
      if(g2-4.5)1030,1030,1020
1020  continue
      g2=2.
1030  continue
      if(g2-0.1)1040,1050,1050
1040  continue
      g2=1.
1050  continue
      g2=g2*store(li+6)
      call xsac(2,ly,li,ljj)
      return
      end
c
code for xlat
      subroutine xlat(hl)
c--set up in hl the unit cell shifts for the non-primitive lattice
c
c  hl  the array in which the operators are set up
c
c--this subroutine also sets some variables as well as 'hl'
c
c  n2p  the number of speararte shift vectors needed to describe
c       this lattice
c  md2p number of words per shift vectors
c
c--
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      dimension hl(12)
c
      md2p=3
      n2p=il
      if(il-4)1410,1410,1400
1400  continue
      n2p=2
1410  continue
      do 1520 i=1,3
      hl(i)=0.
1520  continue
      go to (1700,1600,1630,1650,1600,1600,1600),il
c--'i' , 'a' , 'b' or 'c' centred lattice
1600  continue
      do 1610 i=4,6
      hl(i)=0.5
1610  continue
      if(il-4) 1700,1700,1620
1620  continue
      hl(il-1)=0.
      go to 1700
c--'r' centred lattice
1630  continue
      do 1640 i=5,6
      hl(i  )=0.66666667
      hl(i+3)=0.33333333
1640  continue
      hl(4)=hl(8)
      hl(7)=hl(5)
      go to 1700
c--'f' centred lattice
1650  continue
      k=4
      do 1670 i=4,12,4
      do 1660 j=1,3
      hl(k)=0.5
      k=k+1
1660  continue
      hl(i)=0.
1670  continue
1700  continue
      return
      end
c
code for xfl03
      subroutine xfl03
c--form absolute list 3
c
c  l3  location of the information for the first form factor
c  n3  number of form factors
c  l3t location at which to store the calculated real form factors
c l3ti location at which to store the anomalous dispersion
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      sys03=1.0
      call sldl(3,ly,l3g,lz)
      n3=     store(l3g+5)
      l3=     store(l3g+6) +l3g
      md3=    store(l3g+7)
c--temporary routine to update upper case
      m3=l3
      do 1000 i=1,n3
      call hocase(istore,m3,1)
      m3=m3+md3
1000  continue
c--end of temporary routine
      l3t=lz+1
      l3ti=l3t+n3
      nfl=l3ti+n3
      l=nfl-1
      call xsac(3,ly,li,l)
      n3g=lz-l3g+1
      return
      end
c
code for scatt
      subroutine scatt(st)
c--calculate and store the scattering factors for the atoms in list 3
c
c  st  the value of sin(theta)/lambda for the calculation
c
c--list 3 is assumed to have been loaded and the results appear at
c  'l3t' for the real components
c  'l3ti' for the anomalous dispersion
c
c--
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      sst=st*st
      m3=l3
      do 1000 jz=1,n3
      m3t=l3t+jz-1
      store(m3t)=store(m3+1)+store(m3+2)+
     2           store(m3+3)*exp(-store(m3+4)*sst)+
     3           store(m3+5)*exp(-store(m3+6)*sst)+
     4           store(m3+7)*exp(-store(m3+8)*sst)+
     5           store(m3+9)*exp(-store(m3+10)*sst)
      m3ti=l3ti+jz-1
      store(m3ti)=store(m3+11)
      m3=m3+md3
1000  continue
      return
      end
c
code for sigma
      function sigma(c1,s)
c--calculate the sigma value
c
      implicit integer*4 (l,m)
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      sig2=0.0
      call scatt(s)
      m3=l3
      do 1119 k=1,n3
      l=l3t+k-1
      sig2=sig2+store(m3+12)*store(l)**c1
      m3=m3+md3
 1119 continue
      xn2=float(n2p)
      sigma=sig2/xn2
      return
      end
c                                                                       
code for scfou
      subroutine scfou(b)
c--calculate scattering form for fourier routine
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c--
      common /form/ gis(142),giw(142)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      xn2=float(n2p)
      do 1000 i=1,142
      giw(i)=0.0
1000  continue
      do 2020 i=1,142
      s=0.01*float(i-1)
      sst=s*s
      m3=l3
      do 2010 k=1,n3
      m3t=l3t+k-1
      store(m3t)=store(m3+1)+store(m3+2)+
     2           store(m3+3)*exp(-store(m3+4)*sst)+
     3           store(m3+5)*exp(-store(m3+6)*sst)+
     4           store(m3+7)*exp(-store(m3+8)*sst)+
     5           store(m3+9)*exp(-store(m3+10)*sst)
      giw(i)=giw(i)+store(m3+12)*store(m3t)*store(m3t)/xn2
      m3=m3+md3
2010  continue
      gis(i)=sqrt(giw(i))
      giw(i)=giw(i)*exp(-2.0*b*sst)
2020  continue
      if(istat2.eq.0) return
      write(ncwu,2030) (gis(i),i=1,141,2)
2030  format(//,' sigma  form factors (0.02 step',
     1 ' in sin(th)/lamda **2)',//,(1h ,17f7.2))
      write(ncwu,2040) (giw(i),i=1,141,2)
2040  format(//,' sigma form factors **2 exp(-2b*s**) (o.o2 step',
     1 ' in sin(th)/lambda **2)',//,(1h ,17f7.2))
      return
      end
c
code for sifou
      function sifou(s)
c--calculate the sigma value for fourier routine
c--
      common /form/ gis(142),giw(142)
c--
      z=100.0*s
      ind=max0(2,int(z+1.5))
      u=z-float(ind-1)
      p=0.5*(giw(ind+1)-giw(ind-1))
      q=p+giw(ind-1)-giw(ind)
      sifou=q*u*u+p*u+giw(ind)
      return
      end                                                               
c
code for kst53
      function kst53(in)
c--set up the form factor types in list 5
c
c  in  = 0  ok
c	-1  form factor not in list 3
c
c--on return 'kst53' is set to the maximum form factor type
c  referenced minus one
c
c--lists 5 and 3 are assumed to have been loaded
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst13/l13,m13,md13,n13,l13g,n13g,sys13
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--                           
      in=0
      kst53=-1
      n=-1
      m5=l5
      do l=1,n5+n5g
	ngr=store(m5+28)
	if(ngr.eq.0) then
	  m3=l3
	  j=0
	  do i=1,n3
c	   write(ncwu,'(2h [,a4,1h-,a4,1h])') istore(m3),istore(m5)
	   if(istore(m3)-istore(m5)) 2550,2570,2550
2550	   continue
	   m3=m3+md3
	   j=j+1
	  enddo
	  write(ncwu,2565) istore(m5),l
2565	  format(/,' Warning! form factor [',a4,'] for the atom #',
     1		  i5,' not in list 3')
	  in=-1
	  store(m5+26)=in
c      return
	  goto 2575
2570	  continue
	  store(m5+26)=j
	  n=max0(n,j)
2575	  continue
	else
	  m13=l13
	  j=0
	  do i=1,n13
c	   write(ncwu,'(2h [,a4,1h-,a4,1h])') istore(m13),istore(m5)
	   if(istore(m13)-istore(m5)) 2650,2670,2650
2650	   continue
	   m13=m13+istore(m13+1)*md13+2
	   j=j+1
	  enddo
	  write(ncwu,2665) istore(m5),l
2665	  format(/,' Warning! group [',a4,'] for the #',
     1		  i5,' not in list 13')
	  in=-1
	  store(m5+26)=in
c      return
	  goto 2675
2670	  continue
	  store(m5+26)=j
2675	  continue
	endif
	m5=m5+md5
      enddo
      kst53=n
      return
      end
c
code for kst353
      function kst353(in)
c--set up the form factor types in list 35
c
c  in  dummy argument
c
c--on return 'kst353' is set to the maximum form factor type
c  referenced minus one
c
c--lists 35 and 3 are assumed to have been loaded
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--                            
      inn=in
      kst353=-1
      n=-1
      m35=l35
      do 2600 l=1,n35
      m35i=m35
      m3=l3
      j=0
      do 2560 i=1,n3
      m3i=m3
      if(istore(m3i)-istore(m35i)) 2550,2570,2550
2550  continue
      m3=m3+md3
      j=j+1
2560  continue
      write(ncwu,2565)
2565  format(/,26h form factor not in list 3)
      call zerr
      stop
2570  continue
      store(m35+26)=j
      n=max0(n,j)
      m35=m35+md35
2600  continue
      kst353=n
      return
      end
c
code for xfl04
      subroutine xfl04
c--form absolute list 4 in store
c
c--variables used:
c
c     iw4 weighting scheme type
c     n4  number of parameters for this scheme
c     l4  location of the first parameter
c
c--
      common/lst04/iw4,l4,m4,n4
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call sldl(4,ly,li,lz)
      iw4=     store(li+5)
      n4 =     store(li+6)
      l4 =li+7
      if(iw4.eq.2) then
       if(n4.eq.2) then
	nfl=nfl+1
	n4=n4+1
	store(l4+2)=store(l4+1)
	store(l4+1)=1.0
       endif
      endif
      if(iw4.ne.16) then
      if(store(l4+n4).le.0.0)store(l4+n4)=1.0
      else
      if(store(l4+11).le.0.0)store(l4+11)=1.0
      endif
      return
      end
c
code for sweig
      subroutine sweig(fo,fc,sigmaf,st,df,w,n4z)
c--calculate the wheight
c
c  fc	      on scale of fo
c  st	      the value of sin(theta)/lambda for the calculation
c  df	      the value of fo-fc
c
c  on return, 'w' is the calculated weight
c
c--list 4 and 6 are assumed to have been loaded
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst04/iw4,l4,m4,n4
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
c  jump on the type of weighting scheme
      go to (1000,1100,1200,1300,1400,1500,1600,
     2	     1700,1800,1900,1950,1970,2000,1100,2200,
     3	     2300,2400,2500,9000),iw4
9000  continue
      write(ncwu,9010) iw4
9010  format(/,i5,29h weighting scheme not allowed)
      call zerr
      stop  1111
c--weighting scheme type 1
1000  continue
      if(fo-store(l4)) 1010,1010,1020
1010  continue
      a=store(l4)/(fo*store(l4+1))
      go to 3000
1020  continue
      a=fo/(store(l4)*store(l4+1))
      goto 3000
c--weighting scheme type 2 & 14
1100  continue
      l=l4+1
      a=store(l4)
      do j=1,2
      a=a+store(l)*fo**j
      l=l+1
      enddo
      a=a/store(l4+n4)
      go to 3000
c--weighting scheme type 3
1200  continue
      a=1./(store(l4+1)*(st**store(l4)))
      go to 3000
c--weighting scheme type 4
1300  continue
      a=st**store(l4)/store(l4+1)
      go to 3000
c--weighting scheme type 5
1400  continue
      a=sigmaf*sigmaf/store(l4)
      go to 3000
c--weighting scheme type 6
1500  continue
      a=1.0/store(l4)
      goto 3000
c--weighting scheme type 7
1600  continue
      a=1.0+((fo-store(l4+1))/store(l4))**2
      a=a/store(l4+2)
      go to 3000
c--weighting scheme type 8
1700  continue
      a=1.0
      if(fo-store(l4)) 1720,1720,1710
1710  continue
      a=fo/store(l4)
1720  continue
      a=a/store(l4+1)
      go to 3000
c--weighting scheme type 9
1800  continue
      a=1.0/(sigmaf*store(l4))
      go to 3000
c--weighting scheme type 10
1900  continue
      a=sigmaf/store(l4)
      go to 3000
c--weighting scheme type 11
1950  continue
      a=store(l4)
      l=l4+1
      do 1952 j=1,2
      a=a+store(l)*fo**j
      l=l+1
1952  continue
      a=a/(store(l4+n4)*(st**store(l4+3)))
      goto 3000
c--weighting scheme type 12
1970  continue
      a=store(l4)*sigmaf*sigmaf
      l=l4+1
      p=(fo+2.0*fc)/3.0
      do 1972 j=1,2
      a=a+store(l)*p**j
      l=l+1
1972  continue
      a=a/store(l4+n4)
      go to 3000
c--weighting scheme type 13
2000  continue
      l=l4+1
      a=store(l4)
      do j=1,2
      a=a+store(l)*fo**j
      l=l+1
      enddo
      a=a+st*store(l4+3)
      a=a/store(l4+n4)
      goto 3000
c--weighting scheme type 15
2200  continue
      st1=1.0/st
      l=l4+1
      a=store(l4)
      do j=1,2
      a=a+store(l)*st1**j
      l=l+1
      enddo
      a=a/store(l4+n4)
      go to 3000
c--weighting scheme type 16
2300  continue
      l=l4+2
      a=store(l4)
      g=2.0*fo*store(l4+10) - 1
      b=1.
      c=g
      do j=3,n4
      d=2.0*g*c-b
      a=a+d*store(l)
      l=l+1
      b=c
      c=d
      enddo
      a=a+g*store(l4+1)
      a=a/store(l4+11)
      go to 3000
c--weighting scheme type 17
2400  continue
      a=store(l4)*sigmaf*sigmaf+store(l4+1)*fo*fo
      a=a/(store(l4+3)*(st**store(l4+2)))
      goto 3000
c--weighting scheme type 18
2500  continue
      l=l4+1
      a=store(l4)
      do j=1,2
      a=a+store(l)*fo**j
      l=l+1
      enddo
      a=a+store(l+3)*st**store(l+4)
      a=(a*sigmaf*sigmaf)/store(l4+n4)
      go to 3000
c--common section
3000  continue
      if(a.le.0.0)then
       if(a.lt.-0.01)then
        a=-a     
       else
        a=0.01
       endif
       n4z=n4z+1
      endif
      w=1.0/a
      w=sqrt(w)
      return
      end
c
code for chweig
      subroutine chweig(jproc,cod,rob,df,w,nchg,ies)
c--check the wheight
c
c  jproc  0   not modify the weight calculated
c	 -1   procedure 1 (like Prince & Nicholson)
c	  1   my procedure
c  cod	      n times limit to modify
c  rob	      average(sqrt(w)*df)
c  df	      the value of fo-fc
c
c  on return, 'w' is the calculated weight
c  ies	  0 no change
c	  1 w was changed
c
c--list 4 and 6 are assumed to have been loaded
c
c--
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      ies=0
      psi=1.0
c--modify the weight
      if(jproc.eq.1) then
c--my procedure
      a=1.0/w
      diff2=abs(df)
      if(diff2.lt.0.00001) diff2=0.00001
      diff3=diff2-a
      rr=abs(diff3/diff2)
      if(diff3.ge.0.) then
	if(rr.gt.cod) then
c	  write(ncwu,'(5f10.4)')rr,diff2,a,w,diff3
	  a=a+0.5*diff2
	  ies=1
	  nchg=nchg+1
	endif
      else
	if(rr.gt.cod) then
c	  write(ncwu,'(5f10.4)')rr,diff2,a,w,diff3
	  a=a-0.5*a
	  nchg=nchg+1
	  ies=1
	endif
      endif
      w=1.0/a
      else
c--Prince procedure
      aw=abs(df)*w
      if(aw.gt.cod*rob) then
       psi=0.
       nchg=nchg+1
       ies=1
       else
       psi=(1-(aw*aw/(cod*cod*rob*rob)))
      endif
      w=w*psi
      endif
c--end of modifying
      return
      end
c
code for xfl35
      subroutine  xfl35
c--form absolute list 35
c
c  l35   location of the first atom
c  md35  number of words per atom
c  n35   total number of atoms
c  l35o  location of first overall parameter
c  md35o number of words for each overall parameter
c  n35o  number of overall parameters
c  n35g  number of groups
c  l35d address of list 35
c  n35d  length of list 35
c
c--
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call sldl(35,li,lz,lj)
      l35o = store(lz+ 5)+lz
      md35o= store(lz+ 6)
      n35o = store(lz+ 7)
      l35  = store(lz+ 8)+lz
      md35 = store(lz+ 9)
      n35  = store(lz+10)
      md35h= store(lz+14)
      if(md35h.eq.0) md35h=22
      md35xyz= store(lz+15)
      if(md35xyz.eq.0) md35xyz=6
      md35c= store(lz+26)
      l35d=lz
      call srlin(35,lsn,li,lj,lk,ll)
      n35d=ll
      return
      end
c
code for xfrm35
      subroutine  xfrm35
c--store on disc the list 35
c
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      ll=nfl
      nfl=l35d
      call xfrml(35 ,n35d)
      call xdump
      nfl=ll
      return
      end
c
code for xfl05
      subroutine xfl05
c--form absolute list 5
c
c  l5   location of the first atom
c  md5  number of words per atom
c  n5   total number of atoms
c  l5o  location of first overall parameter
c  md5o number of words for each overall parameter
c  n5o  number of overall parameters
c  n5g  number of groups
c  l5d address of list 5
c  n5d  length of list 5
c  md5c number of words for connectivity
c  l5ori location of first value of orientation matrix (9 parameters)
c  md5h increment for label
c  md5xyz increment for coordinates
c
c--
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      common /temp/ iconn(9800)
c--common  sir
      common /piero/ BTot(3,3)
c--end of common sir
c--
      call sldl(5,li,lz,lj)
      l5o   = store(lz+ 5)+lz
      md5o  = store(lz+ 6)
      n5o   = store(lz+ 7)
      l5    = store(lz+ 8)+lz
      md5   = store(lz+ 9)
      n5    = store(lz+10)
      n5g   = store(lz+12)
      md5h  = store(lz+14)
      if(md5h.eq.0) md5h=22
      md5xyz= store(lz+15)
      if(md5xyz.eq.0) md5xyz=6
      md5c  = store(lz+26)
      l5ori = store(lz+25)+lz
      l5d=lz
      call srlin(5,lsn,li,lj,lk,ll)
      n5d=ll
c--restore common sir
      n=l5ori
      do i=1,3
       do j=1,3
	BTot(i,j)=store(n)
	n=n+1
       enddo
      enddo
c--write matrix
c	    write(*,*) ' mnqd: l5d,l5ori,n5d',l5d,l5ori,n5d
c	    do i=1,3
c	    write(*,*)'orient:',i, BTot(i,1),BTot(1,2),BTot(i,3)
c	    enddo
c--check the connectivity
      jconn=store(l5d+11)
      l5c=l5+(n5+n5g)*md5
      if (jconn.eq.1) then
	if (istore(l5c).gt.0) then
	 nco=istore(l5c)
	 nco2=nco*md5c
	 n5d=store(l5d+8)+(n5+n5g)*md5+nco2+1
       else
	jconn=0
	iconn(1)=-1
	store(l5d+11)=jconn
       end if
      else
	jconn=0
	iconn(1)=-1
	store(l5d+11)=jconn
	istore(l5c) = 0
      end if
c	write(ncwu,*)' xfl05: l5d,l5ori,n5d,md5h,md5xyz',
c     1	 l5d,l5ori,n5d,md5h,md5xyz,n5g
      return
      end
c
code for xfrm5
      subroutine  xfrm5
c--store on disc the list 5
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      ll=nfl
      nfl=l5d
      call xfrml(5 ,n5d)
      call xdump
      nfl=ll
      return
      end
c
code for xfrm0535
      subroutine  xfrm0535
c--store on disc the list 35 from 5
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call xfl05
      ll=nfl
      nfl=l5d
      iln=35
      store(nfl+1)=35.
      call xfrml(iln ,n5d)
      call xdump
      nfl=ll
      return
      end
c
code for xrst3505
      subroutine  xrst3505
c--store on disc the list 5 from 35
c
      common/lst35/l35,m35,md35,n35,l35o,m35o,md35o,n35o
     2 ,n35g,l35d,n35d,md35c,l35ori,md35h,md35xyz
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call xfl35
      ll=nfl
      nfl=l35d
      iln=5
      store(nfl+1)=5.
      call xfrml(iln ,n35d)
      call xdump
      nfl=ll
      return
      end
c
code for xfrm1236
      subroutine xfrm1236
c--form list 36 from list 12
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c--
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
      call sfl12
      nfl=l12d
      iln=36
      store(nfl+1)=36.0
      call xfrml(iln,n12d)
      call xdump
      return                                                            
      end
c
code for xfl36
      subroutine xfl36
c--load list 36
c                            
      common/lst36/l36,m36,md36,n36,jsca,jbm,nbl36,jdra,jdrb,l36d,n36d,
     2 jpol,jextin,n36c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c--
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
      call sldl(36,ly,li,lz)
      n36    =store(li+5)
      md36   =store(li+6)
      md36a  =store(li+7)
      jsca   =store(li+8)
      jbm    =store(li+9)
      nbl36  =store(li+10)
      jpol   =store(li+11)
      jextin =store(li+12)
      n36c   =store(li+13)
      l36=li+md36a
      l36d=li
      n36d=lz                                           
      return                                                            
      end                                                               
c
code for xrst3612
      subroutine xrst3612
c--reset list 12 from list 36 
c                                                              
      common/lst36/l36,m36,md36,n36,jsca,jbm,nbl36,jdra,jdrb,l36d,n36d,
     2 jpol,jextin,n36c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c--
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
      call xfl36
      nfl=l36d
      store(nfl+1)=12.0
      call xfrml(12,n36d)
      call xdump
      return
      end
c
code for jfnd5
      function jfnd5(iall,il50)
c--find the specified atom(s) in list 5
c
c  jfnd5  = 0 all right
c           1 atom(s) not found
c  iall   = 0 all the card has to be analized
c         = 1 return after the first current definition
c  il50   = 0 list50 has not been defined
c         = 1 list50 has been defined
c  jy     = 0 all the atoms
c         = 1 only same part of the atom(s)
c  jx     = -1 'until' is found
c         =  0 name of atom
c         =  1 the specie is given
c
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst13/l13,m13,md13,n13,l13g,n13g,sys13
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence (itemp,temp)
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20)
      common/worka/iname(7),idum(19)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      dimension iunt(3),name1(40),name2(40),idd(4)
      equivalence(idd,id)
      data iunt/4hfirs,4hlast,4hunti/
c--
c      write(ncwu,'(a,4a1)')'jfnd5:',id,ie,ib,icc
      jfnd5=0
      ifirst=0
900   continue
      jy=0
      jx=0
      n1x=8
      n2x=8
      do i=1,40
      name1(i)=ib(1)
      name2(i)=ib(1)
      enddo
      nc=keq(nc,ib,2)
      nca=nc
      if(nc) 1200,1200,1000
1000  continue
      nc=kne(nc,ib,2)
      if(nc) 1200,1200,1001
1001  continue
      jy=1
      if(jrcx(name1,n,idd,4)) 9000,1010,9000
1010  continue
      iname(1)=name1(1)
      n1x=n
c      write(ncwu,'(a,a4,i5,a1)')'jrcx=',iname(1),nc,image(nc)
      if(image(nc)-id) 1030,1020,1030
c--ha trovato una "("
1020  continue
      do i=2,7
      i1=i
      iname(i)=jredi(in)
c--ha trovato una ")"
      if(image(nc).eq.ie)go to 1025
      enddo
1025  continue
      nc=nc+1
c      write(ncwu,1)(iname(i),i=1,i1)
c1     format(1x,a4,7i6)
c     nc=nca
c     if(jrcx(name1,n1x,ie,1))9000,1040,9000
c     if(jrca(name1,n1x)) 9000,1040,9000
c--ricostruisce il nome dell'atomo  specie(number)
      jb=1
      call sa21(jb,iname(1),itemp)
      call sned(jb,iname(2),itemp)
      jb=jb-1
      call scomp(itemp,name1,jb)
      n1x=jb
c      write(ncwu,2)(name1(i),i=1,n1x)
c2     format(1x,4a4)
      go to 1040
c--controlla se first,last,until
 1030 continue
      in=kcomp(1,name1,iunt,3,1)
      if(in) 1019,1019,1011
1011  continue
      goto(1012,1014,9000),in
1012  continue
      m5=l5
      goto 1015
1014  continue
      m5=l5+(n5+n5g-1)*md5
1015  continue
      m5h=m5+md5h
      n1x=8
      do i=1,4
      name1(i)=istore(m5h)
      m5h=m5h+1
      enddo
      goto 1040
c--controlliamo se name1 e' una specie in lista 3
1019  continue
c      write(*,'(a,a4)') 'controllo specie atomica ',name1(1)
      m3=l3
      do i=1,n3
c      write(ncwu,'(a,1h$,a4,1h$,a4,1h$)')'l3$',name1(1),istore(m3)
      if(name1(1).eq.istore(m3)) goto 2019
      m3=m3+md3
      enddo
c      write(*,*)'non riconosco specie'
c--controlliamo se name1 e' un gruppo in lista 13
      m13=l13
      do i=1,n13
c      write(ncwu,'(a,1h$,a4,1h$,a4,1h$)')'l3$',name1(1),istore(m13)
      if(name1(1).eq.istore(m13)) goto 2019
      m13=m13+istore(m13+1)*md13+2
      enddo
c      write(*,*)'non riconosco specie'
c--name1 e' un atomo indicato senza parentesi
      goto 1040
c--e' stata indicata la specie atomica o nome di gruppo
2019  continue
      jx=1
1040  continue
      nca=nc
      if(jrca(name2,n2x)) 2000,1050,2000
1050  continue
      in=kcomp(1,name2,iunt,3,1)
      if(in) 1300,1300,1051
1051  continue
      goto(1300,1300,1060),in
1060  continue
      if(jrca(name2,n2x)) 1070,1075,1070
1075  continue
      in=kcomp(1,name2,iunt,3,1)
      if(in) 1100,1100,1076
1076  continue
      goto(1077,1070,9000),in
1077  continue
      m5=l5
      goto 1078
1070  continue
      m5=l5+(n5+n5g-1)*md5
1078  continue
      m5h=m5+md5h
      n2x=8
      do i=1,4
      name2(i)=istore(m5h)
      m5h=m5h+1
      enddo
1100  continue
      jx=-1
      goto 2000
1200  continue
      if(ifirst.eq.0) goto 2000
      return
1300  continue
      nc=nca
      do  i=1,40
      name2(i)=ib(1)
      enddo 
2000  continue
      ifirst=1
      n1x=(n1x+nch-1)/nch
      n2x=(n2x+nch-1)/nch
c      write(*,'(a,a4,1x,a4,5i5)')'prima di jset5 ',name1(1),name2(1),
c     1  n1x,n2x,jy,jx,il50
      j=jset5(name1,name2,n1x,n2x,jy,jx,il50)
c      write(*,*) 'jset5: ',j
      if(iall.eq.1) return
      if(j.ne.0) goto 9000
      if(jy.eq.0) return
      goto 900
c--error
9000  continue
      jfnd5=1
      return
      end
c
code for jset5
      function jset5(name1,name2,n1par,n2par,jy,jx,il50)
c--set flag in list 5
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst50/l50,m50,md50,n50
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib,ic,ia,ih,numb(10),iplus, inus,ipoint,namh
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      dimension name1(40),name2(40)
c
      jset5=0
      il50a=il50
      m5=l5
      do 2100 i=1,n5+n5g
      if(jy) 2090,2090,2010
2010  continue
      if(jx) 2020,2020,2015
2015  continue
      m5=m5
      if(istore(m5)-name1(1)) 2095,2090,2095
2020  continue
      m5h=m5+md5h
      do j=1,n1par
      if(istore(m5h)-name1(j)) 2095,2022,2095
2022  continue
      m5h=m5h+1
      enddo
      if(jx) 2200,2030,9000
2030  continue
      store(m5+44)=-1.0
      if(il50.eq.1)call jset50
      return
2090  continue
      store(m5+44)=-1.0
      if(il50.eq.1)call jset50
2095  continue
      m5=m5+md5
2100  continue
      if(jx.eq.1) return
      if(jy.ne.0) jset5=1
      return
2200  continue
      store(m5+44)=-1.0
      if(il50.eq.1)call jset50
      m5p=m5+md5
      i1=i+1
      do k=i1,n5+n5g
      store(m5p+44)=-1.0
      m5h=m5p+md5h
      do j=1,n2par
      if(istore(m5h)-name2(j)) 2390,2210,2390
2210  continue
      m5h=m5h+1
      enddo
      return
2390  continue
      m5p=m5p+md5
      enddo
c--error
9000  continue
      jset5=1
      return
      end
c
code for sclr5
      subroutine sclr5
c--clear flag in list 5
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      m5=l5
      do i=1,n5+n5g
      store(m5+44)=0.0
      m5=m5+md5
      enddo
      return
      end
c
code for jflg5
      function jflg5(m)
c--check the flag of the atom
c
c  m  address of the current atom in list 5
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      jflg5=0
      if(store(m+44).ne.0.0)jflg5=1
      return
      end
c
code for xfl50
      subroutine  xfl50
c--form absolute list 50
c
c  l50   location of the first atom
c  md50  number of words per atom
c  n50   total number of atoms
c
c--
      common/lst02/ ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,nori
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst50/l50,m50,md50,n50
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
c    istore(l50  )=0    atom not considered
c                 =1    atom considered
c                 =-1   atom considered with all its equivalents
      l50 = nfl
      md50= 1+n2*5
      m50=l50
      n50 = n5+n5g
      nfl=l50+n50*md50
      return
      end
c
code for jset50
      subroutine jset50
      common/worka/iname(7),ipres,iopsy,idum(17)
      common/lst50/l50,m50,md50,n50
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      ja=1
      istore(m50)=ipres
      in=iname(3)
      if(in)10,30,20
10    ja=-1
      in=ja*in
20    m50n=m50+1+(in-1)*4
      istore(m50n  )=ja
      istore(m50n+1)=iname(4)
      istore(m50n+2)=iname(5)
      istore(m50n+3)=iname(6)
      istore(m50n+4)=iname(7)
30    return
      end
c
code for sfr0r
      subroutine sfr0r(iln)
c--form the preamble block for a list type six or seven
c  ja =  7 (anomalous dispersion differences)
c
c--store(l6p+ 4)      sys06   -100.0 new version of list 6
c--store(l6p+ 5)      md6d    no. of word for reflect.(md6d=11) on store
c--store(l6p+ 6)      n6dk    no. of word for reflect.(n6dk=14) on disk
c--store(l6p+ 7)      n6p     length of preamble
c--store(l6p+ 8)      md6f   incremento per memorizzare il format
c
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/workb/ja,idumb(25)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
c--nuovo compattamento degli indici
c      ifat512	= 512
c      ifat512a = ( 2 * ifat512 + 1 ) * ( 2 * ifat512 + 1 )
c      ifat512b = ( 2 * ifat512 + 1 )
c--old ones
c      kk3=512
c      kk2=kk3*kk3
c      kk1=kk3*kk2
c      kk5=kk3/2
c--
      l6p=nfl
      call xxcln(iln)
      sys06=-100.0
      store(l6p+4)=sys06
      n6p=100
      n6dk=14
      md6d=12
      md6f=80
c--numero di riflessi da scrivere su disco n6d (=nrefltot)
      n6d=nrefltot
      store(l6p+5)= md6d
      store(l6p+6)= n6dk
      store(l6p+7)= n6p
      store(l6p+8)= md6f
      lj=l6p+9
      do i=1,69
       store(lj)=stor6(i)
       lj=lj+1
      enddo
      istore(l6p+78)=iyrand
      read(formatrif,'(20a4)')(istore(l6p+md6f-1+i),i=1,20)
      ln=n6p+(n6d+1)*n6dk
      call sowl(ln,iln,lsn,ld6p,lk,lm,lj)
      store(l6p+2)=lsn
      l6=ld6p+n6p
      n6=0
      call yup(ld6p,l6p,n6p)
      llw=ld6p+ln-1
      call swlin(iln,lsn,ld6p,llw,n6p,ln)
      l=l6p+n6p
c--check that we have not corrupted the store
      li=l6p
      l=l-1
      call xsac(106,lsn,li,l)
      m6dk=l6p+n6p+1
      m6  = m6dk+n6dk
      nfl = m6+md6d
      return
      end
c
code for xfl06
      subroutine xfl06
c--set up list 6 for reading and possibly writing
c--
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      in6=6
      call srlin(in6,li,ld6p,lk,ln,lm)
      n6p=ln
      l6p=nfl
      ly=l6p+n6p
      call srdls(in6,l,l6p,lj)
      sys06=store(l6p+4)
      md6d= store(l6p+5)
      n6dk= store(l6p+6)
      n6p = store(l6p+7)
      md6f= store(l6p+8)
      lj=l6p+9
      do i=1,69
      stor6(i)=store(lj)
      lj=lj+1
      enddo
      iyrand=istore(l6p+78)
      write(formatrif,'(20a4)')(istore(l6p+md6f-1+i),i=1,20)
      n6=nrefl
      n6d=nrefltot
      m6dk=l6p+n6p+1
      m6  = m6dk+n6dk
      nfl = m6+md6d
      ly  = nfl-1
      call xsac(in6,l,l6p,ly)
      l6d = ld6p+n6p
      l6  = l6d
      l6a = l6d
c--	write(ncwu,*)'xfl06:kk1,kk2,kk3,kk5',kk1,kk2,kk3,kk5
      return
      end
c
code for kfnr
      function kfnr(in,vett)
c--fetch the next reflection allowed by list 18
c
c--return values are :
c  -1  last reflection marker found
c   0  next reflection found
c
c  m6  location of the core buffer
c--
      include 'li6com.inc'
c--
      dimension vett(18)
c--
1000  continue
      j=kldnr(in,vett)
c--check for the last reflection
      if(j) 2000,1010,1010
1010  continue
      if(in) 1020,2000,1020
c--reflection deleted
1020  continue
      l6=l6+n6dk
      go to 1000
2000  continue
      kfnr=j
      return
      end
c
code for kldnr
      function kldnr(in,vett)
c--load the next reflection from the disc
c
c  ivett(1) = h
c  ivett(2) = k
c  ivett(3) = l
c   vett(4) = e
c   vett(5) = fo
c   vett(6) = e'
c   vett(7) = e'p
c  ivett(8) = phi' (parz)
c   vett(9) = phi (publ)
c  ivett(10) = code
c   vett(11) = sigma(fo)
c   vett(12) = fc
c   vett(13) = phi (calc)
c   vett(14) = (sin(theta)/lambda)**2
c   vett(15) = weight
c   vett(16) = fo(-)
c   vett(17) = fc(-)
c   vett(18) = phi(-) (calc)
c--
c   store(m6  ) = h
c   store(m6+1) = k
c   store(m6+2) = l
c   store(m6+3) = Fo
c   store(m6+4) = sigma(fo)
c   store(m6+5) = fc
c   store(m6+6) = phi (calc)
c   store(m6+7) = (sin(theta)/lambda)**2
c   store(m6+8) = weight
c   store(m6+9) = fo(-)
c   store(m6+10) = fc(-)
c   store(m6+11) = phi(-) (calc)
c--
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension vett(18),vet(18),ivet(18)
      equivalence (ivet,vet)
c--
      kldnr=0
c-	write(ncwu,*)'kldnr:kk1,kk2,kk3,kk5',kk1,kk2,kk3,kk5
      call ydwn(l6d,m6dk,n6dk)
      l6d=l6d+n6dk
c--unpack the values
      if(istore(m6dk).eq.ifine) goto 1000
      if(istore(m6dk).eq.iend ) goto 1000
      in  =istore(m6dk + 13)
      call unpack2002(istore(m6dk),ih,ik,il)
c      write(lo,*)'xslr',m6dk,istore(m6dk),ih,ik,il
      ivet(1)=ih
      ivet(2)=ik
      ivet(3)=il
      vet(4)= store(m6dk+1)
      vet(5)= store(m6dk+2)
      vet(6)= float(istore(m6dk+3)/32768)*0.001
      vet(7)= mod(istore(m6dk+3),32768)*0.001
      iphi8=istore(m6dk+4)/kk2
      ihkl =istore(m6dk+4)-iphi8*kk2
      ipub8=ihkl/kk3
      ityp8 = mod(ihkl,kk3)
      ivet(8) =iphi8
       vet(9) =ipub8
      ivet(10)=ityp8
      lj=m6dk+5
      do i = 11,18
       vet(i)= store(lj)
       lj=lj+1
      enddo
c--riempie il buffer in store
      store(m6	)=ivet(1)    !-- h
      store(m6+1)=ivet(2)    !-- k
      store(m6+2)=ivet(3)    !-- l
      store(m6+3)=vet(5)     !-- Fo
      m=m6+4
      do i=11,18
      store(m)=vet(i)
      m=m+1
      enddo
1010  continue
      do i=1,18
       vett(i)=vet(i)
      enddo
      return
1000  continue
      do i=1,18
       vet(i)=0.0
      enddo
      ivet(1   )=ifat512
      ivet(2   )=ifat512
      ivet(3   )=ifat512
      store(m6	)=ivet(1)    !-- 512
      store(m6+1)=ivet(2)    !-- 512
      store(m6+2)=ivet(3)    !-- 512
      kldnr=-1
      goto 1010
      end
c
code for xslr
      subroutine xslr(in)
c--store the last reflection on the disc
c--read data from store(m6)
c
      include 'li6com.inc'
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      m=m6
      do i=1,3
      ivett(i)=int(store(m))
      m=m+1
      enddo
      vett(5 )=store(m6+3)
      m=m6+4
      do i=11,18
      vett(i)=store(m)
      m=m+1
      enddo
      call xslrx(in,vett)
      return
      end
c
code for xslrx
      subroutine xslrx(in,vett)
c--store the last reflection on the disc
c--
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--     
      dimension vett(18),vet(18),ivet(18)
      equivalence (ivet,vet)
c--
c      write(ncwu,*)'xslr:kk1,kk2,kk3,kk5',kk1,kk2,kk3,kk5
      do i=1,18
      vet(i)=vett(i)
      enddo
      ih=ivet(1)
      ik=ivet(2)
      il=ivet(3)
      call pack2002(index,ih,ik,il)
      istore(m6dk  ) = index
c      write(lo,*)'xslr',m6dk,istore(m6dk),ih,ik,il
       store(m6dk+1) = vet(4)
       store(m6dk+2) = vet(5)
       ia=vet(6)*1000.
       ib=vet(7)*1000.
      istore(m6dk+3)=ia*32768+ib
       iphi8=ivet(8)
       ipub8=vet(9)
       ityp8=ivet(10)
      istore(m6dk+4)=iphi8*kk2+ipub8*kk3+ityp8
      lj=m6dk+5
      do i=11,18
      store(lj)=vet(i)
      lj=lj+1
      enddo
      istore(m6dk+13)=in
      call yup(l6,m6dk,n6dk)
      call ydwn(l6,m6dk,n6dk)
      l6=l6+n6dk
      return
      end
c
code for xert
      subroutine xert
c--end reflection transfer and rewrite the preamble block
c--
      include 'li6com.inc'
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
c--end the reflection transfer
      ifine=-11111
      iend=11111
      lj=m6dk
      do i=1,n6dk
      istore(lj)=ifine
      lj=lj+1
      enddo
      call yup(l6,m6dk,n6dk)
      l6=l6+n6dk
      call wpre6
      return
      end
c
code for unpack2002
      subroutine unpack2002(index,ih,ik,il)
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
!
      is = index
      ih = is / ifat512a
      is = is - ifat512a * ih
      ik = is / ifat512b
      il = is - ifat512b * ik
!
      ih = ih - ifat512
      ik = ik - ifat512
      il = il - ifat512
!
      return
      end
c
code for pack2002
      subroutine pack2002(index,ih,ik,il)
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
!
      ih = ih + ifat512
      ik = ik + ifat512
      il = il + ifat512

      index = ih * ifat512a + ik * ifat512b + il
!
      return
      end
! ----------------------------------------------------------------------
c
code for wpre6
      subroutine wpre6
c--rewrite the preamble block
c--
      include 'li6com.inc'
c
      common/xfile/ifile,ilist,iend,infle,nwfle,icfle,lid(4),ifine
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      lj=l6p+9
      do i=1,69
      store(lj)=stor6(i)
      lj=lj+1
      enddo
      istore(l6p+78)=iyrand
      read(formatrif,'(20a4)')(istore(l6p+md6f-1+i),i=1,20)
      call yup(ld6p,l6p,n6p)
      call xdump
      return
      end
c
code for xsto6
      subroutine xsto6(il6,iall,icode,in)
c--store list 6 in memory
c  input:
c  il6  = 6/7 list
c  iall = 0 observed reflections
c	  1 all the reflections
c  icode= 0 not save code flag into store(m6+11)
c	  1 save code flag into store(m6+11)=[phi(-) (calc)]*10+icode
c  output:
c  in = 1  list 6 in memory
c	0  no store available
c--
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c
      common/ylimi/nfl,lfl,nlx,dummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
c--check if there is enough room
      in=0
      m=nfl+(nrefltot+1)*md6d
      if(m.ge.lfl) goto 4200
c--store the reflections
      in=1
      lxxe=nfl
      nxxe=0
      mdxxe=md6d
      mxxe=lxxe
      l6 =l6a
      l6d=l6a
c      iconto=0
4105  continue
c      iconto=iconto+1
c      write(ncwu,'(a,2i10)') ' conto:',iconto,mxxe
      if(iall.eq.0) then
	if(kfnr(nn,vett))  4115,4110,4110
      else
	if(kldnr(nn,vett)) 4115,4110,4110
      endif
4110  continue
      mxxec=mxxe
      do l=m6,m6+md6d-1
      store(mxxe)=store(l)
      mxxe=mxxe+1
      enddo
c      write(ncwu,*)'input',store(m6+md6d-1)
      if(icode.eq.1) then
      asto = store(mxxec+11)*1000
      iphi = int(asto)
      iphi = iphi * 100
      istore(mxxec+11) =	(nn+10)+iphi ! code invece di phi(-) (calc)
c      write(ncwu,'(a,i5,i20)') 'prima',nn,istore(mxxec+11)
      endif
      if(il6.eq.7) then
        store(mxxec+4)=vett(4)
        store(mxxec+5)=0.0
        store(mxxec+6)=0.0
c--	 if(jg.eq.0) store(mxxec+6)=vett(9)
        if(jpart.ne.0) then
          store(mxxec+4)=vett(6)
          store(mxxec+5)=vett(7)
          store(mxxec+6)=vett(8)
        endif
      endif
c       ihh=lint( mxxec  )
c       ikk=lint( mxxec+1)
c       ill=lint( mxxec+2)
c       write(ncwu,'(1x,i10,3i4)') mxxec,ihh,ikk,ill
      nxxe=nxxe+1
      go to 4105
4115  continue
c      write(ncwu,'(a,2i10)') ' conto finale:',iconto,mxxe
      do l=m6,m6+md6d-1
      store(mxxe)=store(l)
      mxxe=mxxe+1
      enddo
      nfl=mxxe
      call xsac(106,1,lxxe,nfl-1)
c      write(ncwu,'(a,i10)') ' Numero di riflessi in xsto6',nxxe
c      mxxe=lxxe
c      do m=1,nxxe
c       ihh=store(mxxe  )
c       ikk=store(mxxe+1)
c       ill=store(mxxe+2)
c       write(ncwu,'(1x,i10,3i4)') mxxe,ihh,ikk,ill
c       mxxe=mxxe+mdxxe
c      enddo
4200  continue
      return
      end
c
code for stor6x
      subroutine stor6x(iall,icode)
c--save the reflections onto disc file
c  iall = 0 observed reflections
c         1 all the reflections
c  icode= 0 not save code flag into store(m6+11)
c	  1 save code flag into store(m6+11)=[phi(-) (calc)]*10+icode
c--
      include 'li6com.inc'
************************************************************************
*     Reflections packing constants
      common /param512/ ifat512,ifat512a,ifat512b
*
************************************************************************
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c
      common/ylimi/nfl,lfl,nlx,idummy(4)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
      common/xfour/ iverb,num,ipat,ifrag,ianom,ianomx,ipdb,iauto,irefi
     2 ,ihomx,ihvmx,ihsmx,rvol,scale,f000,scr,isearc,n5p,inte,iref
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      mxxe=lxxe
      l6 =l6a
      l6d=l6a
4105  continue
      m6=nfl
      if(iall.eq.0) then
	if(kfnr(nn,vett))  4115,4110,4110
      else
	if(kldnr(nn,vett)) 4115,4110,4110
      endif
4110  continue
      m6=mxxe
      if(store(m6)-ifat512) 4111,4105,4105
4111  continue
      if(icode.eq.1) then
      iphi = istore(mxxe+11)/100
      nn = istore(mxxe+11)-iphi*100  ! code invece di phi(-) (calc)
      nn=nn-10
c      write(ncwu,'(a,i5,2i20)') 'dopo',nn,istore(mxxe+11),iphi
      store(mxxe+11) = iphi/1000.0
      endif
c      write(ncwu,2)store(m6),store(m6+1),store(m6+2),
c     1 store(m6+3),store(m6+4),nn
c2     format(3f5.0,2f10.4,i10)
      mxxe=mxxe+mdxxe
      call xslr(nn)
      goto 4105
4115  continue
      call xert
      return
      end
c
code for sfl13
      subroutine sfl13
c--form absolute list 13
c
c  l13	 location of the first value
c
c--
      common/lst13/l13,m13,md13,n13,l13g,n13g,sys13
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      sys13=1.00
      call sldl(13,l,l13g,lj)
      n13=store(l13g+5)
      l13=l13g+store(l13g+6)
      md13=store(l13g+7)
      call srlin(13,lsn,li,lj,lk,ll)
      n13g=ll
      return
      end
c
code for sfl14
      subroutine sfl14
c--form absolute list 14
c
c  l14   location of the first value (initial x)
c
c--
      common/lst14/l14,m14,md14,n14,l14a,m14a,md14a,n14a,l14g,n14g,
     2 l14p,l14f,sys14
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      sys14=1.00
      call sldl(14,l,l14g,lj)
      l14f=l14g+store(l14g+5)
      l14p=l14g+store(l14g+17)
      l14=l14f
      md14=store(l14g+6)
      md14a=store(l14g+7)
      call srlin(14,lsn,li,lj,lk,ll)
      n14g=ll
      return
      end
c
code for sfl17
      subroutine  sfl17
c--form absolute list 17
c
c  n17o   number of grou(s)
c  l17o   location of the first group
c  md17o  number of overall words per each group
c  md17   number of words for atom
c
c--
      implicit integer*4 (l,m)
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call sldl(17,l,lz,lj)
      l17o = store(lz+ 5)+lz
      md17o= store(lz+ 7)
      md17 = store(lz+ 8)
      n17o = store(lz+ 6)
      n173=n3
      l173=lj+1
      nfl=l173+n173
      md173=1
      lj=nfl-1
      call xsac(17,l,lz,lj)
      return
      end
c
code for j5317
      function j5317(in)
c--set up the form factor types in list 17
c  subtract group atoms from total number of atoms
c
c  in  dummy argument
c
c--on return 'k5317' is set to the maximum form factor type
c  referenced minus one
c
c--lists 5, 17 and 3 are assumed to have been loaded
c
c--
      implicit integer*4 (l,m)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--                           
      inn=in
      j5317=-1
      m173=l173
      m3=l3
      do 1000 i=1,n173
      store(m173)=store(m3+12)
      m3=m3+md3
      m173=m173+1
1000  continue
      k=-1
      m17o=l17o
      m17oi=m17o
      n17=store(m17o+2)
      m17 =m17o+md17o
      do 2600 l=1,n17
      m17i=m17
      m3=l3
      j=0
      do 2560 i=1,n3
      m3i=m3
      if(istore(m3i)-istore(m17i)) 2550,2570,2550
2550  continue
      m3=m3+md3
      j=j+1
2560  continue
      write(ncwu,2565)
2565  format(/,26h form factor not in list 3)
      call xerr
c**machine specific
      stop 1111
2570  continue
      store(m17+7)=j
      k=max0(k,j)
      m=l173+j
      store(m)=store(m)-store(m17o+1)
      m17=m17+md17
2600  continue
      m17o=m17
3000  continue
      j5317=k
      return
      end
c
code for sfl18
      subroutine sfl18
c--form absolute list 18 in store
c
c--the locations in store are controlled by the following variables
c
c  l18  location of the first general condition
c  md18 number of words for each general condition
c  n18  number of general condition
c  l18r location of the first reflection condition
c  md18r number of words for each reflection condition
c  n18r  number of reflection condition
c  m18  location at which the program has put the reflection
c  m18r  =m18
c  l18d  location of list 18 in core
c  md18d the list type number to be used as data of type 18.
c  n18d  lenght of list 18 in core.
c  m18d  location of maximum of equivalent indicies
c
c--
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d,nrif18,lrif18,mrif18,ncla18,lcla18
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      call srdls(18,l,nfl,lj)
      l18  =store(nfl+12)+nfl
      md18 =store(nfl+ 7)
      n18  =store(nfl+ 6)
      l18r =store(nfl+ 8)+nfl
      md18r=store(nfl+10)
      n18r =store(nfl+ 9)
      nrif18 =store(nfl+13)   ! no. riflessi esclusi
      lrif18 =l18r+n18r*md18r
      mrif18= lrif18+nrif18*3
      ncla18 =store(nfl+11)	! no. classi
      lcla18 =store(nfl+ 5)+nfl
      m18=nfl+lj
      m18d=l18+md18*n18+n18
      l18d=nfl
      n18d=lj
      nfl=m18+n18
      m=nfl-1
      call xsac(18,l,l18d,m)
      md18d=18
      return
      end
c
code for inmxeq
      subroutine inmxeq(ivetm,ivetx)
c--
      include 'li6com.inc'
c
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
c
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (store,istore)
c
      dimension ivet(3),ivetm(3),ivetx(3)
c
      m2=l2
      do i=1,n2
      ivet(1)=store(m6  )*store(m2  )+store(m6+1)*store(m2+3)+
     1            store(m6+2)*store(m2+6)
      ivet(2)=store(m6  )*store(m2+1)+store(m6+1)*store(m2+4)+
     1            store(m6+2)*store(m2+7)
      ivet(3)=store(m6  )*store(m2+2)+store(m6+1)*store(m2+5)+
     1            store(m6+2)*store(m2+8)
      do k=1,3
	if(ivetm(k).gt.ivet(k))ivetm(k)=ivet(k)
	if(ivetx(k).lt.ivet(k))ivetx(k)=ivet(k)
      enddo
      m2=m2+md2
      enddo
      return
      end
c
code for sort9
      subroutine sort9
c--routine di sort list 7
c  routine modificata (da controllare)
c
c  jd  numero di e
c  l   indirizzo di partenza in store
c  ja  = 1 ordine decrescente ( e forti)
c       -1 ordine crescente ( e dedoli)
c
      implicit integer*4 (l,m)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7f,l7e,l7p,n7f,n7dd,ks1,ks2,ks3,sys07
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence(istore,store)
      if(jd.eq.1)return
      n=2
 1000 continue
      jn=jd/n
      if(jn)1100,1100,1200
 1100 continue
      jn=1
 1200 continue
      jf=jd-jn
 1300 continue
      jh=0
      mm=l
      do 1400 i=1,jf
      mm1=mm+(  jn  )*md7d
      if((istore(mm+2)-istore(mm1+2))*ja)1450,1470,1470
 1450 continue
      do 1460 nn=1,md7d
      ji=istore(mm+nn-1)
      istore(mm+nn-1)=istore(mm1+nn-1)
      istore(mm1+nn-1)=ji
 1460 continue
      jh=1
 1470 continue
      mm=mm+md7d
 1400 continue
      if(jh)1500,1500,1300
 1500 continue
      if(jn-1)1700,1700,1600
 1600 continue
      n=n*2
      go to 1000
 1700 continue
      return
      end
c
code for sorty
      subroutine sorty(lind,numb,minc,jump)
c
c--general sorting routine
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
c--array to be used : istore
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence(istore,store)
c
      call sortya(istore,lind,numb,minc,jump)
      return
      end
c
code for sortz
      subroutine sortz(lind,numb,minc,jump)
c
c--general sorting routine
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
c--array to be used : istore
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence(istore,store)
c
      call sortza(store,lind,numb,minc,jump)
      return
      end
c
code for sortya
      subroutine sortya(istore,lind,numb,minc,jump)
c--general sorting routine
c
c  istore : array to be used
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension  istore(*)
c
      jsign=1
      if(jump.ge.0)go to 2000
      jump=iabs(jump)-1
      jsign=-1
2000  continue
      if(numb.eq.1)return
      ja=2
 2010 continue
      jb=numb/ja
      if(jb) 2020,2020,2030
 2020 continue
      jb=1
 2030 continue
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do 2070 i=1,jc
      mk =m +jb*minc
      if((istore(m +jump)-istore(mk +jump))*jsign)2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,minc
      jf=istore(mm)
      istore(mm)=istore(mmk)
      istore(mmk)=jf
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m =m +minc
 2070 continue
      if(jd)2080,2080,2040
 2080 continue
      if(jb-1)2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c
code for sortza
      subroutine sortza(store,lind,numb,minc,jump)
c--general sorting routine
c
c  store : array to be used
c--lind :first address in the list
c--numb :number of elements in the list
c--minc :number of words per element
c--jump :function of the relative address(jaddress) of the variable
c  to be sort   (0.ge.jaddress.le.minc)
c  jump>0 increasing sorting ( jaddress=jump )
c  jump<0 decreasing sorting ( jaddress=iabs(jump)-1 )
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      dimension  store(*)
c
      jsign=1
      if(jump.ge.0)go to 2000
      jump=iabs(jump)-1
      jsign=-1
2000  continue
      if(numb.eq.1)return
      ja=2
 2010 continue
      jb=numb/ja
      if(jb) 2020,2020,2030
 2020 continue
      jb=1
 2030 continue
      jc=numb-jb
 2040 continue
      jd=0
      m =lind
      do 2070 i=1,jc
      mk =m +jb*minc
      if(( store(m +jump)- store(mk +jump))*jsign)2060,2060,2050
 2050 continue
      mm=m
      mmk=mk
      do 2055 je=1,minc
      f= store(mm)
      store(mm)= store(mmk)
      store(mmk)= f
      mm=mm+1
      mmk=mmk+1
 2055 continue
      jd=1
 2060 continue
      m =m +minc
 2070 continue
      if(jd)2080,2080,2040
 2080 continue
      if(jb-1)2100,2100,2090
 2090 continue
      ja=ja*2
      go to 2010
 2100 continue
      return
      end
c
code for frm15
      subroutine frm15
c--write list 15 on disk (peaks)
c
c  l15  location of the first parameter in  store
c  n15  number of parameter
c  md15 number of words for parameter
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      l15d=nfl
      kn=15
      npre15=13
      call xxcln(kn)
      store(nfl+5)=npre15
      store(nfl+6)=md15
      store(nfl+7)=n15
      store(nfl+8)=0
      store(nfl+9)=n15a
      ll15=nfl + npre15
      m15=ll15
      ll=l15
      do 5500 j=1,n15
      do 5550 k=1,md15
      if(k.eq.1)then
      istore(m15)=itytoz(istore(ll))
      go to 5550
      endif
      store(m15+k-1)=store(ll+k-1)
5550  continue
      ll=ll+md15
5500  m15=m15+md15
      l15=ll15
      n=npre15+n15*md15
      call xfrml(kn,n)
      call xdump
      return
      end
c
code for sfl15
      subroutine sfl15
c--form absolute list 15  (peaks)
c
c  l15  location of the first parameter in  store
c  n15  number of parameter
c  md15 number of words for parameter
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
      common/lst15/ l15,m15,md15,n15,l15a,m15a,md15a,n15a,l15d,n15d
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      call sldl(15,li,l15d,lj)
      md15=store(l15d+6)
      n15 =store(l15d+7)
      n15a=store(l15d+9)
      l15 =store(l15d+5)+l15d
      call srlin(15,lsn,li,lj,lk,ll)
      n15d=ll
c--
      m15=l15
      do 100 i=1,n15
      istore(m15)=iztoty(istore(m15))
100   m15=m15+md15
      return
      end
c
code for itytoz
      function itytoz(iz)
c
c  from type to z(atomic number)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
      data k/2hpk/
c--
      itytoz=0
      if(iz.eq.k)then
      itytoz=999
      return
      endif
      m3=l3
      do 200 j=1,n3
      izz=istore(m3)
      if(izz.ne.iz)go to 200
      itytoz=int(store(m3+13))
      return
200   m3=m3+md3
      return
      end
c
code for iztoty
      function iztoty(iz)
c
c  from z to type
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti,l3g,n3g,sys03
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      data j/2h  /,k/2hpk/
      if(iz.eq.999)then
      iztoty=k
      return
      endif
      iztoty=j
      m3=l3
      do 200 j=1,n3
      izz=int(store(m3+13))
      if(izz.ne.iz)go to 200
      iztoty=istore(m3)
      return
200   m3=m3+md3
      return
      end
c
code for sfl08
      subroutine sfl08(ix)
c--set up the list type 8
c  positive triplets
c
c--ix=0   read the whole list
c  ix=-1  read only the preamble block
c
c--the common variables are used as follow
c-- l8   address on store of the first triplet
c-- m8   current address on store
c-- md8  number of words per reflections on disc
c-- n8   number of relationships on disc
c-- n8xa number of relationships to be regarded
c-- n8xd value stored on the preamble
c-- n8xe value stored on the preamble
c-- icod8  value stored on the preamble
c-- n8p  lenght of preamble block
c-- n8d  lenght of list on disc
c-- l8d  address on disc of the first triplet
      common/lst08/l8,m8,md8,n8,n8xa,n8xd,n8xe,icod8,n8p,l8d,n8d
      in=8
      call xflxx(ix,in,n8,n8xa,n8xd,n8xe,icod8,l8,md8,l8d,n8d)
      return
      end
c
code for sfl09
      subroutine sfl09(ix)
c--set up the list type 9
c  psi zero
c
      common/lst09/l9,m9,md9,n9,n9xa,n9xd,n9xe,icod9,n9p,l9d,n9d
      in=9
      call xflxx(ix,in,n9,n9xa,n9xd,n9xe,icod9,l9,md9,l9d,n9d)
      return
      end
c
code for sfl10
      subroutine sfl10(ix)
c--set up the list type 10
c  negative triplets
c
      common/lst10/l10,m10,md10,n10,n10xa,n10xd,n10xe,icod10,
     1  n10p,l10d,n10d
      in=10
      call xflxx(ix,in,n10,n10xa,n10xd,n10xe,icod10,l10,md10,l10d,n10d)
      return
      end
c
code for sfl11
      subroutine sfl11(ix)
c--set up the list type 11
c  enantiomorphous triplets
c
      common/lst11/l11,m11,md11,n11,n11xa,n11xd,n11xe,icod11,
     1  n11p,l11d,n11d
      in=11
      call xflxx(ix,in,n11,n11xa,n11xd,n11xe,icod11,l11,md11,l11d,n11d)
      return
      end
c
code for sfl24
      subroutine sfl24(ix)
c--set up the list type 24
c  psi-e triplets
c
      common/lst24/l24,m24,md24,n24,n24xa,n24xd,n24xe,icod24,
     1	n24p,l24d,n24d
      in=24
      call xflxx(ix,in,n24,n24xa,n24xd,n24xe,icod24,l24,md24,l24d,n24d)
      return
      end
c
code for sfl20
      subroutine sfl20(ix)
c--set up the list type 20
c  negative quartets
c
      common/lst20/l20,m20,md20,n20,n20xa,n20xd,n20xe,icod20,
     1  n20p,l20d,n20d
      in=20
      call xflxx(ix,in,n20,n20xa,n20xd,n20xe,icod20,l20,md20,l20d,n20d)
      return
      end
c
code for sfl21
      subroutine sfl21(ix)
c--set up the list type 21
c  enantiomorphous quartets
c
      common/lst21/l21,m21,md21,n21,n21xa,n21xd,n21xe,icod21,
     1  n21p,l21d,n21d
      in=21
      call xflxx(ix,in,n21,n21xa,n21xd,n21xe,icod21,l21,md21,l21d,n21d)
      return
      end
c
code for sfl26
      subroutine sfl26(ix)
c--set up the list type 26
c  one phase seminvariants
c
      common/lst26/l26,m26,md26,n26,n26xa,n26xd,n26xe,icod26,
     1	n26p,l26d,n26d
      in=26
      call xflxx(ix,in,n26,n26xa,n26xd,n26xe,icod26,l26,md26,l26d,n26d)
      return
      end
c
code for sfl27
      subroutine sfl27(ix)
c--set up the list type 27
c
      common/lst27/l27,m27,md27,n27,n27xa,n27xd,n27xe,icod27,
     1	n27p,l27d,n27d
      in=27
      call xflxx(ix,in,n27,n27xa,n27xd,n27xe,icod27,l27,md27,l27d,n27d)
      return
      end
c
code for xfrmx
      subroutine xfrmx(ixx,iln,nxx,nxxa,nxxd,nxxe,icod,lx,mdxxc,lxd,nxd)
c--form list xx (relationships)
c
c  ixx =  0  write the whole list
c        -1  write only the preamble block
c  iln =  list number
c          8   positive triplets
c          9   psi zero
c         10   negative triplets
c         11   enantiomorphous triplets
c	  24   psi-e triplets
c         20   negative quartets
c         21   enantiomorphous quartets
c	  26   one phase seminvariants
c	  27   two phases seminvariants
c
c  nxx =  number of relationships to be stored on disc
c  nxxa=  number of relationships to be regarded
c         ( usually  nxx = nxxa  except positive triplets for p10)
c  nxxd=  value to be stored on the preamble
c  nxxe=  value to be stored on the preamble
c  icod=  value to be stored on the preamble
c  lx  =  address in store for the relationships
c  mdxx=  number of words per relationship on disc
c  mdxxc= number of words per relationship on store
c  lxd =  address in store of the first word of the list xx
c  nxd =  lenght of the list xx
c
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)      
c--                    
      lxdc=lxd
      nxdc=nxd
      if(iln.gt.27.or.iln.lt.1) goto 1
      goto(1,1,1,1,1,1,1,8,9, 8, 8,1,1,1,1,1,1,1,1 ,
     1 20,20,1,1,1,1,22,8),iln
1     write(ncwu,1001) iln
1001  format(///,i7,25h is not a valid list type)
      call zerr
      stop  1111
8     mdxx=3
      mdxxc=3
      goto 1000
9     mdxx=1
      mdxxc=3
      goto 1000
20    mdxx=3
      mdxxc=7
      goto 1000
22    mdxx=1
      mdxxc=1
1000  continue
      call xxcln(iln)
      nxxp=19
      l=nfl+nxxp-1
      do 1010 i=nfl+5,l
1010  store(i)=0.0
      store(nfl+5)=mdxx
      store(nfl+6)=mdxxc
      store(nfl+7)=nxxp
      store(nfl+8)=nxx
      store(nfl+9)=nxxa
      store(nfl+10)=nxxd
      store(nfl+11)=nxxe
      store(nfl+12)=icod
      ln=nxxp+(nxx+1)*mdxx
      call sowl(ln,iln,lsn,ldxxp,lk,lm,lj)
      store(nfl+2)=lsn
      call yup(ldxxp,nfl,nxxp)
      llw=ldxxp+ln-1
      call swlin(iln,lsn,ldxxp,llw,nxxp,ln)
      if(ixx.lt.0)return
      lxx=ldxxp+nxxp
      mx=lx
      do 2000 i=1,nxx
      call xup(lxx,istore(mx),mdxx)
      lxx=lxx+mdxx
      mx=mx+mdxxc
2000  continue
      call xdump
      return
      end
c
code for xflxx
      subroutine xflxx(ixx,iln,nxx,nxxa,nxxd,nxxe,icod,lx,mdxxc,lxd,nxd)
c--load  list xx  (relationships)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      call srlin(iln,li,ldxxp,lk,ln,lm)
      lxd=nfl
      nxd=lm
      call srdls(iln,l,nfl,lj)
      mdxx= store(nfl+5)
      mdxxc=store(nfl+6)
      nxxp= store(nfl+7)
      nxx = store(nfl+8)
      nxxa= store(nfl+9)
      nxxd= store(nfl+10)
      nxxe= store(nfl+11)
      icod= store(nfl+12)
      nfl=nfl+nxxp
      if(ixx.lt.0) return
      lxx=ldxxp+nxxp
      lx=nfl
      mx=lx
      do 2000 i=1,nxx
      call xdwn(lxx,istore(mx),mdxx)
      lxx=lxx+mdxx
      mx=mx+mdxxc
2000  continue
      nfl=mx
      return
      end
c
code for dcmp
      subroutine dcmp (m8,jump)
c--unpack the sir's format lists
c
c  jump = 1 one phase s.s.
c       = 2 two phases s.s.
c       = 3 triplets
c       = 4 quartets
c       = 5 psi zero
c
      implicit integer*4 (l,m)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/dcmt/nor(4),nop(4),nsgn(4),gi,ifaz,nphasv,ift1,ift2,ift3
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      do 1 i=1,4
      nor(i)=0
      nop(i)=0
1     nsgn(i)=0
      goto (1000,2000,3000,4000,5000),jump
c--unpack the list 26
1000  continue
      call unpak3(istore(m8),nor(1),igi,ifaz)
      gi=igi*0.01
      goto 9000
c--unpack the list 27
2000  continue
      call unpak3(istore(m8  ),nor(1),nor(2),nphasv)
      call unpak3(istore(m8+1),n     ,igi   ,ifaz  )
      gi=igi*0.01
      goto 9000
c--unpack the list 8,10,11,24
3000  continue
      call unpak3(istore(m8  ),nor(1),nor(2),nphasv)
      call unpak3(istore(m8+1),nor(3),igi   ,ifaz  )
      call unpak3(istore(m8+2),in3   ,igi1  ,ifaz1 )
      gi=igi*0.01
      goto 9000
c--unpack the list 20,21
4000  continue
      call unpak3(istore(m8  ),nor(1),nor(2),nphasv)
      call unpak3(istore(m8+1),nor(3),nor(4),ifaz1 )
      call unpak3(istore(m8+2),in3   ,igi   ,ifaz  )
      gi=igi*0.01
      goto 9000
c--unpack the list 9
5000  continue
      call unpak3(istore(m8),nor(1),nor(2),ifaz)
9000  do 9100 i=1,4
      if(nor(i).eq.0) return
      if(nor(i).lt.0) nsgn(i)=-1
      nor(i)=iabs(nor(i))
9100  continue
      return
      end
c
code for jpack1
      function jpack1(n1,g,ifaz)
c--funzione di compattazione da sir
      ifz=ifaz/15
      ifz=mod(ifz,24)
      ig100=int(g*100)
      if (ig100.gt.2047) ig100=2047
      jpack1=((n1+2048)*4096+ig100+2048)*32+ifz+1
      return
      end
c
code for jpack2
      subroutine jpack2(ind1,ind2,n1,ise,n2,g,ifaz)
c--funzione di compattazione da sir
      ig100=int(g*100)
      if (ig100.gt.2047) ig100=2047
      ind1=((n1+2048)*4096+n2*ise+2048)*32
      ind2=((1024+2048)*4096+ig100+2048)*32+(ifaz/15)+1
      return
      end
c
code for unpk1
      subroutine unpk1(ind,n1,g,ifaz)
c--funzione di decompattazione da sir
c---- jpack1=((n1+2048)*4096+int(g*100)+2048)*32+(ifaz/15)+1
      ind=ind-1
      n1=ind/131072-2048
      ig100=ind/32-(n1+2048)*4096-2048
      g=float(ig100)/100.0
      ifaz=(ind-((n1+2048)*4096+ig100+2048)*32)*15
      return
      end
c
code for unpak3
      subroutine unpak3(index,kod1,kod2,ifaz)
c--funzione di decompattazione da sir
      isave=index/32
      ifaz=index-isave*32 -1
      kod1=isave/4096
      kod2=isave-4096*kod1-2048
      kod1=kod1-2048
      return
      end
c
code for jphsp
      function jphsp(inp)
      implicit integer*4 (l,m)
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
     3 ,l2a,l2b,l2c,l2d,l2j,norix
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (store,istore)
c
      dimension inp(3),ivet(3)
      jphsp=13
      if(ic.eq.1)return
      jphsp=1
      m2=l2
      do 100 i=1,n2
      mm=m2
      do 200 j=1,3
      ivet(j   )=inp(1   )*store(mm  )+inp(2   )*store(mm+3)+
     1             inp(3   )*store(mm+6)
      if(inp(j)+ivet(j))250,199,250
199   continue
      mm=mm+1
200   continue
      sis=inp(1)*store(m2+9)+inp(2)*store(m2+10)+inp(3)*store(m2+11)
      is=sis*12+.002
      jphsp=mod(is,12)+1
      if(jphsp.le.1)jphsp=jphsp+12
c     write(ncwu,1)i,(inp(k),k=1,3),sis,is,jphsp
1     format(i4,3x,3i5,f10.2,2i5)
      return
250   continue
      m2=m2+md2
  100 continue
      return
      end
c
code for sfl12
      subroutine sfl12
c--load list 12
c
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      call sldl(12,ly,li,lz)                                            
      n12    =store(li+5)
      md12   =store(li+6)
      md12a  =store(li+7)
      do i=1,4
      iover12(i)=store(li+8+i-1)
      enddo
      nbl12  =store(li+12)
      n12c   =store(li+13)
c--store(li+14) n. asse del floating origin....
      md12b  =store(li+15)
      n12d=lz
      l12d=li
      l12=li+md12a
      return                                                            
      end                                                               
c                                                                       
code for sfl22                                                          
      subroutine sfl22                                                  
c--load list 22                                                         
c                                                                       
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c                                                                       
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c                                                                       
      call sldl(22,ly,li,lz)                                            
      incr=store(li+5)                                                  
      n22 =store(li+6)                                                  
      ieq =store(li+7)                                                  
      iwe =store(li+8)                                                  
      md22=store(li+11)
      md22a=store(li+12)
      incrx=store(li+13)
      n22d=store(li+14)
      iflorg=store(li+15)
      in14=store(li+9)
      do i=1,4
      iover22(i)=store(li+16+i-1)
      enddo
      l22=li+incr
      l22d=li+incrx
      return
      end
c                                                                       
code for jfr22
      function jfr22(in)
c--main function to form list 22
c                                                                       
c      character*200 Msg
c      common /msgerr/ Msg
c
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      jfr22=0
      inn=in
      call frm22(jbb,ier)
      if(ier.eq.0) return
      goto(9000,9020,9050),ier
9000  continue
      write(ncwu,9010)jbb
      ier=1111
c      call manage_mouse_cursor(0)
c      call screrr(ier,Msg,1)
9010  format(' Card (jfr22) ',i2,' error: atom unknown')
      go to 9100
9020  continue
      write(ncwu,9030) iover22(2),iover22(1)
      ier=-1
c      call manage_mouse_cursor(0)
c      call screrr(ier,Msg,1)
9030  format(' (jfr22) dummy overall temp. factor block (',i2,
     2 ') different from scale block (',i2,')')
      goto 9100
9050  continue
      write(ncwu,9055)jbb
      ier=-1
c      call manage_mouse_cursor(0)
c      call screrr(ier,Msg,1)
9055  format(' Card (jfr22) ',i2,' error: equivalenced parameter',
     1 ' in different blocks or fixed')
9100  continue
      jfr22=-1
      return
      end
c
code for frm22
      subroutine frm22(jbb,ier)
c--form list 22                                                         
c                                                                       
      character*80 ifmt
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/xchar/id,ie,ib,ixchar(17)
      common/xcard/nch,image(80),nc,idumx(27)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      ier=0
      in14=11
c
c--check if there are mixed atom sites (loop solo su atomi)
      m5=l5
      do i=1,n5
      if(store(m5+46).gt.0.05) then
       in14=15
       goto 1001
      endif
      m5=m5+md5
      enddo
1001  continue
c
c--form preamble block for list 22
      ka=22                                                             
      call xxcln(ka)
      do i=1,4
      iover22(i)=0
      enddo
      iwe=0
      ieq=0                                                             
      md22a=5
      md22=1+md22a*in14
      incr=20
      incrx=incr+(n5+n5g)*md22
      l22=nfl+incr
      l22d=nfl+incrx
      n22d=n12c
      l=nfl+5                                                           
      l1=l22-1                                                          
      do m=l,l1
      store(m)=0.0                                                      
      enddo
      store(nfl+5)=incr                                                 
      store(nfl+11)=md22
      store(nfl+12)=md22a                                               
      store(nfl+13)=incrx
      store(nfl+14)=n22d
      store(nfl+15)=store(l12d+14)
      store(nfl+9 )=in14
c                                                                       
c--clear list 22                                                        
      m22=l22                                                           
      do in=1,n5+n5g
      istore(m22)=0                                                     
      m22a=m22+1                                                        
      do i=1,in14
      l=m22a
      l1=m22a+md22a-1
      do m=l,l1
      istore(m)=0
      enddo
      istore(m22a+1)=1000
      m22a=m22a+md22a
      enddo
      m22=m22+md22
      enddo
c--set current next free location for restraints directives
      m22d=l22d
      m22x=m22d
      m22dc=0
c
c--loop on list 12                                                      
      n22=0                                                             
      m12=l12                                                           
      do 2000 jbb=1,n12
      call sclr5                                                        
      ist =istore(m12  )                                                
      if(ist.le.3) ista=ist
c      write(ncwu,*)' ist=',ist
      nca=iabs(istore(m12+1))
      ncb=iabs(istore(m12+2))
      if(nca.eq.0) go to 1050                                           
      do i=1,80
      image(i)=ib                                                       
      enddo
      i=1                                                               
      l=m12+md12b+nca-1
      do n=nca,ncb
      image(i)=istore(l)                                                
      l=l+1                                                             
      i=i+1                                                             
      enddo
c      write(ncwu,'(80a1)')  ( image(n),n=1,80)
      write(ifmt,1051)image
1051  format(80a1)
      call xcase(ifmt)
      read(ifmt,1051) image                                                 
c      write(ncwu,'(6hImage:,80a1)') image
      nc=1
1050  continue                                                          
c      write(ncwu,*)'jfr22,jbb,n12,ist,nca,ncb,l12,nfl:',
c     1 jfr22,jbb,n12,ist,nca,ncb,l12,nfl
      go to (1100,1200,1300,1400,1500,
     1	     1600,1700,1900,
     2	     2100,1500,2200,2200,2300,2400,2450,2500),ist
c
c--'diag'
1100  continue
      iy=1
      iaa=0
      ix=0
      if(jfn22(nca,iaa,iy,ix)) 9000,1110,9000
1110  continue
      n22=iaa
      go to 2001                                                        
c                                                                       
c--'full'                                                               
1200  continue                                                          
      iy=0                                                              
      iaa=1
      n22=1                                                             
      ix=0
      if(jfn22(nca,iaa,iy,ix)) 9000,2001,9000
c                                                                       
c--'block'                                                              
1300  continue                                                          
      iaa=n22+1
      iy=0                                                              
      ix=0
      if(jfn22(nca,iaa,iy,ix)) 9000,1110,9000
c                                                                       
c--'plus'                                                               
1400  continue                                                          
      iy=0                                                              
      iaa=n22
      if(ista.eq.1) iy=1                                                
      ix=0
      if(jfn22(nca,iaa,iy,ix)) 9000,1110,9000
c                                                                       
c--'fix'                                                                
1500  continue                                                          
      iaa=0
      iy=0                                                              
      ix=0
c      write(*,*) 'card:',jbb,istore(m12+6)
      if(jfn22(nca,iaa,iy,ix)) 9000,2001,9000
c
c--'weight'
1600  continue
      iwe=1
      ix=0
      il50=0
      if(jfnd5(ix,il50)) 9000,1610,9000
1610  continue
      m5=l5
      m22=l22
      do 1625 n=1,n5+n5g
      if(jflg5(m5))1620,1620,1615
1615  continue
      ncc=istore(m12+3)
      m22a=m22+1+(ncc-1)*md22a
      istore(m22a+1)=istore(m12+4)
1620  continue
      m22=m22+md22
      m5=m5+md5
1625  continue
      go to 2001
c
c--'equiv'
1700  continue
      iaa=n22
      if(ista.eq.1) iaa=0
      ieq=1
      if(istore(m12+1).lt.0) goto 1820
      if(istore(m12+4).eq.0) goto 1800
c--1th kind of 'equiv' (atom1 p1 atom2 p2)
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1703,9000
1703  continue
      m5=l5
      m22=l22
      do 1704 n=1,n5+n5g
      if(jflg5(m5))1708,1708,1707
1707  continue
      nn=n
      ncc=istore(m12+3)
      m22a=m22+1+(ncc-1)*md22a
      go to 1709
1708  continue
      m22=m22+md22
      m5=m5+md5
1704  continue
      go to 9000
1709  continue
      nca=istore(m12+4)
      ncb=istore(m12+5)
      ndd=istore(m12+6)
      nnn=nn
      m22z=m22+1+(ndd-1)*md22a
      do i=1,80
      image(i)=ib
      enddo
      i=1
      l=m12+md12b+nca-1
      do n=nca,ncb
      image(i)=istore(l)
      l=l+1
      i=i+1
      enddo
      nc=1
      call sclr5
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1722,9000
1722  continue
      m5=l5
      m22=l22
      do 1735 n=1,n5+n5g
      if(jflg5(m5))1725,1725,1724
1724  continue
      nnn=n
      m22z=m22+1+(ndd-1)*md22a
      go to 1750
1725  continue
      m22=m22+md22
      m5=m5+md5
1735  continue
      go to 9000
1750  continue
c      write(ncwu,*)'prima di j22cm',iaa,m22a,m22z,nn,ncc
      icod22=0
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,2001,9050
c--2nd kind of 'equiv'	(atom p1 p2)
1800  continue
      ix=0
      il50=0
      if(jfnd5(ix,il50)) 9000,1803,9000
1803  continue
      m5=l5
      m22=l22
      do 1804 n=1,n5+n5g
      if(jflg5(m5))1810,1810,1807
1807  continue
      nn=n
      ncc=istore(m12+3)
      m22a=m22+1+(ncc-1)*md22a
      ndd=istore(m12+6)
      m22z=m22+1+(ndd-1)*md22a
      icod22=0
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1810,9050
1810  continue
      m22=m22+md22
      m5=m5+md5
1804  continue
      goto 2001
c--3st kind of equiv directive	(atom1	atom2)
1820  continue
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1823,9000
1823  continue
      m5=l5
      do 1824 n=1,n5+n5g
      if(jflg5(m5))1828,1828,1827
1827  continue
      iani1=0
      if(store(m5+10).gt.0.001) iani1=1
      nn=n
      go to 1829
1828  continue
      m5=m5+md5
1824  continue
      go to 9000
1829  continue
      call sclr5
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1822,9000
1822  continue
      m5=l5
      do 1835 n=1,n5+n5g
      if(jflg5(m5))1825,1825,1834
1834  continue
      iani2=0
      if(store(m5+10).gt.0.001) iani2=1
      nnn=n
      go to 1830
1825  continue
      m5=m5+md5
1835  continue
      go to 9000
1830  continue
      icod22=0
      m22 =l22+(nn -1)*md22
      m22y=l22+(nnn-1)*md22
      if(istore(m12+2).lt.0) goto 1850
c--positional coordinates
      ncc=1
      ndd=1
      do i=1,3
      m22a=m22 +1+(ncc-1)*md22a
      m22z=m22y+1+(ndd-1)*md22a
      if(istore(m22a)+istore(m22z)) 1837,1837,1836
1836  continue
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1837,9050
1837  continue
      ncc=ncc+1
      ndd=ndd+1
      enddo
c--thermal parameters
      nn4=1
      if(iani1+iani2.eq.2) then
       nn4=6
       ncc=ncc+1
       ndd=ndd+1
      endif
      do i=1,nn4
      m22a=m22 +1+(ncc-1)*md22a
      m22z=m22y+1+(ndd-1)*md22a
      if(istore(m22a)+istore(m22z)) 1867,1867,1866
1866  continue
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1867,9050
1867  continue
      ncc=ncc+1
      ndd=ndd+1
      enddo
      goto 2001
c--4th kind of equiv directive	(atom1	atom2  p1)
1850  continue
      do i=1,3
      ndd=istore(m12+2+i)
      if(ndd.eq.1) then
      ncc=i
      m22a=m22 +1+(ncc-1)*md22a
      m22z=m22y+1+(ncc-1)*md22a
      if(istore(m22a)+istore(m22z)) 1857,1857,1856
1856  continue
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1857,9050
1857  continue
      endif
      enddo
      nn4=1
      j=4
      if(iani1+iani2.eq.2) then
       nn4=6
       j=5
      endif
      do  i=1,nn4
      ndd=istore(m12+2+j)
      if(ndd.eq.1) then
      ncc=j
      m22a=m22 +1+(ncc-1)*md22a
      m22z=m22y+1+(ncc-1)*md22a
      if(istore(m22a)+istore(m22z)) 1877,1877,1876
1876  continue
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1877,9050
1877  continue
      endif
      j=j+1
      enddo
      goto 2001
c
c--'ride'
1900  continue
      iaa=n22
      if(ista.eq.1) iaa=0
      ieq=1
      l51=m22x
      md51=2
      l52=l51+n5*md51
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1903,9000
1903  continue
      m51=l51
      n51=0
      m5=l5
      do 1904 n=1,n5
      if(jflg5(m5))1908,1908,1907
1907  continue
      istore(m51)=m5
      istore(m51+1)=n
c      write(ncwu,*) 'primo gruppo'
c      write(ncwu,1) istore(m5),n,m5
c 1    format(1x,a4,i5,i10)
      n51=n51+1
      m51=m51+md51
1908  continue
      m5=m5+md5
1904  continue
      call sclr5
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,1913,9000
1913  continue
      m52=l52
      n52=0
      m5=l5
      do 1914 n=1,n5
      if(jflg5(m5))1918,1918,1917
1917  continue
      istore(m52)=m5
      istore(m52+1)=n
c      write(ncwu,*) 'secondo gruppo'
c      write(ncwu,1) istore(m5),n,m5
      n52=n52+1
      m52=m52+md51
1918  continue
      m5=m5+md5
1914  continue
      i=jredf(temp,1)
      dm=temp(1)
      if(dm.lt.0.1) dm=1.2
      dm=dm*dm
      m51=l51
      do 1950 k=1,n51
      m5=istore(m51)
      nn=istore(m51+1)
      m22=l22+(nn-1)*md22
      m52=l52
      do 1940 j=1,n52
      m5a=istore(m52)
      temp(1)=store(m5+md5xyz  )-store(m5a+md5xyz  )
      temp(2)=store(m5+md5xyz+1)-store(m5a+md5xyz+1)
      temp(3)=store(m5+md5xyz+2)-store(m5a+md5xyz+2)
      dist=store(l1m1  )*temp(1)*temp(1)
     1    +store(l1m1+4)*temp(2)*temp(2)
     2    +store(l1m1+8)*temp(3)*temp(3)
     3    +store(l1m1+1)*temp(1)*temp(2)*2.0
     4    +store(l1m1+2)*temp(1)*temp(3)*2.0
     5    +store(l1m1+5)*temp(2)*temp(3)*2.0
      if(dist.gt.dm) goto 1939
      n=istore(m52+1)
      m22y=l22+(n-1)*md22
      ncc=1
      ndd=1
      do 1930 i=1,3
      m22a=m22+1+(ncc-1)*md22a
      m22z=m22y+1+(ndd-1)*md22a
c      write(ncwu,*) 'atomi n.:',nn,n
      icod22=1
      if(j22cm(iaa,m22a,m22z,nn,ncc,icod22)) 9050,1925,9050
1925  continue
      ncc=ncc+1
      ndd=ndd+1
1930  continue
1939  continue
      m52=m52+md51
1940  continue
      m51=m51+md51
1950  continue
      goto 2001
c
c--'dist' & 'angle' directive
2200  continue
      istore(m22d  )=ist-10
      istore(m22d+2)=jbb
      store (m22d+3)=store(m12+3)
      store (m22d+4)=store(m12+4)
      n25=2
      if(ist.eq.12) n25=3
      istore(m22d+5)=n25
      m25=m22d+6
      do j25=1,n25
      ix=1
      il50=0
      if(jfnd5(ix,il50)) 9000,2203,9000
2203  continue
      m5=l5
      do 2204 n=1,n5
      if(jflg5(m5))2208,2208,2207
2207  continue
      istore(m25)=n
      m25=m25+1
c      write(ncwu,1) istore(m5),n,m5,m25
c 1    format(1x,a2,i5,2i10)
      goto 2205
2208  continue
      m5=m5+md5
2204  continue
2205  continue
      call sclr5
      enddo
      istore(m22d+1)=6+n25
      m22dc=m22d
      m22d=m22d+istore(m22d+1)
      m22x=m22d
      goto 2001
c
c--'planar' directive
2300  continue
      istore(m22d  )=ist-10
      istore(m22d+2)=jbb
      store (m22d+3)=store(m12+3)
      store (m22d+4)=store(m12+4)
c--find the atoms
      l25=m22d+50000
      md25=11
      n25=0
      m25=l25
      if(jfr5(m25,n25,md25)) 9000,2302,9000
2302  continue
c     write(ncwu,*)' n25',n25
      if(n25.lt.3) goto 9000
      istore(m22d+5)=n25
      m=m22d+6
      m25=l25
      do i=1,n25
      istore(m)=istore(m25+9)
      m=m+1
      m25=m25+md25
      enddo
      istore(m22d+1)=6+n25
      m22dc=m22d
      m22d=m22d+istore(m22d+1)
      m22x=m22d
      goto 2001
c
c--'sum' directive
2400  continue
c      write(ncwu,*)'sum'
      istore(m22d  )=ist-10
      istore(m22d+2)=jbb
      store (m22d+3)= store(m12+3)
      store (m22d+4)= store(m12+4)
c--store the number of parameter(s)
      istore(m22d+5)=istore(m12+6)
c      write(ncwu,*)'frm22',(istore(m22d+mj-1),mj=1,6)
      m=m22d+7
      m1=m12+7
      kpar=istore(m22d+5)
      if(kpar.gt.0) then
c      write(ncwu,*)'kpar=',kpar
      do i=1,kpar
      istore(m)=istore(m1)
c      write(ncwu,*)istore(m1)
      m=m+1
      m1=m1+1
      enddo
      mmm=m22d+7+kpar
      else
c--deve esistere una scheda 'continue'
      mmm=m22d+7
      kpar=0
      endif
      if(istore(m12+5).eq.0) then
	n25=n5
	do i=1,n5
	 istore(mmm)=i
	 mmm=mmm+1
	enddo
       else
c--find the atoms
	l25=m22d+50000
	md25=11
	n25=0
	m25=l25
	if(jfr5(m25,n25,md25)) 9000,2402,9000
2402	continue
c	write(ncwu,*)' n25',n25
	m25=l25
	do i=1,n25
	 istore(mmm)=istore(m25+9)
c	 write(ncwu,*)mmm,istore(mmm)
	 mmm=mmm+1
	 m25=m25+md25
	enddo
       endif
c      write(ncwu,*)' n25,kpar',n25,kpar
      istore(m22d+6)=n25
      istore(m22d+1)=7+kpar+n25
c      mjf=istore(m22d+1)
c      write(ncwu,*)'istore(m22d+1)',istore(m22d+1)
c      write(ncwu,*)(istore(m22d+mj-1),mj=1,mjf)
      m22dc=m22d
      m22d=m22d+istore(m22d+1)
      m22x=m22d
      goto 2001
c
c--'continue' directive
2450  continue
c     write(ncwu,*)'continue'
      if(m22dc.eq.0) goto 9000
      m22d=m22dc
      istc =istore(m22d)
c--continuazione direttiva 'planar'
      if(istc.eq.3) then
c	write(ncwu,*) 'continue planar'
	n25=istore(m22d+5)
c	write(ncwu,*)' old n25',n25
	lll=m22d+6
	ll25=m22d+istore(m22d+1)+5000
	mmm =ll25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
c--find the atoms
	l25=m22d+50000
	md25=11
	n25=0
	m25=l25
	if(jfr5(m25,n25,md25)) 9000,2452,9000
2452	continue
c	write(ncwu,*)' new n25,l25',n25,l25
	m25=l25
	do i=1,n25
	  istore(mmm)=istore(m25+9)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  mmm=mmm+1
	  m25=m25+md25
	enddo
	mmm=m22d+6
	lll =ll25
	n25=istore(m22d+5)+n25
c	write(ncwu,*)' total n25',n25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,lll,istore(mmm)',mmm,lll,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
	istore(m22d+5)=n25
	istore(m22d+1)=6+n25
	mjf=istore(m22d+1)
c	write(ncwu,*)'istore(m22d+1)',istore(m22d+1)
c	write(ncwu,*)(istore(m22d+mj-1),mj=1,mjf)
	m22dc=m22d
	m22d=m22d+istore(m22d+1)
	m22x=m22d
	goto 2001
      endif
c--continuazione direttiva 'sum'
      if(istc.eq.4) then
c	write(ncwu,*) 'continue sum'
	n25=istore(m22d+6)
c	write(ncwu,*)' old n25',n25
	lll=m22d+7
	ll25=m22d+istore(m22d+1)+5000
	mmm =ll25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
c--find the atoms
	l25=m22d+50000
	md25=11
	n25=0
	m25=l25
	if(jfr5(m25,n25,md25)) 9000,2462,9000
2462	continue
c	write(ncwu,*)' new n25,l25',n25,l25
	m25=l25
	do i=1,n25
	  istore(mmm)=istore(m25+9)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  mmm=mmm+1
	  m25=m25+md25
	enddo
c--store the number of parameter(s)
	istore(m22d+5)=istore(m12+6)
c	write(ncwu,*)(istore(m22d+mj-1),mj=1,6)
	m=m22d+7
	m1=m12+7
	kpar=istore(m22d+5)
	if(kpar.gt.0) then
c	  write(ncwu,*)'kpar=',kpar
	  do i=1,kpar
	    istore(m)=istore(m1)
c	    write(ncwu,*)istore(m1)
	    m=m+1
	    m1=m1+1
	  enddo
	endif
	mmm=m22d+7+kpar
	lll =ll25
	n25=istore(m22d+6)+n25
c	write(ncwu,*)' total n25',n25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,lll,istore(mmm)',mmm,lll,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
c	write(ncwu,*)' n25,kpar',n25,kpar
	istore(m22d+6)=n25
	istore(m22d+1)=7+kpar+n25
	mjf=istore(m22d+1)
c	write(ncwu,*)'istore(m22d+1)',istore(m22d+1)
c	write(ncwu,*)(istore(m22d+mj-1),mj=1,mjf)
	m22dc=m22d
	m22d=m22d+istore(m22d+1)
	m22x=m22d
	goto 2001
      endif
c--continuazione direttiva 'limit'
      if(istc.eq.5) then
c	write(ncwu,*) 'continue limit'
	n25=istore(m22d+5)
c	write(ncwu,*)' old n25',n25
	lll=m22d+7
	ll25=m22d+istore(m22d+1)+5000
	mmm =ll25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
c--find the atoms
	l25=m22d+50000
	md25=11
	n25=0
	m25=l25
	if(jfr5(m25,n25,md25)) 9000,2472,9000
2472	continue
c	write(ncwu,*)' new n25,l25',n25,l25
	m25=l25
	do i=1,n25
	  istore(mmm)=istore(m25+9)
c	  write(ncwu,*)'mmm,istore(mmm)',mmm,istore(mmm)
	  mmm=mmm+1
	  m25=m25+md25
	enddo
	mmm=m22d+7
	lll =ll25
	n25=istore(m22d+5)+n25
c	write(ncwu,*)' total n25',n25
	do i=1,n25
	  istore(mmm)=istore(lll)
c	  write(ncwu,*)'mmm,lll,istore(mmm)',mmm,lll,istore(mmm)
	  lll =lll +1
	  mmm=mmm+1
	enddo
	istore(m22d+6)=n25
	istore(m22d+1)=7+n25
	mjf=istore(m22d+1)
c	write(ncwu,*)'istore(m22d+1)',istore(m22d+1)
c	write(ncwu,*)(istore(m22d+mj-1),mj=1,mjf)
	m22dc=m22d
	m22d=m22d+istore(m22d+1)
	m22x=m22d
	goto 2001
      endif
      goto 9100
c
c--'limit' directive
2500  continue
      istore(m22d  )=5
      istore(m22d+2)=jbb
      store (m22d+3)=store(m12+3)
      store (m22d+4)=store(m12+4)
      store (m22d+5)=store(m12+5)
c--find the atoms
      l25=m22d+50000
      md25=11
      n25=0
      m25=l25
      if(jfr5(m25,n25,md25)) 9000,2502,9000
2502  continue
c      write(ncwu,*)' n25',n25
      istore(m22d+6)=n25
      m=m22d+7
      m25=l25
      do i=1,n25
      istore(m)=istore(m25+9)
c	  write(ncwu,*)'m,istore(m)',m,istore(m)
      m=m+1
      m25=m25+md25
      enddo
      istore(m22d+1)=7+n25
      m22dc=m22d
      m22d=m22d+istore(m22d+1)
      m22x=m22d
      goto 2001
c
c--common branch
2001  continue
      do i=1,4
      if(iover12(i).eq.jbb) iover22(i)=n22
      enddo
      m12=m12+md12
2000  continue
c--end of loop on n12 directives
2100  continue
      if(ista.eq.1) n22=n22+1
      store(nfl+6)=n22
      store(nfl+7)=ieq
      store(nfl+8)=iwe
      if(iover22(1).eq.0) then
      if(ista.le.2) iover22(1)=n22
      endif
      if(iover22(2).eq.0) then
      if(ista.eq.1) iover22(2)=n22
      endif
      if(iover22(2).ne.0) then
      if(iover22(1).ne.iover22(2)) goto 9020
      endif
      do i=1,4
      store(nfl+16+i-1)=iover22(i)
      enddo
      m22 = m22x
      j=m22 -nfl
      call xfrml(22,j)
      return
9000  continue
      ier=1
      go to 9100
9020  continue
      ier=2
      goto 9100
9050  continue
      ier=3
9100  continue
      jfr22=-1
      return
      end
c                                                                       
code for j22cm
      function j22cm(ia,m22a,m22z,nn,ncc,icod22)
c--insert equivalence code
c  ia	 =n    number of block
c         0    direttiva diag (richiede che i parametri siano 
c              esplicitamente indicati da affinare , almeno uno)
c  icod22=0  normal equiv directive
c         1  ride directive
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
c      m=m22a
c      mm=m22z
c      do i=1,5
c      write(*,*)'code0(ia)',ia,i,istore(m),istore(mm)
c      m=m+1
c      mm=mm+1
c      enddo
      j22cm=0
c--check the number block of the paramaters
      if(istore(m22z)+istore(m22a)) 1750,1750,1755
1750  continue
      if(ia.eq.0) goto 9050
      istore(m22z)=ia
      istore(m22a)=ia
      goto 1758
1755  continue
      if(istore(m22z).eq.0) istore(m22z)=istore(m22a)
      if(istore(m22a).eq.0) istore(m22a)=istore(m22z)
      if(istore(m22z).ne.istore(m22a))goto 9050
c--check equivalenced parameters
1758  continue
      if(istore(m22a+3)) 1760,1760,1790
1760  continue
      if(istore(m22z+3)) 1765,1765,1780
1765  continue
      istore(m22z+3)=nn
      istore(m22z+4)=ncc
      goto 1800
1780  continue
      if(icod22) 1781,1781,1800
1781  continue
      istore(m22a+3)=istore(m22z+3)
      istore(m22a+4)=istore(m22z+4)
      goto 1800
1790  continue
      if(istore(m22z+3)) 1795,1795,9050
1795  continue
      istore(m22z+3)=istore(m22a+3)
      istore(m22z+4)=istore(m22a+4)
c--normal exit
1800  continue
c      m=m22a
c      mm=m22z
c      do i=1,5
c	write(*,*)'code1(ia)',ia,i,istore(m),istore(mm)
c      m=m+1
c      mm=mm+1
c      enddo
      return
c--error exit
9050  continue
      if(icod22) 9051,9051,1800
9051  continue
c      m=m22a
c      mm=m22z
c      do i=1,5
c      write(*,*)'codex',i,istore(m),istore(mm)
c      m=m+1
c      mm=mm+1
c      enddo
      j22cm=-1
      return
      end
c
code for jfn22                                                          
      function jfn22(nca,ia,iy,ix)
c--insert the requested code
c
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst12/l12,m12,md12,n12,nbl12,idra,idrb,l12d,n12d,
     2	n12c,md12b,iover12(4)
      common/lst22/ l22,m22,md22,n22,l22a,m22a,md22a,n22a,
     1 l22b,m22b,md22b,n22b,l22c,m22c,md22c,n22c,l22d,m22d,md22d,n22d,
     2 iflorg,ieq,iwe,in14,iover22(4),iadov22(4)
c
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c
      jfn22=0
      nn1=in14-10
c--check se sono indicati tutti gli atomi (nca=0)
      if(nca.eq.0) then
	m5=l5
	do i=1,n5+n5g
	  store(m5+44)=1.0
	  m5=m5+md5
	enddo
      else
c--sono indicati gli atomi
	il50=0
	ixxx=jfnd5(ix,il50)
c	write(*,*) 'ixxx=',ixxx
	if(ixxx.ne.0) goto 1200
      endif
      m5=l5                                                             
      m22=l22                                                           
      do n=1,n5
	m22c=m22+1
	if(jflg5(m5).gt.0) then
	  ia=ia+iy
	  m=m12+3
	  do k=1,3
	    if(istore(m).eq.1)istore(m22c)=ia
	    m=m+1
	    m22c=m22c+md22a
	  enddo
	  if(store(m5+10).eq.0.0) then
	    if(istore(m).eq.1)istore(m22c)=ia
	  else
	    m=m+1
	    m22c=m22c+md22a
	    do k=1,6
	      if(istore(m).eq.1) istore(m22c)=ia
	      m=m+1
	      m22c=m22c+md22a
	    enddo
	  endif
	  m22c=m22+1+10*md22a
	  m=m12+13
	  do k=1,nn1
	    if(istore(m).eq.1)istore(m22c)=ia
	    m=m+1
	    m22c=m22c+md22a
	  enddo
	endif
	m5=m5+md5
	m22=m22+md22
      enddo
      if(n5g.gt.0) then
      do n=1,n5g
	m22c=m22+1
	if(jflg5(m5).gt.0) then
	  ia=ia+iy
	  m=m12+3
	  do k=1,7
	    if(istore(m).eq.1)istore(m22c)=ia
	    m=m+1
	    m22c=m22c+md22a
	  enddo
	  m22c=m22+1+10*md22a
	  m=m12+13
	  if(istore(m).eq.1)istore(m22c)=ia
	endif
	m5=m5+md5
	m22=m22+md22
      enddo
      endif
      return
1200  continue                                                          
      jfn22=ixxx
      return                                                            
      end                                                               
c
code for frm16
      subroutine frm16(lin)
c--form list 16, set(s) of phases
c
c  lin  logical unit of scratch file
c--the common variables are used as follow
c-- m16  current address
c-- m16d number of words per set
c-- n16  number of set's
c-- n16p lenght of preamble block
c-- n16r relative address of the cfom
c-- l16  address on disc of the first set
c
      common/lst07/l7,l7a,l7d,ld7p,m7,m7dk,n7dk,md7d,n7d,n7,n7p,
     2 l7rs,l7rk,l7in,l7f,l7e,l7p,n7f,n7dd,ks1,ks2,ks3,sys07
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension cfom(200)
c--read the 4th record
      read(unit=lin,rec=4) nset,(cfom(j),j=1,nset)
      in=16
      call xxcln(in)
      l16p=nfl
      md16d=5
      m16d=1
      n16r=15
      n16=nset
      numb=n7f
      n16p=n16r+nset
      lj=nfl+n16p-1
      do 1000 i=nfl+5,lj
1000  store(i)=0.0
      store(nfl+5)= md16d
      store(nfl+6)= m16d
      store(nfl+7)= numb
      store(nfl+8)= n16r
      store(nfl+9)= n16p
      store(nfl+10)=nset
      m=n16r+nfl
      do 1010 i=1,nset
      store(m)=cfom(i)
1010  m=m+1
      n16k=numb*m16d+md16d
      ln=n16p+n16k*nset
      call sowl(ln,in,lsn,ld16p,lk,lm,lj)
      store(nfl+2)=lsn
      call xup(ld16p,istore(l16p),n16p)
      llw=ld16p+ln-1
      call swlin(16,lsn,ld16p,llw,n16p,ln)
      l16=ld16p+n16p
c--read from scratch file
      l16a=nfl+n16p
      l16k=l16a+5
      l16b=l16k+numb
      l16c=l16b+numb
      do 1020 k=1,nset
      l=k*2+3
      read(unit=lin,rec=l) (store(j),j=l16a,l16a+md16d-1),
     1 (store(j),j=l16b,l16b+numb-1)
      read(unit=lin,rec=l+1) (istore(j),j=l16c,l16c+numb-1)
      m16k=l16k
      m16b=l16b
      m16c=l16c
      do 2000 i=1,numb
      idum=int(store(m16b)*1000)
      istore(m16k  )=istore(m16c)*10000+idum
      m16k=m16k+1
      m16b=m16b+1
      m16c=m16c+1
2000  continue
      call xup(l16,istore(l16a),n16k)
      l16=l16+n16k
1020  continue
      call xdump
      return
      end
c
code for sfl16
      subroutine sfl16(cfom,nset)
c--load list 16 (set of phases)
c
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension cfom(1)
c--load the preamble of list 16
      inm=16
      call srlin(inm,li,ld16p,lk,ln,lm)
      n16p=ln
      l16p=nfl
      call srdls(inm,l,l16p,lj)
      md16d= store(l16p+5)
      m16d = store(l16p+6)
      numb = store(l16p+7)
      n16r = store(l16p+8)
      n16p = store(l16p+9)
      nset = store(l16p+10)
      n16=nset
      m=n16r+l16p
      do 1010 i=1,nset
      cfom(i)=store(m)
1010  m=m+1
      n16k=numb*m16d+md16d
      l16    =ld16p+n16p
      l16a=l16p+n16p
      l16k=l16a+md16d
      nfl=l16a+n16k
      return
      end
c
code for snr16
      subroutine snr16(it,fig,ww,iph)
c--load a set of phases
c
c  it = number of set
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
      dimension ww(1),iph(1),fig(1)
c--
      l16d=l16+(it-1)*n16k
      call xdwn(l16d,istore(l16a),n16k)
c--unpack the values
      m=l16a
      do 1000 i=1,md16d
      fig(i)=store(m)
1000  m=m+1
      m16k=l16k
      do 2000 i=1,numb
      idum=istore(m16k)/10000
      idum1=istore(m16k)-idum*10000
      ww(i)=float(idum1)/1000.0
      iph(i)=idum
      m16k=m16k+1
2000  continue
      return
      end
c
code for sup16
      subroutine sup16(cfom)
c--upadte list 16
c
      common/lst16/l16,ld16p,m16,m16d,md16d,n16,n16p,l16p
     1 ,l16a,l16k,n16k,numb
      integer*4 nfl,nl,nflmx,nlmx
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence(istore,store)
      dimension cfom(1)
c--
      l16p=nfl
      call srdls(16,li,l16p,l)
      n16r = store(l16p+8)
      n16p = store(l16p+9)
      nset = store(l16p+10)
      m=n16r+nfl
      do 1010 i=1,nset
      store(m)=cfom(i)
1010  m=m+1
      l=n16p
      call srlin(16,lsn,ln,llw,l,ll)
      call xup(ln,istore(l16p),n16p)
      call xdump
      return
      end
c
code for xplot
      subroutine xplot(ncwu,l1,n2,n3,nd,n4,n5,ifit)
c--plot routine
c  ifit=0 non interpolo
c	1 interpolo
c  ncwu  printer logical unit
c  l1    address in store of the first set of coordinates
c  n2    number of points
c  n3    number of sets of points
c  nd    number of words per each point
c  n4    vector contains the characters
c  n5    vector contains the name(s)
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)
c--
      dimension istrip(101),asc(11),n4(*),n5(*)
      dimension r(4),t(4),a(4),ixy(2),its(6)
      data ib/2h  /,ic/1hx/,ixy/2hy ,2hx /,iug/2h =/,iugs/2h)=/
      data ipa/2h( /
c--
      write(ncwu,991)
 991  format(1h )
      l1b=l1
      n2b=n2*n3
      fx1=store(l1b)
      fx2=store(l1b)
      fy1=store(l1b+1)
      fy2=store(l1b+1)
      do 1000 n=1,n2b
      e=store(l1b)
      f=store(l1b+1)
      fx1=amin1(fx1,e)
      fx2=amax1(fx2,e)
      fy1=amin1(fy1,f)
      fy2=amax1(fy2,f)
      l1b=l1b+nd
 1000 continue
      xoriz=50.
      yvert=25.
      noriz=50
      nvert=25
      dif=fy2-fy1
      sc1=xoriz/dif
      dif=fx2-fx1
      sc2=yvert/dif
      rsc1=1./sc1
      rsc2=1./sc2
      asc(1)=fy1
      npoint=noriz/10+1
      do 1100 i=1,npoint
      asc(i)=asc(1)+10.*(i-1)*rsc1
 1100 continue
      write(ncwu,1101)(asc(i),i=1,npoint)
 1101 format(4x,11f10.3)
      write(ncwu,1102)
 1102 format(2x,6(9x,1h*))
      write(ncwu,1103)
 1103 format(8x,57(1h*))
      write(ncwu,1104)
 1104 format(8x,1h*,55x,1h*)
      write(ncwu,1104)
c--controllo titolo
      jj=1
      jjj=1
      jj1=1
      j1=4
c--loop analogo normal
      if(ifit.eq.0) then
	n2b=n2
       else
	n2b=n2-2
      endif
      j=1
      q=fx1
      do m=1,nvert+1
	do i=1,noriz+1
	 istrip(i)=ib
	enddo
	if(ifit.eq.0)then
	  l1bx=l1+(j-1)*nd
	  l1bxa=l1bx
	  j=j+1
	 else
	  if(j.eq.1) go to 1500
	  if(j.eq.n2b) go to 1515
	  l1b=l1+j*nd
	  if(q.lt.store(l1b)) go to 1515
1500	  continue
	  j=j+1
	  l1ba=l1+(j-2)*nd
	  l1bx=l1ba
	  do k=1,4
	   r(k)=store(l1bx)
	   l1bx=l1bx+nd
	  enddo
1515	  continue
	  l1bx=l1ba
	endif
	do n=1,n3
	  if(ifit.eq.0) then
	    al=(store(l1bx+1)-fy1)*sc1
	  else
	    l1bb=l1bx
	    do k=1,4
	      t(k)=store(l1bb+1)
	      l1bb=l1bb+nd
	    enddo
	    call xfit (r,t,a)
	    al=(a(4)+q*(a(3)+q*(a(2)+q*a(1)))-fy1)*sc1
	  endif
	  if(al.gt.noriz+2) al=noriz+2
	  il=al+1
	  if(il.gt.noriz+1) il=noriz+1
	  if(il.lt.1) il=1
	  if(istrip(il).eq.ib) go to 1540
	  ia=ic
	  go to 1560
1540	  continue
	  ia=n4(n)
1560	  continue
	  istrip(il)=ia
	  l1bx=l1bx+n2*nd
	enddo
c--controllo titolo
	if(jj1.gt.2) go to 1430
	its(1)=ib
	its(2)=ixy(jj1)
	its(3)=iug
	jj1=jj1+1
	go to 1440
1430	continue
	if(jj.gt.n3) go to 1400
	its(1)=ipa
	its(2)=n4(jj)
	its(3)=iugs
	jj=jj+1
1440	continue
	its(4)=n5(jjj  )
	its(5)=n5(jjj+1)
	its(6)=n5(jjj+2)
	jjj=jjj+3
	go to 1420
1400	continue
	do i=1,6
	 its(i)=ib
	enddo
1420	continue
	j1=j1+1
	if(j1-5.eq.0) then
	q1=q
	if(ifit.eq.0) q1=store(l1bxa)
	if(q1.ge.100) then
	write(ncwu,1252) q1 ,(istrip(i),i=1,noriz+1)
     1	 ,(its(i),i=1,6)
 1252	format(1x,f6.2,2h**,2x,51a1,2x,2h**,1x,6a2)
	else
	write(ncwu,1251) q1 ,(istrip(i),i=1,noriz+1)
     1	 ,(its(i),i=1,6)
 1251	format(1x,f6.3,2h**,2x,51a1,2x,2h**,1x,6a2)
	endif
	j1=0
	else
	write(ncwu,1301)(istrip(i),i=1,noriz+1)
     1	 ,(its(i),i=1,6)
 1301	format(8x,1h*,2x,51a1,2x,1h*,2x,6a2)
	endif
	q  =q  +rsc2
      enddo
      write(ncwu,1104)
      write(ncwu,1104)
      write(ncwu,1103)
      write(ncwu,1102)
      write(ncwu,991)
      return
      end
c
code for xfit
      subroutine xfit (r,t,a)
c--fit curve to y = a1*rho**3 +a2*rho**2 +a3*rho +a4
c
      dimension r(4),t(4),a(4)
c--
      b2=r(4)*(r(4)+r(1))
      b1=(t(4)-t(1))/(r(4)-r(1))
      c31=(t(2)-t(1))/(r(2)-r(1))-b1
      c32=(t(3)-t(1))/(r(3)-r(1))-b1
      c11= r(2)     *(r(2)+r(1))-b2
      c12= r(3)     *(r(3)+r(1))-b2
      c21= r(2)-r(4)
      c22= r(3)-r(4)
      a(1)=(c31*c22-c32*c21)/(c22*c11-c12*c21)
      a(2)=(c31-c11*a(1))/c21
      a(3)=b1-(r(4)*r(4)+r(1)*r(1)+r(4)*r(1))*a(1)
     1  -(r(4)+r(1))*a(2)
      a(4)=t(1)-r(1)*(a(3)+r(1)*(a(2)+r(1)*a(1)))
      return
      end
c
code for kinv2
      function kinv2(n,a,b,na,nm,c,d,nc)
c--matrix inversion and solution of simultaneous linear equations
c
c  n       order of the matices to be inverted.
c  a       matrix to be inverted  i.e. a(n,n)
c  b       inverse matrix  -  calculated by this subroutine  -  b(n,n)
c  na      the order of 'a' and 'b'  -  greater than or equal
c          to 'n*n'.
c  nm      number of column vectors to be multiplied onto the inverse
c          matrix
c  c       column vectors to be multiplied onto the inverse matrix c(n,m
c  d       results of multiplication on to the inverse matrix  -  d(n,m)
c  nc      the order of 'c' and 'd'  -  greater than or equal
c          to the maximum of 'n' and 'n*nm'. this means that a column
c          vector at least must be provided for both.
c
c--in matrix notation
c
c  d=b.c
c  c=a.d
c
c--return values of 'kinv2' are :
c
c   0  inversion etc. went okay.
c  >0  singular  -  return value indicates first signular element found.
c
c--
      double precision  x02abf,dummy
c
      dimension a(na),b(na),c(nc),d(nc)
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c
      data asing/0.0/,bsing/0.0/,csing/0.0/,e/0.0/,f/0.0/
      data m1/0/,m2/0/,m3/0/,m4/0/,m5/0/,m6/0/,m7/0/,m8/0/
      data i/0/,j/0/,k/0/,l/0/,m/0/
      data dummy/0.2d1/
c
      kinv2=0
c--set 'eps', such that 'eps' is the smallest number for 1.0+eps>1.0
      bsing=16.0**(-5)
c--set the smallest number that can be exactly represented on the machin
      x02abf=dummy**(-34)
      csing=sngl(x02abf)
c--set the singularity check limits
      csing=csing/bsing
      bsing=bsing*16.
c--set row interchange flags
      do 1000 i=1,n
      d(i)=float(i)
1000  continue
c--commence decomposition a=l.u  -  by rows with interchanges
      m5=1
      m6=1
      m1=m5
      m2=m6
      do 1100 i=1,n
      do 1050 j=1,n
      b(m2)=a(m1)
      m1=m1+1
      m2=m2+1
1050  continue
1100  continue
      m8=1
      do 1900 joj=1,n
      j=joj
      m2=m6
      m7=m8
      f=-1.
      l=j-1
c--calculate the l part , except for the division by u(i,i)
      do 1450 i=j,n
      e=b(m2)
      asing=bsing*abs(e)
      if(l)1250,1250,1150
1150  continue
      m3=i
      m4=m7
      do 1200 k=1,l
      e=e-b(m3)*b(m4)
      m3=m3+n
      m4=m4+1
1200  continue
c--transfer to the b array and check for the maximum value
1250  continue
      b(m2)=e
      m2=m2+1
      if(f-abs(e))1300,1450,1450
c--this is the current maximum
1300  continue
      f=abs(e)
      m=i
      d(m)=abs(d(m))
c--check singularity for this element
      if(asing-f)1350,1400,1400
1350  continue
      if(csing-f)1450,1400,1400
1400  continue
      d(m)=-d(m)
1450  continue
c--check if the maximum value is indicated as singular
      if(d(m))1500,1500,1550
1500  continue
      kinv2=j
      goto 3100
c--interchange rows
1550  continue
      call xint2(n,b,na,d,nc,j,m,n)
      e=1./b(m6)
      b(m6)=e
      if(j-n)1600,1900,1600
1600  continue
      m=j+1
      m3=m6+1
      do 1650 i=m,n
      b(m3)=b(m3)*e
      m3=m3+1
1650  continue
      if(l)1850,1850,1700
c--complete calculation of u
1700  continue
      m2=m6+n
      m7=m7+n
      do 1800 i=m,n
      m3=j
      m4=m7
      do 1750 k=1,l
      b(m2)=b(m2)-b(m3)*b(m4)
      m3=m3+n
      m4=m4+1
1750  continue
      m2=m2+n
      m7=m7+n
1800  continue
c--update various flags
1850  continue
      m6=m6+n+1
      m8=m8+n
1900  continue
c--decomposition ends.
c
c--invert the lower triangular matrix l
      m5=2
c--process by rows
      do 2150 i=2,n
      m4=m5
c--process by columns
      do 2100 j=i,n
      b(m5)=-b(m5)
      k=j-i
      if(k)2050,2050,1950
1950  continue
      m1=m5+n
      m2=m4
      do 2000 l=1,k
      b(m5)=b(m5)-b(m1)*b(m2)
      m1=m1+n
      m2=m2+1
2000  continue
2050  continue
      m5=m5+1
2100  continue
      m5=m5+i
2150  continue
c
c--invert the upper triangular matrix u
      m5=n*n-1
      do 2300 i=2,n
      m4=m5+1
      do 2250 j=i,n
      k=j-i+1
      m1=m5
      m2=m4
      e=0.
      do 2200 l=1,k
      e=e-b(m1)*b(m2)
      m1=m1-n
      m2=m2-1
2200  continue
      b(m5)=e*b(m1)
      m5=m5-1
2250  continue
      m5=m5-i
2300  continue
c
c--assembly of the final matrix  -  still with rows interchanged
      m5=1
      do 2700 j=1,n
      m3=m5+n
      m4=m5+j
      do 2650 i=1,n
      m1=m3
      m2=m4
      if(i-j)2350,2350,2400
2350  continue
      e=b(m5)
      m3=m3+1
      k=n-j
      goto 2450
2400  continue
      e=0.
      m3=m3+n+1
      m4=m4+1
      k=n-i+1
2450  continue
      if(k)2600,2600,2500
2500  continue
      do 2550 l=1,k
      e=e+b(m1)*b(m2)
      m1=m1+n
      m2=m2+1
2550  continue
2600  continue
      b(m5)=e
      m5=m5+1
2650  continue
2700  continue
c--assembly ends.
c
c--sort out the interchanges and store final inverse matrix
      do 2850 ioi=1,n
      do 2800 joj=1,n
      i=ioi
      j=joj
      k=nint(d(j))
      if(k-i)2800,2750,2800
2750  continue
      call xint2(n,b,na,d,nc,i,j,1)
      goto 2850
2800  continue
      write(ncwu,2830)
2830  format(15h inverter fails  )
c     call xerhnd ( iersev )
      kinv2=1
      goto 3100
2850  continue
c--final assembly ends.
c
c--solve the given equations if any
      if(nm)3100,3100,2900
2900  m3=1
      m4=1
      do 3050 i=1,nm
      do 3000 j=1,n
      m1=j
      m2=m3
      d(m4)=0.
      do 2950 k=1,n
      d(m4)=d(m4)+b(m1)*c(m2)
      m1=m1+n
2950  m2=m2+1
3000  m4=m4+1
3050  m3=m3+n
c
3100  return
      end
c
code for xint2
      subroutine xint2(n,b,nb,d,nd,j,k,itype)
c--interchanges either rows or columns j and k
c--the type of interchange is determinated by 'itype' :
c  1  columns.
c  2  rows.
c--
      dimension b(nb),d(nd)
      data i/0/,l/0/,m/0/
      data f/0.0/
      if(j-k)1000,1100,1000
1000  continue
      l=(j-1)*(n/itype)+1
      m=(k-1)*(n/itype)+1
      f=d(j)
      d(j)=d(k)
      d(k)=f
      do 1050 i=1,n
      f=b(l)
      b(l)=b(m)
      b(m)=f
      l=l+itype
      m=m+itype
1050  continue
1100  continue
      return
      end
c                                                                       
code for vec                                                            
      function vec(x)                                                   
      vec    = amin1(((0.0106 * x - 0.1304) * x + 0.5658) * x, 1.0)     
      return                                                            
      end                                                               
c
code for crea19
      subroutine crea19
c--crea list 19  (diffractometer data)
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      iuber=2
      dcf=21.0
      resolx=0.0
      ireftotx=0
      do k=1,3
      ihgo(k)=0
      do i=1,3
      om(k,i)=0.0
      if(k.eq.i) om(k,i)=1.0
      oms(k,i)=0.0
      if(k.eq.i) oms(k,i)=1.0
      enddo
      do i=1,2
      indix(i,k)=0
      enddo
      enddo
      do k=1,2
      xypol(k)=0.0
      thetax(k)=0.0
      psical(k)=0.0
      fical(k)=0.0
      enddo
      do k=1,4
      anggo(k)=0.0
      zang0(k)=0.0
      do i=1,2
      angcal(i,k)=0.0
      enddo
      enddo
      nstack=100
      do i=1,nstack
      numr(i)=i
      icd(100)=0
      do j=1,3
      ihkl(j,i)=0
      fhkl(j,i)=0.0
      enddo
      do j=1,4
      angref(j,i)=0.0
      enddo
      xpol(i)=0.0
      ypol(i)=0.0
      intref(i)=0
      enddo
      call frm19
      return
      end
c
code for frm19
      subroutine frm19
c--write list 19 on disk (diffractometer data)
c
c  l19	location of the first parameter in  store
c  n19	number of parameter
c  md19 number of words for parameter
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      l19d=nfl
      kn=19
      npre19=13
      md19=1
      n19=1600
      call xxcln(kn)
      store(nfl+5)=npre19
      store(nfl+6)=md19
      store(nfl+7)=n19
      store(nfl+8)=0
      l19=nfl + npre19
      m19=l19
      do k=1,n19
      store(m19)=stor19(k)
      m19=m19+1
      enddo
      n19d=m19-l19d
      call xfrml(kn,n19d)
      call xdump
      return
      end
c
code for sfl19
      subroutine sfl19
c--form absolute list 19  (diffractometer data)
c
c  l19	location of the first parameter in  store
c  n19	number of parameter
c  md19 number of words for parameter
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      call sldl(19,li,l19d,lj)
      md19=store(l19d+6)
      n19 =store(l19d+7)
      l19 =store(l19d+5)+l19d
      call srlin(19,lsn,li,lj,lk,ll)
      n19d=ll
c--
      m19=l19
      do k=1,n19
      stor19(k)=store(m19)
      m19=m19+1
      enddo
      return
      end
c
code for crea29
      subroutine crea29
c--crea list 29  (some data for CIF file)
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      noce=25
      ceth(1)=15
      ceth(2)=30
      tmnx(1)=.98
      tmnx(2)=1.0
      nstand=3
      ncount=97
      do i=1,nstand
      do n=1,3
      istand(n,i)=n
      enddo
      enddo
      do n=1,3
      size(n)=.25
      enddo
      ntotale=10000
      averr=0.05
      uneti=0.1
      call frm29
      return
      end
c
code for frm29
      subroutine frm29
c--write list 29 on disk  (some data for CIF file)
c
c  l29	location of the first parameter in  store
c  n29	number of parameter
c  md29 number of words for parameter
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      l29d=nfl
      kn=29
      npre29=13
      md29=1
      n29=31
      call xxcln(kn)
      store(nfl+5)=npre29
      store(nfl+6)=md29
      store(nfl+7)=n29
      store(nfl+8)=0
      l29=nfl + npre29
      m29=l29
      do k=1,n29
      store(m29)=stor29(k)
      m29=m29+1
      enddo
      n29d=m29-l29d
      call xfrml(kn,n29d)
      call xdump
      return
      end
c
code for sfl29
      subroutine sfl29
c--form absolute list 29  (some data for CIF file)
c
c  l29	location of the first parameter in  store
c  n29	number of parameter
c  md29 number of words for parameter
c
      include 'diffrat.inc'
      common/ylimi/nfl,lfl,nl,nflmx,lflmx,nlmx,idummy(1)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
c--
      common/xdata/store(1000000)
      dimension   istore(1000000)
      equivalence (istore,store)
c--
      call sldl(29,li,l29d,lj)
      md29=store(l29d+6)
      n29 =store(l29d+7)
      l29 =store(l29d+5)+l29d
      call srlin(29,lsn,li,lj,lk,ll)
      n29d=ll
c--
      m29=l29
      do k=1,n29
      stor29(k)=store(m29)
      m29=m29+1
      enddo
      return
      end
