c
code for stati
      subroutine stati
c--dummy routine to identify the module
      return
      end
c
code for snorx
      subroutine snorx
c--normalization routine
c--
      include 'li6com.inc'
c--
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      call slist
      if(ista1(in).eq.0) then
c--calculate the wilson plot
      call xnora
      sc=gmed
      bt=bmed
c--rewrite the preamble block
c      if(iparz.ne.1) then
       call wpre6
c	endif
      endif
      return
      end
c
code for ista1
      function ista1(in)
c--read directives for statistical program
c--
c  ha(i)  a,c,d,(b)  constants of the 'sharpening' function
c  hg(1)  scale from user
c  hg(2)  b(iso) from user
c  hg(3)  e maximum  (20.0 default value)
c  sm     (sin(t)/l)***3 minimum
c  ds     max-min difference of (sin(t)/l)***3
c  fs     intervals*2    (20 default value)
c  m1m    intervals*2    (20 default value)
c  iuse    0  use only the observed reflections
c         +1  use all the reflections
c  iem    -1  'm' calculation                                           
c          0  wilson plot only                                          
c         +1  'e' calculation                                           
c  ista   -1  only statistic is requested
c          0  do not statistic
c          1  statistic is requested (default)
c  idby   0/1   debye curve no/ requested                               
c  ie21   output (e**2-1) into fc position                              
c  ikb    -1  e's from user's k(s)-curve                                
c          0  e's from scale and b(iso)                                 
c          +1  e's from observed k(s)-curve                             
c  inor   -1  renormalize                                               
c          0  do not normalize                                          
c         +1  normalize                                                 
c  iall   -1  normalize on sin(t)/l range                               
c          0      ''    on class or on parity                           
c         +1      ''    all the reflections                             
c  iclp    0      ''    on class                                        
c         +1      ''    on parity                                       
c  igroup  0      ''    all the class or all the parity                 
c          n  which group has to be normalized                          
c  e2m    value of the (e**2)   (1.0  default value)                    
c  iparz   0  unknown structure                                         
c         +1  partial known structure                                   
c--
      include 'li6com.inc'
c
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,    
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti                       
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173                                            
      common /form/ gis(142),giw(142),gisa(142),giwa(142)
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcard/nch,image(80),nc,nd,ni,nt,na(3),ncd,idoc(20),irs(4)  
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      dimension itarg(16)                                               
      dimension inorm(5),iclas(2,5),ipari(2,9)                          
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data nat/16/
      data nnor/5/,ncls/5/,npar/9/
      data itarg/4hinte,4honly,4he   ,4hdeby,4hnorm,
     1		 4hreno,4hscal,4hb   ,4hemax,4hk(s),
     2		 4hwils,4hweak,4hstat,4hshar,4hpart,
     3		 4hend /
      data inorm/4hthet,4hall ,4hclas,4hpari,4hno  /
      data iclas(1,1)/2hal/                                             
      data iclas(2,1)/2hl /                                             
      data iclas(1,2)/2hhk/                                             
      data iclas(2,2)/2hl /                                             
      data iclas(1,3)/2h0k/                                            
      data iclas(2,3)/2hl /                                             
      data iclas(1,4)/2hh0/                                             
      data iclas(2,4)/2hl /                                             
      data iclas(1,5)/2hhk/                                             
      data iclas(2,5)/2h0 /                                             
      data ipari(1,1)/2hal/                                             
      data ipari(2,1)/2hl /                                             
      data ipari(1,2)/2hgg/                                            
      data ipari(2,2)/2hg /                                             
      data ipari(1,3)/2hgg/                                             
      data ipari(2,3)/2hu /                                             
      data ipari(1,4)/2hgu/                                             
      data ipari(2,4)/2hg /                                             
      data ipari(1,5)/2hgu/                                             
      data ipari(2,5)/2hu /                                             
      data ipari(1,6)/2hug/                                             
      data ipari(2,6)/2hg /                                             
      data ipari(1,7)/2hug/                                             
      data ipari(2,7)/2hu /                                             
      data ipari(1,8)/2huu/                                             
      data ipari(2,8)/2hg /                                             
      data ipari(1,9)/2huu/                                             
      data ipari(2,9)/2hu /                                             
c--                                                                     
      data ionly/4honly/                                                  
c--                                                                     
      ista1=0
c--check the cell content
      m3=l3
      a=0.0
      do i=1,n3
      a=a+store(m3+12)
      m3=m3+md3
      enddo
      if(a.lt.0.5) goto 9100
      iscal=0
      n17o=0
      gmed=1.0
      bmed=1.0
      e2m=1.0
      iparz=0
      jh=0
      iuse=0
      inor=1
      iem=1
      ie21=0
      hg(1)=0.0
      hg(2)=0.0
      hg(3)=20.0
      ja=2*n6*n2
      jb=1000
1020  continue
      n1m=ja/jb
      if(n1m.gt.15) go to 1010
      jb=jb-50
      if(jb.gt.0) goto 1020
      write(ncwu,1025)
1025  format(' warning! the program is unable to define the'
     1 ,' intervals')
      call xerr
1010  continue
      fs=n1m
      ikb=0
      idby=1
      iall=1                                                            
      ista=1                                                            
      if(idefa(i)) 1000,1000,9000                                       
1000  continue                                                          
      call sty(iarg)
c                                                                       
c--main loop for processing input instructions                          
c--fetch the next card                                                  
 2000 continue                                                          
      if(klnc(2)) 9000,2020,9000
c-- card to be interpreted                                              
 2020 continue                                                          
      call xpcci                                                        
      if(jrca(itemp,n)) 2060,2040,2060                                  
c--process the directive                                                
 2040 continue                                                          
      n=kcomp(1,itemp,itarg,nat,1)                                      
      if(n) 2060,2060,2050                                              
 2050 continue                                                          
      go to (2100,2110,2200,2300,2400,2500,2600,2700,2800,2900,         
     2 2950,3000,3100,3200,3300,9000,2060),n                            
2060  continue                                                          
      call xunkw                                                        
      go to 2000                                                        
c                                                                       
c--'intervals' directive                                                
 2100 continue                                                          
      j=kredi(i)
      if(j.gt.0) n1m=j
      fs=float(n1m)                                                     
      jh=kredi(i)                                                       
      go to 2000                                                        
c                                                                       
c--'only' directive                                                     
2110  continue                                                          
      ista=0
      iem=0                                                             
      go to 2000                                                        
c                                                                       
c--'e  ' directive                                                      
 2200 continue                                                          
      ikb1=kredi(i)                                                     
      ie21=kredi(i)                                                     
      iem=1                                                             
      ikb=ikb1
      go to 2000                                                        
c                                                                       
c--'debye' directive                                                    
 2300 continue                                                          
      idby=1                                                            
      if(jrca(itemp,n)) 2000,2310,2000                                  
2310  continue                                                          
      if(itemp(1)-ionly) 2060,2320,2060                                 
2320  continue                                                          
      ista=0                                                            
      iem =0                                                            
      go to 2000                                                        
c                                                                       
c--'normalize' directive                                                
 2400 continue                                                          
      inor=1                                                            
      go to 2510                                                        
c                                                                       
c--'renormalize' directive                                              
 2500 continue                                                          
      inor=-1                                                           
 2510 continue                                                          
      if(jrca(itemp,n)) 2060,2520,2060                                  
 2520 continue                                                          
      i=kcomp(1,itemp,inorm,nnor,1)                                     
      if(i) 2060,2060,2530                                              
 2530 continue                                                          
      go to (2531,2532,2533,2535,2529),i                                
c--do not normalize                                                     
2529  continue                                                          
      iall=0                                                            
      inor=0                                                            
      go to 2000                                                        
c--on sin(t)/ l range                                                   
 2531 continue                                                          
      iall=-1                                                           
      go to 2539                                                        
c--all                                                                  
 2532 continue                                                          
      iall=1                                                            
      go to 2539                                                        
c--class                                                                
 2533 continue                                                          
      iall=0                                                            
      iclp=0                                                            
      if(jrca(itemp,n)) 2060,2534,2060                                  
 2534 continue                                                          
      i=kcomp(2,itemp,iclas,ncls,2)                                     
      if(i) 2060,2060,2538                                              
c--parity                                                               
 2535 continue                                                          
      iall=0                                                            
      iclp=1                                                            
      if(jrca(itemp,n)) 2060,2536,2060                                  
 2536 continue                                                          
      i=kcomp(2,itemp,ipari,npar,2)                                     
      if(i) 2060,2060,2538                                              
 2538 continue                                                          
      igroup=i-1                                                        
 2539 continue                                                          
      nc=keq(nc,ib,2)                                                   
      nc=kne(nc,ib,2)                                                   
      temp(1)=1.0                                                       
      if(nc) 2550,2550,2540                                             
 2540 continue                                                          
      if(jredf(temp,1)) 2060,2550,2060                                  
 2550 continue                                                          
      e2m=temp(1)                                                       
      go to 2000                                                        
c                                                                       
c--'scale' directive                                                    
 2600 continue                                                          
      ikb=0                                                             
      if(jredf(hg(1),1)) 2000,2000,2000                                 
c                                                                       
c--'b ' directive                                                       
 2700 continue                                                          
      ikb=0                                                             
      if(jredf(hg(2),1)) 2000,2000,2000                                 
c                                                                       
c--'emax' directive                                                     
 2800 continue                                                          
      if(jredf(hg(3),1)) 2060,2000,2060                                 
c                                                                       
c--'k(s)' directive                                                     
 2900 continue                                                          
      n=n1m-1                                                           
      lks=nfl                                                           
      nfl=lks+n                                                         
      ikb=-1                                                            
      l=lks                                                             
      do 2920 i=1,n                                                     
      if(jredf(temp,1)) 2060,2910,2060                                  
2910  continue                                                          
      store(l)=temp(1)                                                  
      l=l+1                                                             
2920  continue                                                          
      go to 2000                                                        
c                                                                       
c--'wilson' directive                                                   
2950  continue                                                          
      idby=0                                                            
      if(jrca(itemp,n)) 2000,2960,2000                                  
2960  continue                                                          
      if(itemp(1)-ionly) 2060,2970,2060                                 
2970  continue                                                          
      ista=0                                                            
      iem =0                                                            
      go to 2000                                                        
c                                                                       
c--'weak' directive                                                     
3000  continue                                                          
      iuse=1                                                            
      go to 2000                                                        
c                                                                       
c--'statistic' directive                                                
3100  continue                                                          
      ista=1                                                            
      if(jrca(itemp,n)) 2000,3110,2000                                  
3110  continue                                                          
      if(itemp(1)-ionly) 2060,3120,2060                                 
3120  continue                                                          
      ista=-1                                                           
      go to 2000                                                        
c                                                                       
c--'sharpening' directive                                               
3200  continue                                                          
      iem=-1                                                            
      if(jredf(ha,3)) 2060,2000,2060                                    
c                                                                       
c--'partial ' directive                                                 
3300  continue                                                          
      iparz=1                                                           
      ikb=0                                                             
      inor=0                                                            
      ista=0                                                            
      go to 2000                                                        
c                                                                       
c--'end' directive                                                      
 9000 continue
      if(iabort) 9002,9002,9120
9002  continue
c     write(ncwu,9001)
c9001 format(20h intensity statistic  ,
c    2 5x,11hversion  5a,5x,17hcreated  15/02/88,/)
      hg(3)=hg(3)*hg(3)
      if(idby) 9050,9050,9010
9010  continue
      in=17
      call srlin(in,li,lj,lk,ll,lm)
      if(lj) 9020,9020,9030
9020  continue
      idby=0
      go to 9050
9030  continue
      call sfl17
      i=j5317(in)
9050  continue
      if(iparz.eq.0) return
c      inx=0
c      call xfl07(inx)
      call xform
      do i=1,142
      gisa(i)=gis(i)
      giwa(i)=giw(i)
      enddo
      call xfl05
      if(hg(1).le.0.0) hg(1)=abs(store(l5o))
      i=kst53(j)
      if(j.ne.0) goto 9120
      m=nfl
      m3=l3
      do 3320 i=1,n3
      store(m)=store(m3+12)
      m=m+1
      m3=m3+md3
 3320 continue
      m5=l5
      do 3310 k=1,n5
      a=store(m5+16)*float(n2)*g2
      m3=l3+ store(m5+26)*md3
      store(m3+12)=store(m3+12)-a
      if(store(m3+12).lt.0.0) store(m3+12)=0.0
      m5=m5+md5
3310  continue
      write(ncwu,3330)
3330  format(' unknown cell content:  type  number (total)')
      m=nfl
      m3=l3
      do 3340 i=1,n3
      m3i=m3
      n=store(m)
      n1=store(m3+12)
      write(ncwu,3350) istore(m3i),n1,n
3350  format(25x,a2,i7,i8)
      m=m+1
      m3=m3+md3
3340  continue
      return
9100  continue
      write(ncwu,9110)
9110  format(' warning! cell content is zero')
9120  continue
      call xerr
      ista1=1
      iabort=0
      return
      end
c
code for jscal
      function  jscal(in)
c--set the default value for the normalization routine
c  in = 0 put the structure factors on the absolute scale
c       1 calculate the e's
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17
     2 ,l173,m173,md173,n173
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      jscal=0
      call slist
c--check the cell content
      m3=l3
      a=0.0
      do i=1,n3
      a=a+store(m3+12)
      m3=m3+md3
      enddo
      if(a.lt.0.5) goto 9100
      n17o=0
      gmed=1.0
      bmed=1.0
      e2m=1.0
      iparz=0
      jh=0
      iuse=0
      ie21=0
      hg(1)=0.0
      hg(2)=0.0
      hg(3)=20.0
      ntot=2*n6*n2
      numb=1000
1020  continue
      n1m=ntot/numb
      if(n1m.gt.15) go to 1010
      numb=numb-50
      if(numb.gt.0) goto 1020
      write(ncwu,1025)
1025  format(' warning! the program is unable to define the'
     1 ,' intervals')
      return
1010  continue
      fs=n1m
      ikb=0
      iscal=1
      inor=0
      iem=0
      idby=0
      iall=0
      ista=0
      if(in.ne.0) then
      iscal=0
      inor=1
      iem=1
      idby=1
      iall=1
      ista=1
      endif
c
c--calculate the wilson plot
      hg(3)=hg(3)*hg(3)
      call xnora
      if(in.eq.1) return
c--rewrite the reflections
      l6 =l6a
      l6d=l6a
 3000 continue
      if(kldnr(in,vett)) 3110,3010,3010
 3010 continue
      store(m6+3)=store(m6+3)/gmed
      store(m6+4)=store(m6+4)/gmed
 3100 continue
      call xslr(in)
      go to 3000
 3110 continue
      sc=gmed
      bt=bmed
      call xert
      return
9100  continue
      write(ncwu,9110)
9110  format(' warning! cell content is zero')
9120  continue
      jscal=1
      return
      end
c                                                                       
code for xnora                                                          
      subroutine xnora                                                  
c--main normalization routine                                           
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common /form/ gis(142),giw(142),gisa(142),giwa(142)
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal      
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)                                         
      dimension hmax(3),ihmax(3)
c                                                                       
c     call stim1(1)
c--calculate scattering form's curve
      call xform
c--calculate range values
      call range(ihmax)
c--the weak reflections are required?
c     if(iuse.eq.1) call weak(ihmax)
c--address setting
      ls=nfl
      nfl=ls+n1m+1
      nlrw=3
      mwl=nfl
      lwl=mwl+n1m*nlrw-1
      mlr=lwl+1
      llr=mlr+n1m*nlrw-1
      lc=llr+1-2*nlrw
      mr1=lc+nlrw*(n1m-1)
      lc2=mr1-1
      mnr1=mr1+n1m
      mr2=mnr1-1
      nnrw=5                                                            
      nfl=mnr1+n1m*nnrw                                                 
      mnr2=nfl-1                                                        
      mrwa=nfl                                                          
      nfl=mrwa+n1m                                                      
      nghw=5                                                            
      lgu=nfl                                                           
      lhk=lgu+8*nghw                                                    
      lgu1=lhk-1                                                        
      nfl=lhk+4*nghw                                                    
      lhk1=nfl-1                                                        
      l1=1                                                              
      call xsac(110,l1,ls,lhk1)                                         
      do lj=ls,lhk1
       store(lj)=0.0                                                    
      enddo
      ls1=ls                                                            
      n1p=n1m+1                                                         
      do i=1,n1p
      store(ls1)=sm+float(i-1)*ds/fs
      ls1=ls1+1                                                         
      enddo
c                                                                       
c--fetch the observed reflections                                       
      x=float(n2*(ic+1))                                                
      l6d=l6a                                                           
      n6d=0                                                             
 2000 continue                                                          
      if(kfnr(in,vett)) 2100,2010,2010
 2010 continue                                                          
      n6d=n6d+1
c      write(ncwu,*)'n6d,store(m6+7)',n6d,store(m6+7)
      ss=store(m6+7)
      s=sqrt(store(m6+7))
      fm=smult(1)
      fi=x/smult(0)                                                     
      n=jaddr(s,ss)                                                     
      l=mlr+n*nlrw                                                      
      m=mwl+n*nlrw                                                      
      in=1
      sig2=sigm2(in,s)
      li=mr1+n                                                          
      store(li)=store(li)+fm                                            
      li =mrwa+n                                                        
      store(li)=store(li)+1.0                                           
      f=store(m6+3)*store(m6+3)                                         
      if(iparz.eq.1) then
                     f=store(m6+4)*store(m6+4)
                     f=f-store(m6+5)*store(m6+5)
                     f=abs(f)
                     endif
      store(l+1)=store(l+1)+fm*( f /(fi*sig2))
      in=0
      sig2=sigm2(in,s)
      store(m+1)=store(m+1)+fm*( f/(fi*sig2))
      store(l  )=store(l  )+ss*fm
      store(l+2)=store(l+2)+fm
      store(m  )=store(l  )
      store(m+2)=store(l+2)
      if(istat2.eq.3) then
      if(jh.lt.0.or.n.eq.jh) then
      write(ncwu,2015) (store(m6+jj-1),jj=1,4),store(m6+5),
     2 f,fi,sig2,fm,n,store(l),store(l+1),store(l+2)                    
2015  format(1x,3f4.0,3f8.1,2f10.3,f10.0,i6,3e12.5)
      endif
      endif
      go to 2000                                                        
2100  continue                                                          
      write(ncwu,2030) n6d
2030  format(/,' indipendent reflections used',i6)
c                                                                       
c--calculate the total number of observed reflections                   
      icod0=0
      inte0=0
      t=0.0                                                             
      mnr3=mnr1                                                         
      do 2102 l=mr1,mr2                                                 
      inte0=inte0+1
      if(store(l).gt.0.0) goto 2110
      if(icod0.eq.0) int0x=inte0
      icod0=1
      write(ncwu,2115) inte0,n1m
2115  format(' warning!',i5,' range (of',i4,') is empty!')
2110  continue
      t=t+store(l)
      store(mnr3+4)=store(l)
      mnr3=mnr3+nnrw
 2102 continue
      if(icod0.eq.1) goto 9100
c                                                                       
c--overlapp of the range                                                
      mr2=mr2-1                                                         
      m=mrwa                                                            
      do 2103 l=mr1,mr2                                                 
      store(l)=store(l)+store(l+1)                                      
      store(m)=store(m)+store(m+1)                                      
      m=m+1                                                             
 2103 continue                                                          
      lwl=lwl-nlrw                                                      
      do 2104 l=mwl,lwl                                                 
      m=l+nlrw
      store(l)=store(l)+store(m)                                        
2104  continue                                                          
      llr=llr-nlrw                                                      
      do 2101 l=mlr,llr                                                 
      m=l+nlrw                                                          
      store(l-nlrw)=store(l)+store(m)                                   
 2101 continue                                                          
      mlr=mlr-nlrw                                                      
      llr=llr-nlrw                                                      
c                                                                       
c--calculate the medium values                                          
      do 2150 l=mlr,llr,nlrw
      if (store(l+2).le.0.0) goto 2149
      store(l  )=store(l  )/store(l+2)
      store(l+1)=store(l+1)/store(l+2)
2149  if(store(l+1).le.0.0) store(l+1)=0.00001
      store(l+1)=alog(store(l+1))
2150  continue
      do 2151 l=mwl,lwl,nlrw
      if (store(l+2).le.0.0) goto 2152
      store(l  )=store(l  )/store(l+2)
      store(l+1)=store(l+1)/store(l+2)
2152  if(store(l+1).le.0.0) store(l+1)=0.00001
      store(l+1)=alog(store(l+1))                                       
2151  continue                                                          
c                                                                       
c--check if only statistic is required                                  
       if(ista) 2534,2243,2243                                          
c                                                                       
c--check if only renormalization is required                            
2243  continue                                                          
      if(inor) 2534,2240,2240                                           
c                                                                       
c--check if k(s)-curve is given                                         
 2240 continue                                                          
      if(ikb) 2241,2245,2245                                            
 2241 continue                                                          
      m=lks                                                             
      do 2242 l=mlr,llr,nlrw                                            
      store(l+1)=store(m)
      m=m+1                                                             
 2242 continue                                                          
      iem=1                                                             
      go to 2534                                                        
c                                                                       
c--check if scale is given                                              
 2245 continue                                                          
      if(hg(1)) 2260,2260,2250                                          
c                                                                       
c--check if b[iso] is given                                             
 2250 continue
      if(hg(2)) 2260,2260,2510
c
c--calculate wilson plot
 2260 continue
      call swlsn
      call skcur
      if(iparz.eq.1) gmed=abs(store(l5o))
 2310 continue
      if(iem)2520,2534,2509
 2509 continue
      if(hg(1)) 2520,2520,2510
 2510 continue
      gmed=hg(1)                                                        
 2520 continue                                                          
      if(hg(2)) 2534,2534,2530                                          
 2530 continue                                                          
      bmed=hg(2)                                                        
 2534 continue                                                          
c                                                                       
c--check if only wilson plot was required
      if(iem) 2533,9100,2533
2533  continue
c                                                                       
c--check if only statistic is required                                  
      if(ista) 3220,2235,2235                                           
2235  continue                                                          
c                                                                       
c--check if only renormalization is required                            
      if(inor) 3200,2545,2545
c                                                                       
 2545 continue                                                          
      if(iem) 2535,9100,2540                                            
c                                                                       
c--calculate the sharpening function                                    
2535  continue                                                          
      ha(4)=bmed                                                        
      call smcal                                                        
      go to 9100                                                        
c                                                                       
c--calculate the e's
 2540 continue                                                          
      iii=0
      call secal(iii)
      if(inor) 3220,3220,3200                                           
c                                                                       
c--normalize the e's                                                    
 3200 continue                                                          
      do 3205 l=lgu,lhk1                                                
      store(l)=0.0
3205  continue                                                          
      if(inor) 3210,3220,3210                                           
 3210 continue                                                          
      call snorm                                                        
      inor=0                                                            
      go to 3200                                                        
 3220 continue                                                          
c                                                                       
3000  continue                                                          
      if(ista) 3010,3020,3010                                           
3010  continue                                                          
      call stat9
3020  continue                                                          
      if(ie21) 9100,9100,3230                                           
3230  continue                                                          
      call se21                                                         
9100  continue                                                          
c     call stim2(1)
c     call xline
      return
      end
c
code for sewrt                                                          
      subroutine sewrt                                                  
c--distribution of e's
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal       
c                                                                       
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty  
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                              
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
      equivalence(itemp,temp)                                           
c
      common /xdata/ store(1000000)
      dimension     istore(1000000)
      equivalence(store,istore)                                         
c                                                                       
      dimension se(34),nx(34),nm(34),px(34),pm(34)                      
      dimension iht(3,4),et(4),alfa(4),et1(3)                           
      data nt/34/                                                       
      data se/ 0.10,0.15,0.20,0.25,0.30,0.35,0.40,                      
     2         0.45,0.60,0.80,1.00,1.20,1.40,1.55,
     3         1.60,1.65,1.70,1.75,1.80,1.85,1.90,                      
     4         1.95,2.00,2.05,2.10,2.15,2.20,2.25,                      
     5         2.30,2.35,2.40,2.60,2.80,3.00     /                      
c--                                                                     
      call slist
      do i=1,nt
      nx(i)=0
      nm(i)=0
      px(i)=0.0
      pm(i)=0.0
      enddo
      call xline
c--fetch the reflections
1100  continue
      if(kfnr(in,vett)) 2000,1110,1110
1110  continue
      e = vett(4)
      do 1150 i=1,nt
      if(e-se(i)) 1140,1160,1160
1140  continue
      nm(i)=nm(i)+1
      go to 1150
1160  continue
      nx(i)=nx(i)+1
1150  continue
      go to 1100
2000  continue
      fn7=float(n6)
      write(ncwu,2030) n6
2030  format(' number of reflections used',i6)
      do 2050 i=1,nt
      x=nx(i)
      px(i)=x*100.0/fn7
      x=nm(i)
      pm(i)=x*100.0/fn7
2050  continue
      write(ncwu,2040)
2040  format(18h distribution of e   ,/)
      write(ncwu,2060)
2060  format(11x,7he limit,8x,13hnumber of e's,
     2 6x,10hpercentage,7x,13hnumber of e's,
     3 6x,10hpercentage,/,
     4 26x,12hgreater than,26x,12hless than       ,/,
     5 30x,5hlimit,31x,5hlimit,/)
      do 2070 i=1,nt
      write(ncwu,2075) se(i),nx(i),px(i),nm(i),pm(i)
2075  format(f16.2,2(i18,f18.1))
2070  continue
c     call xline
      return
      end
c
code for xecal
      subroutine xecal
c--calculate the e(s)
c--
      include 'li6com.inc'
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal 
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx 
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(1)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c
      call slist
      in=0
      if(iedir(in)) 9000,4000,9000
4000  write(ncwu,4010)
4010  format(' Normalized structure factor',
     2 5x,'version  3a',5x,'created  12/02/88',/)
      if(idby) 4100,4100,4005
4005  continue
      in=17
      call srlin(in,li,lj,lk,ll,lm)
      if(lj) 4020,4020,4030
4020  continue
      write(ncwu,4025) in
4025  format(//,9h no list ,i3,2x,'stored')
      go to 2060
4030  continue
      call sfl17
      i=j5317(in)
4100  continue
c     call xpas
c--calculate scattering form's curve
      iii=jp
      call xform
      bmed=bt
      gmed=sc
      if(bmed.le.0.0.or.bmed.gt.50.) bmed=3.5
      if(gmed.le.0.0.or.gmed.gt.100.) gmed=1.
      call secal(iii)
      if(ie21.ne.0) call se21
9000  return
2060  continue
      call xildr
      return
      end                                                               
c                                                                       
code for sharp                                                          
      subroutine sharp                                                  
c--calculate the sharpened s.f.                                         
c--
      include 'li6com.inc'
c
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal       
c
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty    
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                              
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(1)
      equivalence(itemp,temp)                                           
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c                                                                       
      call slist
      hg(3)=20.0
      if(kredf(ha(1),4)) 2060,5001,2060                                 
5001  continue                                                          
      write(ncwu,5010)                                                  
5010  format(28h sharpened structure factors   ,                        
     2 5x,11hversion  1a,5x,17hcreated  25/08/76,/)                     
      call xpas
      call smcal                                                        
      return                                                            
2060  continue                                                          
      call xildr                                                        
      return                                                            
      end                                                               
c
code for iedir
      function iedir(in)
c--read directives for choose the e>e(min)
c--
      include 'li6com.inc'
c
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xchar/id,ie,ib(2),ia,ih,numb(10),iplus, inus,ipoint,namh
      common/xcard/nch,image(80),nc,ndd,ni,ntt,na(3),ncd,idoc(20),irs(4)
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/xtemp/itemp(80)
      dimension temp(80)
      equivalence(itemp,temp)
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      dimension itarg(7),itarg2(2),iweak(1)
      character*40 iarg
      data iarg/'instruction(s) or ##'/
      data nat/7/
      data itarg/4he   ,4hnumb,4hchop,4hdeby,4he2-1,4hno  ,4hend /
      data iweak/4hweak/
      data itarg2/4hoff ,4hon  /,nat2/2/
c--
      iedir=0
      n7f=400
      n7d=50
      q=1.2
      r=0.2
      z=0.0
      jp =0
      iparz=0
      idby=0
      ikb=0
      iem=1
      hg(3)=400.
      ie21=0
      if(in.ne.0) go to 9000
      if(idefa(i)) 1000,1000,9000
1000  continue
      call sty(iarg)
c
c--main loop for processing input instructions
c--fetch the next card
 2000 continue
      if(klnc(2)) 9000,2020,9000
c-- card to be interpreted
 2020 continue
      call xpcci
      if(jrca(itemp,n)) 2060,2040,2060
c--process the directive
 2040 continue
      n=kcomp(1,itemp,itarg,nat,1)
      if(n) 2060,2060,2050
 2050 continue
      go to (2100,2200,2400,2500,2600,2700,
     2 9000,2060),n
2060  continue
      call xunkw
      go to 2000
c
c--'e ' directive
 2100 continue
      nc=keq(nc,ib,2)
      nca=nc
      if(nc) 2000,2000,2110
2110  continue
c--read the argument in alpha-numeric first
      if(jrca(itemp,n)) 2060,2120,2060
2120  continue
c--check if the code 'weack' is present
      if(kcomp(1,itemp,iweak,1,1)) 2150,2150,2130
2130  continue
      i=jredf(temp,1)
      q=temp(1)
      goto 2000
2150  continue
      nc=nca
      i=jredf(temp,1)
      r=temp(1)
      goto 2000
c
c--'number' directive
2200  continue
      nc=keq(nc,ib,2)
      nca=nc
      if(nc) 2000,2000,2210
2210  continue
c--read the argument in alpha-numeric first
      if(jrca(itemp,n)) 2060,2220,2060
2220  continue
c--check if the code 'weack' is present
      if(kcomp(1,itemp,iweak,1,1)) 2250,2250,2230
2230  continue
      n7d=kredi(i)
      go to 2000
2250  continue
      nc=nca
      n7f=kredi(i)
      go to 2000
c
c--'chop' directive
2400  continue
      if(jredf(temp,1).lt.0) goto 2060
      z=temp(1)
      goto 2000
c
c--'debye' directive
2500  continue
      idby=1
      goto 2000
c
c--'e2-1' directive
2600  continue
      ie21=1
      goto 2000
c
c--'no calc' directive
2700  continue
      jp=1
      goto 2000
c
c--'end' directive                                                      
9000  continue                                                          
      if(iabort) 9010,9010,9100
9010  continue
      return
9100  continue
      iedir=1
      iabort=0
      end                                                               
c
code for emax                                                           
      subroutine emax
c--form list 7 from list 6
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx 
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common/lstsc/lxxa,mxxa,mdxxa1,mdxxa2,nxxa,lxxb,mxxb,mdxxb,
     1 nxxb,lxxc,mxxc,mdxxc,nxxc,lxxe,mxxe,mdxxe,nxxe
c--
      common/xdata/store(1000000)
      dimension istore(1000000)
      equivalence (store,istore)
c--
      dimension ibuf(4,4),buf(4)
c--
      call slist
      in=0
      if(iedir(in)) 9000,1000,9000
1000  continue
      nxxb=0
      nxxc=0
3000  continue
      if(kfnr(in,vett)) 3110,3010,3010
3010  continue
      if(vett(4).ge.q) nxxb=nxxb+1
      if(vett(4).le.r) nxxc=nxxc+1
      go to 3000
3110  continue
      n7f=min0(n7f,nxxb)
      n7d=min0(n7d,nxxc)
      write(ncwu,4000)n7f,q
 4000 format( /,i10,' reflections with e greather than',f8.2)
      write(ncwu,5000)n7d,r
 5000 format(i10,' reflections with e less than',f8.2)
      nstr=n7f
      nzro=n7d
      store(l6p+2)=store(l6p+2)+1
      call wpre6
      call xline
9000  return
      end
c                                                                       
code for swlsn                                                          
      subroutine swlsn                                                  
c--calculate k and b(iso) from the wilson plot                          
c                                                                       
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c                                                                       
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      dimension icar(3),itit(15)                                        
      data icar/1hw,1hd,1h*/                                            
      data itit/2hs*,2h*2,2h  ,2hln,2h i,2h/s,                          
     1          2hwi,2hls,2hon,2hde,2hby,2he ,                          
     2          2hca,2hlc,2h  /                                         
c                                                                       
c--calculate the normal equations                                       
      lm=nfl                                                            
      lt=lm+4                                                           
      li=lt+2                                                           
      lr=li+4                                                           
      nfl=lr+2                                                          
      ll=nfl-1                                                          
      l =1                                                              
      call xsac(130,l ,lm,ll)                                           
      do l=lm,ll
      store(l)=0.0                                                      
      enddo
      mr3=mr1                                                           
      do l=mlr,llr,nlrw
      w=store(mr3)*store(mr3)                                           
      store(lt  )=store(lt  )+store(l+1)*w                              
      store(lt+1)=store(lt+1)+store(l+1)*w*store(l  )                   
      store(lm  )=store(lm  )+w                                         
      store(lm+1)=store(lm+1)+store(l  )*w                              
      store(lm+3)=store(lm+3)+store(l  )*w*store(l  )                   
      mr3=mr3+1                                                         
      enddo
      store(lm+2)=store(lm+1)                                           
      den=store(lm)*store(lm+3)-store(lm+1)*store(lm+2)                 
      store(lr  )=(store(lt)*store(lm+3)-store(lm+1)*store(lt+1))/      
     2 den                                                              
      store(lr+1)=(store(lm)*store(lt+1)-store(lt)*store(lm+2))/        
     2 den                                                              
      store(li  )=store(lm+3)/den                                       
      store(li+3)=store(lm  )/den                                       
c                                                                       
c--calculate the k,b and their standard deviations                      
      gmed=exp(store(lr)*0.5)                                           
      bmed=-0.5*store(lr+1)                                             
      u=bmed/(4.*twopis)                                                
      swd2=0.0                                                          
      lc1=lc                                                            
      mr3=mr1                                                           
      do l=mlr,llr,nlrw
      store(lc1+1)=store(lr)+store(lr+1)*store(l)                       
      d=store(lc1+1)-store(l+1)                                         
      swd2=swd2+d*d*store(mr3)*store(mr3)                               
      store(lc1)=store(l)                                               
      lc1=lc1+nlrw                                                      
      mr3=mr3+1                                                         
      enddo
      fs1=fs-1.0                                                        
      store(li  )=sqrt(store(li)*swd2/(fs1-2.0))*gmed*0.5               
      store(li+3)=sqrt(store(li+3)  *swd2/(fs1-2.0))*0.5                
      store(li+2)=store(li+3)/(4.*twopis)                               
c--print the results                                                    
      if(istat2.gt.0) then
      call sprtn                                                        
      write(ncwu,2351)                                                  
 2351 format(///,12h wilson plot)                                       
      write(ncwu,2400)                                                  
 2400 format(//, 6x,8hrange of, 8x,15h (sin(t)/l)**2 ,3x,               
     2 21hnumber of reflections,22x,                                    
     3  9hln( i/s ),/, 3x,14h(sin(t)/l)***3,23x,                        
     4  7hunwghtd,8x,5hwghtd,12x,6hwilson,                              
     5  7x,5hdebye,8x,4hcalc,/)                                         
      mr3=mrwa                                                          
      lc1=lc+1                                                          
      ls1=ls                                                            
      mwl1=mwl                                                          
      do 2450 l=mlr,llr,nlrw                                            
      write(ncwu,2451) store(ls1),store(ls1+2),store(l),store(mr3),     
     2 store(l+2),store(mwl1+1),store(l+1),store(lc1)                   
 2451 format( 2f10.4,f13.4,1x,2f13.0,6x, 3f12.4)                        
      mr3=mr3+1                                                         
      lc1=lc1+nlrw                                                      
      ls1=ls1+1                                                         
      mwl1=mwl1+nlrw                                                    
 2450 continue                                                          
      call xline                                                        
      write(ncwu,2461) t                                                
2461  format(33x,23h total of reflections =,f10.0)                      
      call sprtn                                                        
      call xline                                                        
      write(ncwu,2452)                                                  
2452  format(27h the normal equations are :,  /)                        
      write(ncwu,2453)  store(lm  ),store(lm+1),store(lt  )             
      write(ncwu,2453)  store(lm+2),store(lm+3),store(lt+1)             
2453  format(1x,e11.3,14h * intercept +,1x,e11.3,10h * slope =,1x,e11.3)
      write(ncwu,2454) store(lr  ),store(lr+1)                          
2454  format(//,31h constants for line of best fit  ,/                  
     2 35x,12h intercept =,f8.4,/,39x,8h slope =,f8.4)                  
      call xline                                                        
      endif
      write(ncwu,2462)                                                  
 2462 format(48h temperature factor and scale factor determined ,
     2 20hfrom the wilson plot)
      write(ncwu,2463)
 2463 format(/,13x,10h parameter,8x,7h e.s.d.,/)
      write(ncwu,2460) gmed,store(li),bmed,store(li+3),u,store(li+2)
 2460 format(6h scale,2x,2f15.5,/ 8h b[iso] ,2f15.5,/  8h ou[iso],
     2 2f15.5)                                                          
      if(iscal.eq.1) return
      n1m1=n1m-1                                                        
      in3=3
      ifit=1
      call xplot(ncwu,mwl,n1m1,in3,nlrw,icar,itit,ifit)
      return                                                            
      end                                                               
c                                                                       
code for skcur                                                          
      subroutine skcur                                                  
c--k(s) plot                                                            
c                                                                       
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c                                                                       
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      dimension icar(2),itit(12)                                        
      data icar/1hk,1h*/                                                
      data itit/2hs*,2h*2,2h  ,2h k,2h  ,2h  ,                          
     1          2hob,2hse,2hrv,2hca,2hlc,2h  /                          
c--                                                                     
      do l=mlr,llr,nlrw
      a=store(l+1)                                                      
      store(l+1)=exp(a)                                                 
      store(l+1)=1.0/store(l+1)                                         
      enddo
      do l=lc,lc2,nlrw
      store(l+1)=exp(2.0*bmed*store(l))/(gmed*gmed)                     
      enddo
c--print the results                                                    
      if(istat2.gt.0) then
      write(ncwu,2501)                                                  
 2501 format(//,11h k(s) curve)                                         
      write(ncwu,2504)                                                  
 2504 format(//4x,15h (sin(t)/l)**2 ,8x,21hnumber of reflections,       
     2 21x,4hk(s),/,17x,  8x,7hunwghtd,12x, 5hwghtd,                    
     3 10x,8hobserved,8x,10hcalculated /)                               
      mr3=mrwa                                                          
      lc1=lc+1                                                          
      do l=mlr,llr,nlrw
      write(ncwu,2505) store(l),store(mr3),store(l+2),store(l+1)        
     2 ,store(lc1)                                                      
 2505 format(f15.5,7x,f10.0,7x,f10.0,3x,2(f15.5,2x))                    
      mr3=mr3+1                                                         
      lc1=lc1+nlrw
      enddo
      n1m1=n1m-1                                                        
      in2=2
      ifit=1
      call xplot(ncwu,mlr,n1m1,in2,nlrw,icar,itit,ifit)
      endif
      return                                                            
      end                                                               
c                                                                       
code for stat9
      subroutine stat9
c--calculate the e statistics                                           
c  the erf function are calculated from the                             
c  handbook of chemistry , pag 212                                      
c  r(e) = 1.0 - n(e) = 1.0 - erf(e)                                     
c       = 1.0 - 2.0 * area(e)                                           
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst05/l5,m5,md5,n5,l5o,m5o,md5o,n5o                        
     2 ,n5g,l5d,n5d,md5c,l5ori,md5h,md5xyz
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d                                             
c                                                                       
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c                                                                       
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
      common/xtemp/itemp(80)                                            
      dimension temp(80)
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
c--
      dimension icar(3)
      dimension iclas(2,5),ipari(2,9)
      dimension itst(9,25),fvalo(2,25)
      dimension itit(15)
      data itit/2h z,2h  ,2h  ,2h%n,2h(z,2h) ,
     2          2hhe,2hre,2h  ,2hac,2hen,2htr,
     3          2hce,2hnt,2hr /
      data ((itst(i,j),i=1,9),j=1,10)
     *         /2h  ,2h  ,2h  ,2h  ,2h<e,2h> ,2h  ,2h  ,2h  ,
     1          2h  ,2h  ,2h  ,2h  ,2h<e,2h2>,2h  ,2h  ,2h  ,
     2          2h  ,2h  ,2h <,2he>,2h2/,2h<e,2h2>,2h  ,2h  ,
     3          2h  ,2h  ,2h  ,2h  ,2h<e,2h3>,2h  ,2h  ,2h  ,
     4          2h  ,2h  ,2h  ,2h  ,2h<e,2h4>,2h  ,2h  ,2h  ,
     5          2h  ,2h  ,2h  ,2h  ,2h<e,2h5>,2h  ,2h  ,2h  ,
     6          2h  ,2h  ,2h  ,2h  ,2h<e,2h6>,2h  ,2h  ,2h  ,
     7          2h  ,2h  ,2h  ,2h  ,2h<e,2h8>,2h  ,2h  ,2h  ,
     8          2h  ,2h  ,2h  ,2h  ,2h<e,2h10,2h> ,2h  ,2h  ,
     9          2h  ,2h  ,2h  ,2h  ,2h<e,2h21,2h> ,2h  ,2h  /
      data ((itst(i,j),i=1,9),j=11,20)
     *         /2h  ,2h  ,2h  ,2h<(,2he2,2h1),2h2>,2h  ,2h  ,
     1          2h  ,2h  ,2h  ,2h<(,2he2,2h1),2h3>,2h  ,2h  ,
     2          2h  ,2h  ,2h <,2h((,2he2,2h1),2h3),2h> ,2h  ,
     3          2h<(,2he2,2h1),2h4>,2h/<,2h(e,2h21,2h)2,2h> ,
     4          2h  ,2h  ,2h  ,2h<(,2he2,2h1),2h4>,2h  ,2h  ,
     5          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h0 ,2h  ,2h  ,
     5          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h2 ,2h  ,2h  ,
     5          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h3 ,2h  ,2h  ,
     5          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h4 ,2h  ,2h  ,
     6          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h5 ,2h  ,2h  /
      data ((itst(i,j),i=1,9),j=21,25)
     6         /2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h6 ,2h  ,2h  ,
     6          2h  ,2h  ,2h  ,2he ,2h> ,2h1.,2h7 ,2h  ,2h  ,
     7          2h  ,2h  ,2h  ,2he ,2h> ,2h2.,2h0 ,2h  ,2h  ,
     8          2h  ,2h  ,2h  ,2he ,2h> ,2h2.,2h5 ,2h  ,2h  ,
     9          2h  ,2h  ,2h  ,2he ,2h> ,2h3.,2h0 ,2h  ,2h  /
      data ((fvalo(i,j),i=1,2),j=1,10)
     *          /  0.886,  0.798,
     1            1.000,  1.000,
     2            0.785,  0.637,                                        
     3            1.329,  1.596,                                        
     4            2.000,  3.000,                                        
     5            3.323,  6.383,                                        
     6            6.000, 15.000,                                        
     7           24.000,105.000,                                        
     8          120.000,945.000,                                        
     9            0.736,  0.968/
      data ((fvalo(i,j),i=1,2),j=11,20)
     *          / 1.000,  2.000,
     1            2.000,  8.000,
     2            2.415,  8.691,
     3            9.000, 15.000,
     4            9.000, 60.000,
     5           36.790, 31.730,
     6           23.693, 23.020,
     7           18.451, 19.360,
     8           14.086, 16.160,
     9           10.540, 13.360/
      data ((fvalo(i,j),i=1,2),j=21,25)
     *          / 7.730, 10.960,
     1            5.558,  8.920,
     2            1.832,  4.540,                                        
     3            0.193,  1.240,                                        
     4            0.012,  0.260/                                        
      data icar/1hz,1h-,1h+/                                            
      data iclas(1,1)/2hal/                                             
      data iclas(2,1)/2hl /                                             
      data iclas(1,2)/2hhk/                                             
      data iclas(2,2)/2hl /                                             
      data iclas(1,3)/2h0k/                                             
      data iclas(2,3)/2hl /                                             
      data iclas(1,4)/2hh0/                                             
      data iclas(2,4)/2hl /                                             
      data iclas(1,5)/2hhk/                                             
      data iclas(2,5)/2h0 /                                             
      data ipari(1,1)/2hal/                                             
      data ipari(2,1)/2hl /                                             
      data ipari(1,2)/2hgg/                                             
      data ipari(2,2)/2hg /                                             
      data ipari(1,3)/2hgg/                                             
      data ipari(2,3)/2hu /                                             
      data ipari(1,4)/2hgu/                                             
      data ipari(2,4)/2hg /                                             
      data ipari(1,5)/2hgu/                                             
      data ipari(2,5)/2hu /                                             
      data ipari(1,6)/2hug/                                             
      data ipari(2,6)/2hg /                                             
      data ipari(1,7)/2hug/                                             
      data ipari(2,7)/2hu /                                             
      data ipari(1,8)/2huu/                                             
      data ipari(2,8)/2hg /                                             
      data ipari(1,9)/2huu/                                             
      data ipari(2,9)/2hu /
c--
      lf=nfl                                                            
      nfw=3                                                             
      le=lf+nfw*10                                                      
      lf1=le-1                                                          
      new=25                                                            
      lz=le+new                                                         
      le1=lz-1                                                          
      nzw=11                                                            
      nfl=lz+n1m*nzw                                                    
      lz1=nfl-1                                                         
      l1=1                                                              
      call xsac(140,l1,lf,lz1)                                          
      do l=lf,lz1
      store(l)=0.0                                                      
      enddo
      l6d=l6a                                                           
 2610 continue                                                          
      if(kfnr(in,vett)) 2700,2620,2620
 2620 continue                                                          
      ss=store(m6+7)
      s=sqrt(ss)                                                        
      fm=smult(1)                                                       
      e=vett(4)
      e2=e*e                                                            
c--test 1                                                               
      n=jaddr(s,ss)                                                     
      l=mnr1+n*nnrw                                                     
      call ssum(l,e,e2,fm)                                              
      store(l+3)=store(l+3)+1.0                                         
      i=int(e2*10.0)+1                                                  
      if(i-nzw-1) 2647,2647,2648                                        
 2647 continue                                                          
      l =lz+n*nzw+i                                                     
      store(l )=store(l )+fm                                            
 2648 continue                                                          
c--test 2                                                               
 2649 continue                                                          
c--test 3                                                               
      call esum(le,e,e2,fm)                                             
 2655 continue                                                          
      call sggg(i,m6)                                                   
      assign 2658 to nind1                                              
      m=lgu                                                             
 2657 continue                                                          
c--test 4 & 5                                                           
      l=m+nghw*i                                                        
      call ssum(l,e,e2,fm)                                              
      store(l+3)=store(l+3)+1.                                          
      store(l+4)=store(l+4)+fm                                          
      go to nind1                                                       
 2658 continue                                                          
      call shkl(i,m6)                                                   
      if(i) 2610,2656,2656                                              
2656  continue                                                          
      assign 2610 to nind1                                              
      m=lhk                                                             
      go to 2657                                                        
 2700 continue                                                          
c                                                                       
c--print the e statistics                                               
      j=0                                                               
      do 2669 l=le,le1                                                  
      j=j+1                                                             
      store(l)=store(l)/t                                               
      if(j-15) 2669,2669,2720                                           
 2720 continue                                                          
      store(l)=100.0*store(l)                                           
 2669 continue                                                          
      store(le+2)=store(le)*store(le)/store(le+1)                       
      store(le+13)=store(le+14)/store(le+10)                            
      do 2741 l=lgu,lhk1,nghw                                           
      if(store(l+3)) 2741,2741,2742                                     
 2742 continue                                                          
      store(l)=store(l)/store(l+4)                                      
      store(l+1)=store(l+1)/store(l+4)                                  
      store(l+2)=store(l+2)/store(l+4)                                  
 2741 continue                                                          
      call sprtn                                                        
      write(ncwu,2701)                                                  
 2701 format (13h e statistics)                                         
      if(iall) 2745,2745,2743                                           
 2743 continue                                                          
      write(ncwu,2744) gmed                                             
 2744 format(' new scale is',2x,f10.5)
 2745 continue
      write(ncwu,2730)
2730  format(/,16x,3h<e>,5x,6h<e2-1>,5x,4h<e2>,9x,1hn,8x,2hn%,/)
      j=2
      do 2731 l=lhk,lhk1,nghw
      store(l+4)=100.0*store(l+4)/t
      write(ncwu,2732) (iclas(k,j),k=1,2),store(l),store(l+1),store(l+2)
     2 ,store(l+3),store(l+4)
2732  format(4x,2a2,2x,3f10.3,2f10.0)
      j=j+1
 2731 continue
      j=2
      do 2733 l=lgu,lgu1,nghw
      store(l+4)=100.0*store(l+4)/t
      write(ncwu,2732) (ipari(k,j),k=1,2),store(l),store(l+1),store(l+2)
     2 ,store(l+3),store(l+4)
      j=j+1
 2733 continue
c--distribution with (sin(t)/l)**2                                      
      write(ncwu,2750)                                                  
2750  format(/,' distribution with (sin(t)/l)**2')
      write(ncwu,2755)                                                  
2755  format(/,4x,15h (sin(t)/l)**2   ,1x,                              
     2 5x,3h<e>,5x,6h<e2-1>,5x,4h<e2>,9x,1hn,8x,2hn%,/)                 
      l=mlr+(n1m-1)*nlrw                                                
      store(l)=store(l18+19)                                            
      m=mlr                                                             
      do 2760 l=mnr1,mnr2,nnrw                                          
      if(store(l+3)) 2764,2764,2761                                     
2761  continue                                                          
      store(l  )=store(l  )/store(l+4)                                  
      store(l+1)=store(l+1)/store(l+4)                                  
      store(l+2)=store(l+2)/store(l+4)                                  
2764  continue                                                          
      lk=l+nnrw-1                                                       
      store(lk)=100.0*store(lk)/t                                       
      write(ncwu,2765) store(m),(store(li),li=l,lk)                     
2765  format(f15.5,4x,3f10.3,2f10.0)                                    
      m=m+nlrw                                                          
2760  continue                                                          
c--some useful properties
      call sprtn
      write(ncwu,2706)
2706  format(/50h some useful average properties for all the reflec,
     1 7htions (,15he21 = e**2-1) :,/,
     2 8x,7haverage,11x,8hacentric,11x,4hhere,8x,7hcentric,/)
      l=le
      do 2704 i=1,new
      write(ncwu,2707) (itst(j,i),j=1,9),
     1 fvalo(1,i),store(l),fvalo(2,i)                                   
2707  format(1x,9a2,3f15.3)                                             
      l=l+1                                                             
2704  continue                                                          
c                                                                       
c--n(z) test                                                            
      lz1=lz1-nzw                                                       
      do 2801 l=lz,lz1                                                  
      lj=l+nzw                                                          
      store(l)=store(l)+store(lj)                                       
 2801 continue                                                          
      lz2=lz                                                            
      mr3=mr1                                                           
      do 2800 l=mlr,llr,nlrw                                            
      store(lz2)=0.0                                                    
      lz3=lz2+1                                                         
      lz4=lz2+nzw-1                                                     
      store(lz3)=store(lz3)+store(l+2)-store(mr3)                       
      do 2810 lj=lz3,lz4                                                
      store(lj)=store(lj)+store(lj-1)                                   
 2810 continue                                                          
      do 2820 lj=lz3,lz4                                                
      store(lj)=100.0*store(lj)/store(l+2)                              
 2820 continue                                                          
      if(lz2-lz) 2850,2850,2830                                         
 2830 continue                                                          
      lk=lz+1                                                           
      do 2840 lj=lz3,lz4                                                
      store(lk)=store(lk)+store(lj)                                     
      lk=lk+1                                                           
 2840 continue                                                          
 2850 continue                                                          
      lz2=lz2+nzw                                                       
      mr3=mr3+1                                                         
 2800 continue                                                          
      fs1=fs-1.0                                                        
      flk=0.0                                                           
      lk=lz+nzw                                                         
      lz1=lk-1                                                          
      nfl=lk+3*nzw                                                      
      do 2860 lj=lz,lz1
      store(lk +1)=store(lj)/fs1
      store(lk  )=flk                                                   
      store(lk+33)=flk                                                  
      store(lk+66)=flk                                                  
      lk=lk+3                                                           
      flk=flk+0.1                                                       
 2860 continue                                                          
      lk=lk+1                                                           
      store(lk  )=0.0                                                   
      store(lk+ 3)=9.52                                                 
      store(lk+ 6)=18.13                                                
      store(lk+ 9)=25.92                                                
      store(lk+12)=32.97                                                
      store(lk+15)=39.35                                                
      store(lk+18)=45.12                                                
      store(lk+21)=50.34                                                
      store(lk+24)=55.07                                                
      store(lk+27)=59.34                                                
      store(lk+30)=63.21                                                
      lk=lk+33                                                          
      store(lk   )=0.0                                                  
      store(lk+ 3)=24.81                                                
      store(lk+ 6)=34.53                                                
      store(lk+ 9)=41.87                                                
      store(lk+12)=47.38                                                
      store(lk+15)=52.05                                                
      store(lk+18)=56.14                                                
      store(lk+21)=59.72                                                
      store(lk+24)=62.89                                                
      store(lk+27)=65.72                                                
      store(lk+30)=68.33                                                
c                                                                       
c--n(z) plot                                                            
      lz=lz+nzw                                                         
      lz1=lz+nzw*3-1                                                    
      nfl=lz+nzw*9                                                      
       if(istat2) 2901,2940,2901                                        
2901  continue                                                          
      call sprtn                                                        
      write(ncwu,2900)                                                  
 2900 format(///,11h n(z) curve)                                        
      write(ncwu,2910)                                                  
 2910 format(//,16h table of n(z) :)                                    
      write(ncwu,2920)                                                  
 2920 format(//6x,2h z,5x,8h centric,4x,5h here,2x,9h acentric,/)       
      do 2930 i=lz,lz1,3                                                
      write(ncwu,2921) store(i),store(i+67),store(i+1),store(i+34)      
 2921 format(4f10.2)                                                    
 2930 continue                                                          
2940  continue                                                          
      in3=3
      ifit=1
      call xplot(ncwu,lz,nzw,in3,nlrw,icar,itit,ifit)
      call xline                                                        
      return                                                            
      end                                                               
c
code for ssum                                                           
      subroutine ssum(le,e,e2,fm)                                       
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      store(le  )=store(le  )+e    *fm                                  
      store(le+1)=store(le+1)+abs(e2-1)*fm                              
      store(le+2)=store(le+2)+e2   *fm                                  
      return                                                            
      end                                                               
c                                                                       
code for esum                                                           
      subroutine esum(le,e,e2,fm)                                       
c                                                                       
      common /xdata/ store(1000000)
c--                                                                     
      store(le  )=store(le  )+fm*e                                      
      store(le+1)=store(le+1)+fm*e2                                     
      store(le+3)=store(le+3)+fm*e2*e                                   
      store(le+4)=store(le+4)+fm*e2*e2                                  
      store(le+5)=store(le+5)+fm*e**5                                   
      store(le+6)=store(le+6)+fm*e**6                                   
      store(le+7)=store(le+7)+fm*e**8                                   
      store(le+8)=store(le+8)+fm*e**10                                  
      e21=e2-1.0                                                        
      store(le+9)=store(le+9)+fm*abs(e21)                               
      store(le+10)=store(le+10)+fm*e21*e21                              
      store(le+11)=store(le+11)+fm*e21**3                               
      store(le+12)=store(le+12)+fm*abs(e21**3)                          
      store(le+14)=store(le+14)+fm*e21**4                               
      if(e-1.0) 1000,1010,1010                                          
1010  continue                                                          
      if(e.ge.1.0) store(le+15)=store(le+15)+fm                         
      if(e.ge.1.2) store(le+16)=store(le+16)+fm                         
      if(e.ge.1.3) store(le+17)=store(le+17)+fm                         
      if(e.ge.1.4) store(le+18)=store(le+18)+fm                         
      if(e.ge.1.5) store(le+19)=store(le+19)+fm                         
      if(e.ge.1.6) store(le+20)=store(le+20)+fm                         
      if(e.ge.1.7) store(le+21)=store(le+21)+fm                         
      if(e.ge.2.0) store(le+22)=store(le+22)+fm                         
      if(e.ge.2.5) store(le+23)=store(le+23)+fm                         
      if(e.ge.3.0) store(le+24)=store(le+24)+fm                         
1000  continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for smult                                                          
      function smult(in)                                                
c--find the multiplicity                                                
c  in=0  point group                                                    
c  in=1  laue                                                           
c--
      include 'li6com.inc'
c
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,    
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
c
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      m2t=l2t                                                           
      n=0                                                               
      m=max0(in+1,ic+1)                                                 
      do 2100 l=l2,m2,md2                                               
c--calculate the new indices                                            
      store(m2t  )=store(m6  )*store(l  )+store(m6+1)*store(l+3)        
     2           +store(m6+2)*store(l+6)                                
      store(m2t+1)=store(m6  )*store(l+1)+store(m6+1)*store(l+4)        
     2           +store(m6+2)*store(l+7)                                
      store(m2t+2)=store(m6  )*store(l+2)+store(m6+1)*store(l+5)        
     2           +store(m6+2)*store(l+8)                                
c--check if these indices have been found before                        
      if(m2t-l2t)2050,2050,2000                                         
c--cycle through all the previous indices                               
 2000 continue                                                          
      ll=m2t-md2t                                                       
      do 2040 lj=l2t,ll,md2t                                            
      aa=store(lj  )-store(m2t  )                                       
      bb=store(lj+1)-store(m2t+1)                                       
      cc=store(lj+2)-store(m2t+2)                                       
      if(abs(aa)+abs(bb)+abs(cc)) 2100,2100,2030                        
 2030 continue                                                          
      if(ic)2033,2033,2035                                              
 2033 continue                                                          
      if(in) 2040,2040,2035                                             
 2035 continue                                                          
      aa=store(lj  )+store(m2t  )                                       
      bb=store(lj+1)+store(m2t+1)                                       
      cc=store(lj+2)+store(m2t+2)                                       
      if(abs(aa)+abs(bb)+abs(cc)) 2100,2100,2040                        
 2040 continue                                                          
c--this reflection is unique                                            
 2050 continue                                                          
      m2t=m2t+md2t                                                      
      n=n+m                                                             
 2100 continue                                                          
      smult=float(n)                                                    
      return                                                            
      end                                                               
c                                                                       
code for range                                                          
      subroutine range(ihmax)
c--calculate the range values                                           
c                                                                       
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/lst01/l1p1,l1p2,l1m1,l1m2,l1o1,l1o2,l1a,l1c,l1s
     1 ,l1p1d,l1p2d,n1g,gg(9),gr(9)
      common/lst18/ l18,m18,md18,n18,l18r,m18r,md18r,n18r,
     2 l18d,m18d,md18d,n18d                                             
c                                                                       
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      dimension ihmax(3)
c                                                                       
      s=     store(l18+17)                                              
      s=sqrt(s)                                                         
      sm=store(l18+17)*s                                                
      s=     store(l18+19)                                              
      s=sqrt(s)                                                         
      ds=(store(l18+19)*s)-sm                                           
      l=l1s                                                             
      j=3                                                               
      do 1000 i=1,3                                                     
      s=store(l18+19)/store(l)                                          
      a =sqrt(s)+1.0                                                    
      ihmax(i)=kintk(a)
      l=l+j                                                             
      j=j-1                                                             
 1000 continue                                                          
      l=l18                                                             
      do 1006 i=1,3                                                     
      a=store(l)                                                        
      b=store(l+3)                                                      
      if(abs(a)+abs(b)) 1007,1007,1008
 1007 continue                                                          
      ihmax(i)=0
 1008 continue                                                          
      l=l+4                                                             
 1006 continue
      return                                                            
      end                                                               
c                                                                       
code for xform                                                          
      subroutine xform                                                  
c--calculate scattering form                                            
c                                                                       
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,    
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i               
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti                       
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17               
     2 ,l173,m173,md173,n173                                            
c--                                                                     
      common /form/ gis(142),giw(142),gisa(142),giwa(142)                                   
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      xn2=float(n2p)                                                    
      do 1000 i=1,142                                                   
      gis(i)=0.0                                                        
      giw(i)=0.0                                                        
1000  continue                                                          
      if(n17o) 2000,2000,1010                                           
1010  continue                                                          
      m17o=l17o                                                         
      do 1100 jz=1,n17o                                                 
      n17=store(m17o+2)                                                 
      amult=store(m17o+1)/xn2                                           
      l17=m17o+md17o                                                    
      call debye(amult)                                                 
      m17o=l17+n17*md17                                                 
1100  continue                                                          
2000  continue                                                          
      do 2020 i=1,142
      s=0.01*float(i-1)
      call scatt(s)                                                     
      m173=l173                                                         
      m3=l3                                                             
      do 2010 k=1,n3                                                    
      l=l3t+k-1                                                         
      giw(i)=giw(i)+store(m3+12)*store(l)*store(l)/xn2                  
      if(n17o) 2030,2030,2040                                           
2040  continue                                                          
      gis(i)=gis(i)+store(m173)*store(l)*store(l)/xn2                   
2030  continue                                                          
      m173=m173+1                                                       
      m3=m3+md3                                                         
2010  continue                                                          
2020  continue                                                          
      if(n17o.ne.0) return                                              
      do 2050 i=1,142                                                   
      gis(i)=giw(i)                                                     
2050  continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for debye                                                          
      subroutine debye(amult)                                           
c--calculate scattering factors from debye                              
c                                                                       
      common/lst03/l3,m3,md3,n3,l3t,m3t,l3ti,m3ti                       
      common/lst17/ l17o,m17o,md17o,n17o,l17,m17,md17,n17               
     2 ,l173,m173,md173,n173                                            
c                                                                       
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty                      
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                               
c--                                                                     
      common /form/ gis(142),giw(142),gisa(142),giwa(142)                                   
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      dimension  gg(142)                                                
c--                                                                     
      fp=4.0*pi                                                         
      d=1.0                                                             
      do 1100 je=1,142                                                  
      gg(je)=0.0                                                        
      s=0.01*float(je-1)                                                
      call scatt(s)                                                     
      m17=l17                                                           
      do 1050 jf=1,n17                                                  
      l=l3t+store(m17+7)                                                
      gg(je)=gg(je)+store(l)*store(l)                                   
      if(jf-n17) 1010,1060,1060                                         
1010  continue                                                          
      jc=jf+1                                                           
      m17a=m17+md17                                                     
      do 1040 jd=jc,n17                                                 
      l1=l3t+store(m17a+7)                                              
      if(je-1) 1030,1030,1020                                           
1020  continue                                                          
      d=fp*s*sqrt((store(m17 +4)-store(m17a+4))**2+                     
     1            (store(m17 +5)-store(m17a+5))**2+                     
     2            (store(m17 +6)-store(m17a+6))**2)                     
      d=sin(d)/d                                                        
1030  continue                                                          
      gg(je)=gg(je)+2.0*store(l)*store(l1)*d                            
      m17a=m17a+md17                                                    
1040  continue                                                          
      m17=m17+md17                                                      
1050  continue                                                          
1060  continue                                                          
      gg(je)=sqrt(gg(je))                                               
1100  continue                                                          
      write(ncwu,1110)(gg(i),i=1,101,2)                                 
1110  format(///,26x,45hgroup scattering factors at intervals of 0.02,  
     1 21h in sin(theta)/lambda,//,(1h ,17f7.2))                        
      do 1120 i=1,142                                                   
      gis(i)=gis(i)+gg(i)*gg(i)*amult                                   
1120  continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for sigm2                                                          
      function sigm2(in,s)                                              
c--calculate the sigma value                                            
c                                                                       
c  in=0  wilson                                                         
c     1  debye                                                          
c--                                                                     
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common /form/ gis(142),giw(142),gisa(142),giwa(142)
c--                                                                     
      z=100.0*s                                                         
      ind=max0(2,int(z+1.5))
      u=z-float(ind-1)
      if(in) 1000,1000,1100                                             
1000  continue                                                          
      p=0.5*(giw(ind+1)-giw(ind-1))                                     
      q=p+giw(ind-1)-giw(ind)                                           
      sigm2=q*u*u+p*u+giw(ind)                                          
      return                                                            
1100  continue                                                          
      p=0.5*(gis(ind+1)-gis(ind-1))                                     
      q=p+gis(ind-1)-gis(ind)                                           
      sigm2=q*u*u+p*u+gis(ind)                                          
      return                                                            
      end
c
code for siga2
      function siga2(in,s)
c--calculate the sigma value from auxiliary curve
c
c  in=0  wilson
c     1  debye
c--
      common /form/ gis(142),giw(142),gisa(142),giwa(142)
c--
      z=100.0*s
      ind=max0(2,int(z+1.5))
      u=z-float(ind-1)
      if(in) 1000,1000,1100
1000  continue
      p=0.5*(giwa(ind+1)-giwa(ind-1))
      q=p+giwa(ind-1)-giwa(ind)
      siga2=q*u*u+p*u+giwa(ind)
      return
1100  continue
      p=0.5*(gisa(ind+1)-gisa(ind-1))
      q=p+gisa(ind-1)-gisa(ind)
      siga2=q*u*u+p*u+gisa(ind)
      return
      end
c
code for jaddr                                                          
      function jaddr(s1,ss)                                             
c--find the right range of sin(t/l)***3                                 
c                                                                       
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed                   
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c--                                                                     
      sss=ss*s1                                                         
      j=int((sss-sm)*fs/ds)                                             
      jaddr=j                                                           
      if(j-n1m) 1010,1000,1000                                          
1000  continue                                                          
      jaddr=n1m-1                                                       
1010  continue                                                          
      return                                                            
      end                                                               
c                                                                       
code for sggg                                                           
      subroutine sggg(in,m6)                                            
c                                                                       
       l=lint(m6)                                                       
      if(l-l/2*2) 1100,1000,1100                                        
 1000 continue                                                          
      i=0                                                               
      go to 1110                                                        
 1100 continue                                                          
      i=4                                                               
 1110 continue                                                          
       l=lint(m6+1)                                                     
      if(l-l/2*2) 2100,2000,2100                                        
 2000 continue                                                          
      j=0                                                               
      go to 2110                                                        
 2100 continue                                                          
      j=2                                                               
 2110 continue                                                          
      l=lint(m6 +2)                                                     
      if(l-l/2*2) 3100,3000,3100                                        
 3000 continue                                                          
      k=1                                                               
      go to 3110                                                        
 3100 continue                                                          
      k=2                                                               
 3110 continue                                                          
      in=i+j+k-1                                                        
      return                                                            
      end                                                               
c                                                                       
code for shkl                                                           
      subroutine shkl(j,m6)                                             
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      j=0                                                               
      if(store(m6)) 1100,1000,1100                                      
 1000 continue                                                          
      j=1                                                               
 1100 continue                                                          
       if(store(m6+1)) 2100,2000,2100                                   
 2000 continue                                                          
      if(j) 9000,2010,9000                                              
 2010 continue                                                          
      j=2                                                               
 2100 continue                                                          
      if(store(m6+2)) 3100,3000,3100                                    
 3000 continue                                                          
      if(j) 9000,3010,9000                                              
 3010 continue                                                          
      j=3                                                               
 3100 continue                                                          
      return                                                            
 9000 continue                                                          
      j=-1                                                              
      return                                                            
      end                                                               
c                                                                       
code for smcal                                                          
      subroutine smcal                                                  
c--calculate the sharpening function                                    
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c                                                                       
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      call xline                                                        
      l6 =l6a                                                           
      l6d=l6a                                                           
c--	store(l6rs+2)=xnx/sqrt(hg(3))
 3000 continue                                                          
      if(kfnr(in,vett)) 3110,3010,3010
 3010 continue                                                          
      ss=store(m6+7)
      s=sqrt(ss)                                                        
      a=s**ha(1)                                                        
      c=exp(2.0*ha(4)*s**ha(2))                                         
      e2=a*c/sigma(ha(3),s)                                             
      vett(4)=sqrt(e2)*store(m6+3)
 3100 continue                                                          
      call xslrx(in,vett)
      go to 3000                                                        
 3110 continue                                                          
      call xert                                                         
      call xline                                                        
      return                                                            
      end                                                               
c                                                                       
code for snorm                                                          
      subroutine snorm                                                  
c--normalize the e's                                                    
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c                                                                       
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z  
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,           
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz                  
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      a=0.0                                                             
      l6d=l6a                                                           
      l6 =l6a                                                           
 3220 continue                                                          
      if(kfnr(in,vett)) 3300,3230,3230
 3230 continue                                                          
      ss=store(m6+7)
      e=vett(4)
      e2=e*e                                                            
      fm=smult(1)                                                       
      if(iall) 3250,3270,3260                                           
 3250 continue                                                          
      s=sqrt(ss)                                                        
      n=jaddr(s,ss)                                                     
      l=mnr1+n*nnrw                                                     
      store(l+1)=store(l+1)+fm*e2                                       
      go to 3220                                                        
 3260 continue                                                          
      a=a+e2*fm                                                         
      go to 3220                                                        
 3270 continue                                                          
      if(iclp) 3271,3271,3275                                           
 3271 continue                                                          
      m=lhk                                                             
      call shkl(i,m6)                                                   
      if(i) 3220,3272,3272                                              
 3275 continue                                                          
      m=lgu                                                             
      call sggg(i,m6)                                                   
 3272 continue                                                          
      l=m+i*nghw                                                        
      store(l+2)=store(l+2)+fm*e2                                       
      store(l+4)=store(l+4)+fm                                          
      go to 3220                                                        
 3300 continue                                                          
      if(iall) 3410,3430,3420                                           
 3410 continue                                                          
      do 3411 l=mnr1,mnr2,nnrw                                          
      store(l)=sqrt(store(l+4)*e2m/store(l+1))                          
 3411 continue                                                          
      go to 3450                                                        
 3420 continue                                                          
      c=sqrt(t*e2m/a)                                                   
      gmed=gmed/c                                                       
      go to 3450                                                        
 3430 continue                                                          
      if(iclp) 3431,3431,3435                                           
 3431 continue                                                          
      m=lhk                                                             
      m1=lhk1                                                           
      go to 3436                                                        
 3435 continue                                                          
      m=lgu                                                             
      m1=lgu1                                                           
 3436 continue                                                          
      j=1                                                               
      do 3441 l=m,m1,nghw                                               
      if(igroup) 3439,3439,3438                                         
 3438 continue                                                          
      if(igroup-j) 3437,3439,3437                                       
 3437 continue                                                          
      store(l)=1.0                                                      
      go to 3440                                                        
 3439 continue                                                          
      store(l)=sqrt(store(l+4)*e2m/store(l+2))                          
 3440 continue                                                          
      j=j+1                                                             
 3441 continue                                                          
 3450 continue                                                          
      l6 =l6a                                                           
      l6d=l6a                                                           
 3320 continue                                                          
      if(kfnr(in,vett)) 3400,3330,3330
 3330 continue                                                          
      ss=store(m6+7)
      if(iall) 3350,3370,3381                                           
 3350 continue                                                          
      s=sqrt(ss)                                                        
      n=jaddr(s,ss)                                                     
      l=mnr1+n*nnrw                                                     
      go to 3380                                                        
 3370 continue                                                          
      if(iclp) 3371,3371,3375                                           
 3371 continue                                                          
      m=lhk                                                             
      call shkl(i,m6)                                                   
      if(i) 3374,3376,3376                                              
 3374 continue                                                          
      c=1.0                                                             
      go to 3381                                                        
 3375 continue                                                          
      m=lgu                                                             
      call sggg(i,m6)                                                   
 3376 continue                                                          
      l=m+i*nghw                                                        
 3380 continue                                                          
      c=store(l)                                                        
 3381 continue                                                          
      vett(4)=vett(4)*c
 3390 continue                                                          
      call xslrx(in,vett)
      go to 3320                                                        
 3400 continue                                                          
      call xert                                                         
      return                                                            
      end                                                               
c                                                                       
code for secal
      subroutine secal(ino)
c--calculate the e's
c  ino = 0  calculate the e's
c        1  pick up the value from list 6
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/lst02/ic,il,g2,isys,ngen,l2,m2,md2,n2,l2s,m2s,md2s,n2s,
     2 l2t,m2t,md2t,n2t,l2p,m2p,md2p,n2p,l2i,m2i,md2i,n2i
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal
      common/ylimi/nfl,lfl,idummy(5)
      common/xunit/ncru,ncwu,ncpu,ncpt,itty,istat2,iabort,intty
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx
      common/worka/a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z
      common/workb/ja,jb,jc,jd,je,jf,jg,jh,ji,jj,jk,jl,jm,jn,
     2             jo,jp,jq,jr,js,jt,ju,jv,jw,jx,jy,jz
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)
      dimension inp(3)
c--
      iex0=0
      x=float(n2*(ic+1))
      if(n7f.le.0.or.n7f.gt.400) n7f=400
      if(n7d.le.0.or.n7d.gt.400) n7d=50
      if(q.gt.5.0.or.q.lt.1.2) q=1.2
      if(r.gt.1.0.or.r.le.0.0) r=0.2
      nxxa=0
      nxxc=0
c--calcola fnat
      s=0.
      a=sigma(3.0,s)
      b=sigma(2.0,s)
      c=a/(b**1.5)
      s3s2=c
c      if(iparz.eq.0) then
c		      n7p=n6p
c		      n7dk=n6dk
c		      l7p=nfl
c		      m=l7p
c		     do l=l6p,l6p+n6p-1
c		      store(m)=store(l)
c c		     m=m+1
c		     enddo
c		      iln=7
c		     call xxcln(iln)
c		      sys07=-1.0
c		      store(l7p+4)=sys07
c		      store(l7p+21)=c
c		      lxxb=l7p+n7p
c		      mdxxb=n7dk
c		      mxxb=lxxb
c		      nfl=lxxb+(n6+1)*mdxxb
c		      call xsac(106,1,lxxb,nfl-1)
c		      else
c		      store(l7p+22)=c
c		      endif
      l6 =l6a
      l6d=l6a
      jg=0
      if(istat2.lt.2) jg=-1
      r0=r
3000  continue
      if(kfnr(in,vett)) 3110,3010,3010
 3010 continue
c      if(iparz.eq.0) then
c		      l=mxxb
c		     do i=m6dk,m6dk+n6dk-1
c		      store(l)=store(i)
c		     l=l+1
c		     enddo
c		      store(mxxb+2)=0.0
c		      store(mxxb+3)=0.0
c		      endif
      if(ino.eq.0) goto 3005
c      store(mxxb+1)= vett(4)
      goto 3105
3005  ss=store(m6+7)
      s=sqrt(ss)
      if(ikb) 3030,3040,3030
 3030 continue
      n=jaddr(s,ss)
      if(n) 3033,3033,3034
 3033 continue
      n=n+1
      go to 3032
 3034 continue
      i=n1m-n
      if(i-2) 3031,3031,3032
 3031 continue
      n=n1m-3
 3032 continue
      l=mlr+n*nlrw
c--3  point interpolation in k(s) curve
c  j  address in store
c  ss (sin(t/l))**2
c
      a=ss-store(l-3)
      bb=ss-store(l  )
      c=ss-store(l+3)
      d=store(l-3)-store(l  )
      e=store(l-3)-store(l+3)
      f=store(l  )-store(l+3)
      rrr   =store(l-2)*bb*c/(d*e)-
     2       store(l+1)*a*c/(d*f)+
     3       store(l+4)*a*bb/(e*f)
      if(rrr) 3035,3035,3050
 3035 continue
      if(iex0-20) 3037,3037,3041
 3037 continue
      write(ncwu,3036) rrr,store(m6),store(m6+1),store(m6+2)
 3036 format(/,26h **** scale less than zero,e12.2,
     2 20h for the reflection,3f5.0,10x,23h scale set to zero ****)
 3041 continue
      iex0=iex0+1
      rrr=0.0
      go to 3050
 3040 continue
      rrr=exp(2.0*bmed*ss)/(gmed*gmed)
 3050 continue
      fi=x/smult(0)
      sig=sigm2(idby,s)
      if(iparz.eq.1) goto 3061
      e2=rrr*store(m6+3)*store(m6+3)/(fi*sig)
      e=sqrt(e2)
      if(e2-hg(3)) 3060,3070,3070
 3070 continue
      if(iex0-20) 3072,3072,3073
 3072 continue
      emx=sqrt(hg(3))
      write(ncwu,3071) emx,store(m6),store(m6+1),store(m6+2),e
 3071 format(/,20h **** e greater than,f7.2,20h for the reflections,
     2 3f5.0,f7.2,10x,19he, set to zero ****)
 3073 continue
      iex0=iex0+1
      e =0.0
 3060 continue
      if(r.ne.r0)write(ncwu,*)'r ,r0,nxxa,nxxc ',r,r0,nxxa,nxxc
      if(e.ge.q) nxxa=nxxa+1
      if(e.le.r) nxxc=nxxc+1
      vett(4)=e
c      store(m6+5)=e
c      store(mxxb+1)=e
c      store(mxxb+2)=store(m6+3)
      idum=store(m6+6)
      inp(1)=store(m6  )
      inp(2)=store(m6+1)
      inp(3)=store(m6+2)
      idum1=jphsp(inp)
      vett(8)=idum1
c      istore(mxxb+4)=idum1+idum*32
c--check if a print of the reflections is needed
      if(jg) 3100,3065,3075
c--partial structure
3061  continue
      e2=rrr*store(m6+4)*store(m6+4)/(fi*sig)
      e=sqrt(e2)
      fp=store(m6+5)*store(m6+5)/(fi*sig)
      e2p=fp*rrr*gmed*gmed
      ep=sqrt(e2p)
c      idum=e*1000
c      if(idum.gt.32767) idum=32767
c      idum1=ep*1000
c      if(idum1.gt.32767) idum1=32767
c      istore(m6+5)=idum1+idum*32768
c      p=istore(m6+6)/2**15
      vett(6)=e
      vett(7)=ep
      vett(8)=store(m6+6)
      if(jg) 3100,3065,3075
3065  continue
      write(ncwu,3066)
3066  format(1h1,6x,1hh,5x,1hk,5x,1hl,6x,4h/fo/,5x,4h /e/,
     2 5x,4h/ep/,4x,5hphase,7x,7hepsilon,2x,6hsigma2,
     3 5x,5h k(s),7x,7hsinth/l,7x,6hmultip,/)
      jg=57
3075  continue
      fm=smult(1)
      jg=jg-1
      write(ncwu,3076) store(m6),store(m6+1),store(m6+2),
     2 store(m6+3),e,ep,p,fi,sig,rrr,s,fm
3076  format(3x,3f6.0,f9.1,2f9.3,f9.1,f12.0,f10.1,
     2 f10.5,f14.5,f10.0)
 3100 continue
      call xslrx(in,vett)
3105  continue
c--	mxxb=mxxb+mdxxb
      go to 3000
c--end of reflection's reading
 3110 continue
      if(iex0) 3130,3130,3120
 3120 continue
      if(iex0-20) 3125,3125,3121
 3121 continue
      write(ncwu,3122)
 3122 format(/,' and so on ...')
 3125 continue
      write(ncwu,3126) iex0
 3126 format(/,i10,3x,22h reflection(s) changed)
 3130 continue
c--update preamble !
      nstr=min0(n7f,nxxa)
      nzro=min0(n7d,nxxc)
      if(ino.eq.0) call xert
      return
c-------------------------------------------
c      if(iparz.eq.1) return
c      l=mxxb
c      do 3140 i=m6dk,m6dk+n6dk-1
c      store(l)=store(i)
c3140  l=l+1
c      n7f=min0(n7f,nxxa)
c      n7d=min0(n7d,nxxc)
c      n=-2
c      call sortz(lxxb,n6,mdxxb,n)
c      ln=n7p+(n6+1)*n6dk
c      iln=7
c      call sowl(ln,iln,lsn,ld7p,lk,lm,lj)
c      store(l7p+2)=lsn
c      store(l7p+19)=n7f
c      store(l7p+20)=n7d
c      l7=ld7p+n7p
c      call yup(ld7p,l7p,n7p)
c      llw=ld7p+ln-1
c      call swlin(iln,lsn,ld7p,llw,n7p,ln)
c      ln=ln-n7p
c      call yup(l7,lxxb,ln)
c      call xdump
c      return
      end
c                                                                       
code for se21                                                           
      subroutine se21                                                   
c--output e*e-1                                                         
c--
      include 'li6com.inc'
c
      dimension vett(18),ivett(18)
      equivalence (ivett,vett)
c--
      common/xstax/hg(3),ha(4),sm,ds,fs,e2m,bmed,gmed
     1 ,lks,ls,mwl,lwl,mlr,llr,nlrw,lc,lc2,mr1,mr2                      
     2 ,mnr1,mnr2,nnrw,mrwa,lgu,lgu1,lhk,lhk1,nghw,iclp,igroup          
     3 ,iparz,ista,n1m,iuse,iem,ie21,idby,ikb,inor,iall,iscal                 
c                                                                       
      common/xcons/pi,twopis,twopi,rtd,dtr,xnx                          
c                                                                       
      common /xdata/ store(1000000)
      dimension istore(1000000)
      equivalence(store,istore)                                         
c--                                                                     
      call xfl06
c      store(l6rs+2)=xnx/(hg(3)-1)
3000  continue
      if(kfnr(in,vett)) 3110,3010,3010
3010  continue
c      e21=store(m6+5)*store(m6+5)-1
      e21=vett(4)*vett(4)-1
      vett(4)=abs(e21)
      vett(13)=0.0
c      store(m6+6)=0.0
      if(e21) 3030,3100,3100
3030  continue
c      store(m6+6)=pi
      vett(13)=pi
3100  continue
      call xslrx(in,vett)
      go to 3000
3110  continue
      call xert
      call xline
      return
      end
